
void ProcessDialogEvent()
{
	ref NPChar;
	aref Link, NextDiag;

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(NextDiag, NPChar.Dialog);

	int iResult;


	switch(Dialog.CurrentNode)
	{
		case "First time":
			if(CheckForQuestFree(npchar) == 1)
			{
				iResult = GenerateEscortQuest(npchar, 0, "", 0, rand(3), 0, 0);
				trace("iResult = " + iResult);
				if (iResult == 0)
				{
					dialog.text = "I'm looking for someone to escort me and my ship to " + XI_ConvertString("colony"+Quests[sti(npchar.currentquest)].l.target_colony) + ", located on the island of " + XI_ConvertString(colonies[FindColony(Quests[sti(npchar.currentquest)].l.target_colony)].island) +  ".\nI'll pay you " + FindRussianMoneyString(Quests[sti(npchar.CurrentQuest)].l.money)  + " piasters for the service. What do you say?";
					link.l1 = "It's a deal. I'll take the job.";
					link.l1.go = "escort_quest_accept";
					link.l2 = "I don't think I'm interested.";
					link.l2.go = "exit";
				}
				if(iResult == -1)
				{
					dialog.text = "Excuse me, I'm not in the mood to talk.";
					link.l1 = "All right.";
					link.l1.go = "exit";
					EraseQuestFreeState(npchar);
				}
				if(iResult == -2)
				{
					dialog.text = "Hey captain, your reputation stinks worse than the devil's own backside, I don't want anything to do with you.";
					link.l1 = "Suit yourself.";
					link.l1.go = "exit";
				}
				if(iResult == -3)
				{
					dialog.text = "Captain, I see you've got a full squadron. Too bad, I had an offer for you.";
					link.l1 = "We'll talk later then.";
					link.l1.go = "exit";
				}
			}
			else
			{
				dialog.text = "Excuse me, I'm not in the mood to talk.";
				link.l1 = "All right.";
				link.l1.go = "exit";
			}

			NextDiag.TempNode = "First time";
		break;

		case "escort_quest_accept":
			dialog.text = "Then it's a deal, captain? I've got one small condition though - we must deliver the cargo in " + FindRussianDaysString(Quests[sti(npchar.CurrentQuest)].l.time) + ".";
			link.l1 = "Yes, I understand that there can't be any delays.";
			link.l1.go = "exit";
			AcceptEscortQuest(npchar);
		break;

		case "SelectOffer":
			dialog.text = SelectEscortShipDialog(npchar);
			link.l1 = "Deal.";
			link.l1.go = "accept_offer_exit";
			link.l2 = "Not interested.";
			link.l2.go = "decline_offer_exit";
		break;

		case "accept_offer_exit":
			AcceptEscortQuest(npchar);
			//Cerez: Set back to default value/behaviour (fix for the empty dialog bug)
			NextDiag.TempNode = "First time";
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;

		case "decline_offer_exit":
			DeleteEscortQuest(npchar);
			//Cerez: Set back to default value/behaviour
			NextDiag.TempNode = "First time";
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;

		case "Exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;
	}
}
