
void ProcessDialogEvent()
{
	ref NPChar;
	aref Link, NextDiag;

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(NextDiag, NPChar.Dialog);

	switch(Dialog.CurrentNode)
	{
		case "First time":
			dialog.text = "Welcome to our church.";
			link.l1 = "I have a confession to make - I have sinned, father...";
			link.l1.go = "confess";
			link.l2 = "I would like to make a donation to the church, father.";
			link.l2.go = "donate";
			link.l3 = "Don't mind me, father - I am leaving.";
			link.l3.go = "exit";
			//link.l4 = "Sorry, wrong door.";
			//link.l4.go = "exit";

			NextDiag.TempNode = "First time";
		break;
		
		case "confess":
			dialog.text = "Is that so? Come, my child - the Lord always listens.";
			link.l1 = "Yes, father...";
			link.l1.go = "timepass";
			
			NextDiag.TempNode = "afterconfess";
		break;
		
		case "timepass":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
			LAi_Fade("", "");
			WaitDate("",0,0,0,0,20);
		break;
		
		case "afterconfess":
			dialog.text = RandPhrase("I can only hope you feel relieved, child. You carry a heavy burden. May the Lord watch over you on your troubled journey.", "Rest assured, you are loved beyond measure. Be at peace, my dear child. The Lord will watch over you on your troubled journey.", "Make sure the love of Christ guides your journey. Believe in the Lord's Grace, trust in His ways, and have no fear in your heart, my child - your path is that of His design.");
			link.l1 = "Thank you, father.";
			link.l1.go = "exit";
			
			NextDiag.TempNode = "First time";
		break;

		case "donate":
			dialog.text = "God smiles upon such noble and selfless deeds. How much would you like to donate, my child?";
			if(sti(pchar.money) >= 500)
			{
				link.l1 = "500 piasters.";
				link.l1.go = "donate500";
			}
			if(sti(pchar.money) >= 1000)
			{
				link.l2 = "1000 piasters.";
				link.l2.go = "donate1000";
			}
			if(sti(pchar.money) >= 5000)
			{
				link.l3 = "5000 piasters.";
				link.l3.go = "donate5000";
			}
			if(sti(pchar.money) >= 10000)
			{
				link.l4 = "10000 piasters.";
				link.l4.go = "donate10000";
			}
			link.l5 = "Erm... I think I'll donate some other time.";
			link.l5.go = "exit";
		break;

		case "donate500":
			dialog.text = "Thank you, my dear child. May God bless you!";
			link.l1 = "Thank you, father.";
			link.l1.go = "donateExit";
			npchar.donate = 500;
		break;

		case "donate1000":
			dialog.text = "Goodness gracious! Just the sum we need to finally replace that leaky, old roof! Bless you, my dear child!";
			link.l1 = "You're quite welcome, father. No thanks necessary.";
			link.l1.go = "donateExit";
			npchar.donate = 1000;
		break;

		case "donate5000":
			dialog.text = "Goodness gracious! Thank you, my child! May God bless you for having such a noble and generous heart!";
			link.l1 = "You're quite welcome, father. No thanks necessary.";
			link.l1.go = "donateExit";
			npchar.donate = 5000;
		break;

		case "donate10000":
			dialog.text = "Oh! Praise the Lord! I can't thank you enough, my child! May God bless you for having such a noble and generous heart!";
			link.l1 = "No, thank you, father.";
			link.l1.go = "donateExit";
			npchar.donate = 10000;
		break;

		case "donateExit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
			MakeDonate(npchar);
		break;

		case "Exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;
	}
}

//Cerez: Select a random line of text from a choice of 3
string RandPhrase(string txt1, string txt2, string txt3)
{
	switch(rand(2))
	{
		case 0:
			return txt1;
			break;
		case 1:
			return txt2;
			break;
		case 2:
			return txt3;
			break;
	}
}
