
void ProcessDialogEvent()
{
	int LoanSum, LoanInterest, LoanPeriod, LoanResult, iPastMonths, DepositSum, DepositInterest, DepositResult;
	ref NPChar;

	aref Link, NextDiag;
	string NPC_Area;
	string npcNat;

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(NextDiag, NPChar.Dialog);

	NPC_Area = Npchar.location;
	npcNat = GetNationNameByType(sti(npchar.nation));

	switch(Dialog.CurrentNode)
	{
		// -----------------------------------  -  
		case "LoanGranted_exit":
			NextDiag.CurrentNode = NextDiag.TempNode;

			AddMoneyToCharacter(Pchar, makeint(Pchar.Quest.Loans.(NPC_Area).Sum));
			Pchar.Quest.Loans.(NPC_Area) = true;
			Pchar.Quest.Loans.(NPC_Area).StartDay = getDataDay();
			Pchar.Quest.Loans.(NPC_Area).StartMonth = getDataMonth();
			Pchar.Quest.Loans.(NPC_Area).StartYear = getDataYear();
			Pchar.Quest.Loans.(NPC_Area).StartTime = getTime();
			Pchar.Quest.Loans.(NPC_Area).LoanNation = npcNat;
/*
			Pchar.quest.(NPC_Area).win_condition.l1 = "Timer";
			Pchar.quest.(NPC_Area).win_condition.l1.date.day = getDataDay();
			Pchar.quest.(NPC_Area).win_condition.l1.date.month = getDataMonth() + makeint(Pchar.Quest.Loans.(NPC_Area).Period);
			Pchar.quest.(NPC_Area).win_condition.l1.date.year = getDataYear();
			Pchar.quest.(NPC_Area).win_condition = "Loans_" + (NPC_Area);
*/
			DialogExit();

		break;

		case "Deposit_exit":
			NextDiag.CurrentNode = NextDiag.TempNode;

		//	DepositSum = -DepositSum;
			AddMoneyToCharacter(Pchar, -(makeint(Pchar.Quest.Deposits.(NPC_Area).Sum)));
			Pchar.Quest.Deposits.(NPC_Area) = true;
			Pchar.Quest.Deposits.(NPC_Area).StartDay = getDataDay();
			Pchar.Quest.Deposits.(NPC_Area).StartMonth = getDataMonth();
			Pchar.Quest.Deposits.(NPC_Area).StartYear = getDataYear();
			Pchar.Quest.Deposits.(NPC_Area).StartTime = getTime();
			DialogExit();
		break;

		case "exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
			DeleteAttribute(Pchar, "quest.Loans." + (NPC_Area));
			DeleteAttribute(Pchar, "quest.Deposits." + (NPC_Area));
		break;

		case "exit_NoChange":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;

		case "First time":
			NextDiag.TempNode = "First time";
			if(NPChar.quest.meeting == "0")
			{
				NPChar.quest.meeting = 1;
				dialog.text = RandPhrase("Welcome, " + colAddress(npcNat) + ", how may I help you?", "Glad to see you, " + colAddress(npcNat) + ". Do you require my services?", "Hello, " + colAddress(npcNat) + ". I'm afraid I haven't had the pleasure of meeting you...");
				Link.l1 = RandPhrase("My name is " + Pchar.name + " " + Pchar.lastname + ". I'm captain of the '" + pchar.ship.name + "'.", "Captain " + Pchar.name + " " + Pchar.lastname + ", at your service.", "I'm captain " + PChar.name + " " + Pchar.lastname + ".");
				Link.l1.go = "meeting";
			}
			else
			{
					dialog.text = RandPhrase("Glad to see you, captain " + Pchar.lastname + ". If you need my services, feel free to ask.", "Welcome, captain. Do you need something?", "Hello, captain " + Pchar.lastname + ". What can I do for you? I can perform any financial operation.");
					Link.l1 = RandPhrase("I'd like to borrow from you.", "I urgently need a few piasters.", "How about a small loan?");
					Link.l1.go = "loan";
					if(makeint(Pchar.money) >= 100)
					{
						Link.l2 = RandPhrase("I'd like to lend gold on interest.", "Will you take my booty to store safely?", "Can I deposit some gold here?");
						Link.l2.go = "deposit";
					}
					Link.l3 = "Goodbye.";
					Link.l3.go = "exit_NoChange";

				if(CheckAttribute(Pchar, "Quest.Loans." + (NPC_Area)) && makeint(Pchar.Quest.Loans.(NPC_Area)) == true)
				{
					iPastMonths = GetPastTime("Month", makeint(Pchar.Quest.Loans.(NPC_Area).StartYear),makeint(Pchar.Quest.Loans.(NPC_Area).StartMonth),makeint(Pchar.Quest.Loans.(NPC_Area).StartDay), makefloat(Pchar.Quest.Loans.(NPC_Area).StartTime), getDataYear(),getDataMonth(),GetDataDay(), GetTime());
					Pchar.Quest.Loans.(NPC_Area).Result = makeint(Pchar.Quest.Loans.(NPC_Area).Sum) + ((makeint(Pchar.Quest.Loans.(NPC_Area).Sum)/100)*makeint(Pchar.Quest.Loans.(NPC_Area).Interest))*iPastMonths;

					dialog.text = RandPhrase("Welcome, captain " + Pchar.lastname + ". Have you come to repay me? You owe me " + Pchar.Quest.Loans.(NPC_Area).Result + " piasters.", "Hello, captain. Glad to see you in good health. Are you ready to return the " + Pchar.Quest.Loans.(NPC_Area).Result + " piasters you've borrowed from me? That's interest included.", "Greetings, " + colAddress(npcNat) + ". I hope your voyage was profitable, and that you brought me my funds. You owe me " + Pchar.Quest.Loans.(NPC_Area).Result + " piasters, interest included.");
					if(makeint(PChar.money) >= makeint(Pchar.Quest.Loans.(NPC_Area).Result))
					{
						Link.l1 = RandPhrase("I can pay off my loan now.", "I'm able to pay off my loan.", "It's time to pay off my loan.");
						Link.l1.go = "loan_return";
					}
					Link.l2 = RandPhrase("I'm afraid I can't do that yet.", "Next time, " + NPChar.name + ".", "Alas, no. I'll be back when I have the gold.");
					Link.l2.go = "Loan_Remind";

				}
				if(CheckAttribute(Pchar, "Quest.Loans." + (NPC_Area)) && makeint(Pchar.Quest.Loans.(NPC_Area)) == false)
				{
					npchar.greeting = "";
					dialog.text = RandPhrase("Well-well-well! Now you decide to show your face! After I've even had to contact the authorities to look for you... You have no idea how much I've lost because of you! You're no longer welcome in this establishment, captain. Please leave immediately, and don't set your foot in this door ever again.", "You dare show your face here now?! After my business has suffered, and I've had to rouse the entire town to just find your whereabouts?! Please leave, and don't come back here ever again, captain.", "Well-well, look who it is! Have you any idea how much my business has lost because of you?! You're not welcome here anymore, captain. Please leave before I call the guards in.");
					Link.l1 = "I was on my way to returning the gold, I swear... I just got caught up in-";
					Link.l1.go = "Not_good_enough";
					Link.l2 = "I'm flattered by all the attention, but do you think we could get back to business, now?");
					Link.l2.go = "Get_out";
					Link.l3 = "That's too bad... Farewell.";
					Link.l3.go = "exit_NoChange";
					
					NextDiag.TempNode = "Dead_end";
				}
				if(CheckAttribute(Pchar, "Quest.Deposits." + (NPC_Area)) && makeint(Pchar.Quest.Deposits.(NPC_Area)) == true)
				{
					iPastMonths = GetPastTime("Month", makeint(Pchar.Quest.Deposits.(NPC_Area).StartYear),makeint(Pchar.Quest.Deposits.(NPC_Area).StartMonth),makeint(Pchar.Quest.Deposits.(NPC_Area).StartDay), makefloat(Pchar.Quest.Deposits.(NPC_Area).StartTime), getDataYear(),getDataMonth(),GetDataDay(), GetTime());
					Pchar.Quest.Deposits.(NPC_Area).Result = makeint(Pchar.Quest.Deposits.(NPC_Area).Sum) + ((makeint(Pchar.Quest.Deposits.(NPC_Area).Sum)/100)*makeint(Pchar.Quest.Deposits.(NPC_Area).Interest))*iPastMonths;
					dialog.text = RandPhrase("Glad to see you, captain " + Pchar.lastname + ". If you need my services, feel free to ask.", "Captain " + Pchar.lastname + ", do you need something?", "Hello, " + colAddress(npcNat) + ". What can I do for you? I can perform any financial operation.");
					Link.l1 = RandPhrase("I'd like to withdraw my investments.", "It's time to withdraw the gold I've deposited.", "I want my gold and the accumulated interest.");
					Link.l1.go = "Deposit_return";
					Link.l2 = "No need to trouble yourself. I'll be back for my funds later.";
					Link.l2.go = "exit_NoChange";
				}
			}
		break;

		case "Meeting":
			dialog.text = RandPhrase("Pleased to meet you. I'm " + NPChar.name + " " + NPChar.lastname + ". My business is loaning funds.", "My name is " + NPChar.name + " " + NPChar.lastname + ". I'm the local loan officer. If you suddenly find yourself in need of funds, I'll be glad to help.", "I'm sure you already know that my name is " + NPChar.name + " " + NPChar.lastname + ". I'm quite well-known around here... Anyway, let's get to business - are you in need of my services?");
			Link.l1 = RandPhrase("I'd like to borrow from you.", "I urgently need a few piasters.", "How about a small loan?");
			Link.l1.go = "loan";
			if(makeint(Pchar.money) >= 100)
			{
				Link.l2 = RandPhrase("I'd like to lend gold on interest.", "Will you take my booty to store safely?", "Can I deposit some gold here?");
				Link.l2.go = "deposit";
			}
			Link.l3 = "Goodbye.";
			Link.l3.go = "exit";
		break;

		case "loan":
			dialog.text = "Oh, of course. How much do you need?";
			Link.l1 = "Not much, really.";
			Link.l1.go = "Small";
			Link.l2 = "Quite a sum.";
			Link.l2.go = "Medium";
			Link.l3 = "The more, the merrier.";
			Link.l3.go = "Large";
		break;

		case "small":
			Pchar.Quest.Loans.(NPC_Area).Sum = 500*makeint(Pchar.rank);
			dialog.text = "Good. It's always easier with smaller sums - less risk to take that way. I can offer you " + Pchar.Quest.loans.(NPC_Area).sum + " piasters...";
			Link.l1 = "Deal. At what interest?";
			Link.l1.go = "Interest";
			Link.l2 = "No, that won't do. Let's change the sum.";
			Link.l2.go = "Loan";
			Link.l3 = "I think I'd better not get into debt. Goodbye.";
			Link.l3.go = "Exit";
		break;

		case "Medium":
			Pchar.Quest.Loans.(NPC_Area).Sum = 1500*makeint(Pchar.rank);
			dialog.text = "Not to worry. I believe that " + Pchar.Quest.Loans.(NPC_Area).sum + " piasters will help solve your problems. It's quite a large sum.";
			Link.l1 = "Deal. At what interest?";
			Link.l1.go = "Interest";
			Link.l2 = "No, that won't do. Let's change the sum.";
			Link.l2.go = "Loan";
			Link.l3 = "I think I'd better not get into debt. Goodbye.";
			Link.l3.go = "Exit";
		break;

		case "Large":
			Pchar.Quest.Loans.(NPC_Area).Sum = 3000*makeint(Pchar.rank);
			dialog.text = "Hmm... Risky... but all right. I'll give you " + Pchar.Quest.Loans.(NPC_Area).sum + ". As you understand, captain, this is a considerable sum. I ask that you take this business seriously.";
			Link.l1 = "Deal. At what interest?";
			Link.l1.go = "Interest";
			Link.l2 = "No, that won't do. Let's change the sum.";
			Link.l2.go = "Loan";
			Link.l3 = "I think I'd better not get into debt. Goodbye.";
			Link.l3.go = "Exit";
		break;

		case "Interest":
			Pchar.Quest.Loans.(NPC_Area).Interest = 11 - makeint(Pchar.skill.commerce);
			dialog.text = "At an interest rate of " + Pchar.Quest.Loans.(NPC_Area).Interest + " percent for each month of holding. Based on what I know about you, I can't offer you anything better right now.";
			Link.l1 = "It'll do. Now, about the terms...";
			Link.l1.go = "Period";
			Link.l3 = "I think I'd better not get into debt. Goodbye.";
			Link.l3.go = "Exit";
		break;

		case "Period":
			Pchar.Quest.Loans.(NPC_Area).Period = makeint(makeint(Pchar.reputation)/20) + 1;
			dialog.text =  "Taking into account what I've heard about you so far, captain " + Pchar.lastname + ", I'm willing to give you leniency to pay off this debt within " + monthPhrase(Pchar.Quest.Loans.(NPC_Area).Period) + ". After that, you understand, I will be forced to take measures.";
			Link.l1 = "I accept your conditions... and your gold.";
			Link.l1.go = "LoanGranted";
			Link.l3 = "Alas, there's no deal. Goodbye.";
			Link.l3.go = "Exit";
		break;

		case "LoanGranted":
			dialog.text = "Good. But, as I hand this sum over, allow me to warn you, I've been in this business for many years, and I have effective means of reacquiring my lost funds. So if you had any ideas about running off with this sum, with no intention of returning it to our agreement, it would be wise for you to reconsider. I say this only as a general warning - not to offend, captain.";
			Link.l1 = "I see... Well, goodbye...";
			Link.l1.go = "LoanGranted_exit";
		break;

		case "Loan_Remind":
			dialog.text = "Well, all right... The interest is accumulating, and you don't have too much time left-";
			Link.l1 = "Don't worry, I'll get it back to you. Goodbye.";
			Link.l1.go = "exit_NoChange";
		break;

		case "loan_return":
			addMoneyToCharacter(Pchar, -(makeint(Pchar.Quest.Loans.(NPC_Area).Result)));
			DeleteAttribute(PChar, "quest.loans." + (NPC_Area));
			Pchar.quest.(NPC_Area).over = "Yes";
			dialog.text = RandPhrase("Oh, wonderful! Anytime you need funds - don't hesitate to come to me.", "Thank you. It's nice to do business with an honourable person, who values a deal and fulfills their end in a bargain. Honesty's so rare to find these days...",  "Oh, I'm so glad I haven't made a mistake in trusting you, " + colAddress(npcNat) + "! I hope you will be using my services in the future!");
			Link.l1 = RandPhrase("I'd like to borrow from you.", "I urgently need a few piasters.", "How about a small loan?");
			Link.l1.go = "loan";
			if(makeint(PChar.money) >= 100)
			{
				Link.l2 = RandPhrase("I'd like to lend gold on interest.", "Will you take my booty to store safely?", "Can I deposit some gold here?");
				Link.l2.go = "deposit";
			}
			Link.l3 = "Goodbye.";
			Link.l3.go = "exit";
		break;

		case "deposit":
			dialog.text = RandPhrase("Ah, a sensible choice! What sum would you like to deposit?", "Good. Trust me, the funds you deposit will be quite safe with me, and even generate interest... How much of your funds would you like to deposit?", "Ah, I see you know how to put your gold to good use! How much would you like to deposit?");
			Link.l1 = "A quarter of my booty - " + makeint(makeint(PChar.money)/40)*10 + " piasters.";
			Link.l1.go = "quarter";
			Link.l2 = "A half of my funds - " + makeint(makeint(PChar.money)/20)*10 + " piasters.";
			Link.l2.go = "half";
			Link.l3 = "Everything I have - " + makeint(makeint(PChar.money)/10)*10 + " piasters.";
			Link.l3.go = "All";
		break;

		case "quarter":
			Pchar.Quest.Deposits.(NPC_Area).Interest = makeint(Pchar.skill.commerce) + 1;
			Pchar.Quest.Deposits.(NPC_Area).Sum = makeint(makeint(PChar.money)/40)*10;
			dialog.text = RandPhrase("All right. I can offer you, say... an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent. Per month, of course.", "All right. I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent for each month your gold stays here.", "I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent - to be added to this sum for each monthly duration your funds stay with us.");
			Link.l1 = "Fine with me.";
			Link.l1.go = "Deposit_placed";
			Link.l2 = "I think I'll change the sum.";
			Link.l2.go = "Deposit";
			Link.l3 = "I don't think I should part with my gold right now. Farewell.";
			Link.l3.go = "Exit";
		break;

		case "half":
			Pchar.Quest.Deposits.(NPC_Area).Interest = makeint(Pchar.skill.commerce) + 2;
			Pchar.Quest.Deposits.(NPC_Area).Sum = makeint(makeint(PChar.money)/20)*10;
			dialog.text = RandPhrase("All right. I can offer you, say... an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent. Per month, of course.", "All right. I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent for each month your gold stays here.", "I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent - to be added to this sum for each monthly duration your funds stay with us.");
			Link.l1 = "Fine with me.";
			Link.l1.go = "Deposit_placed";
			Link.l2 = "I think I'll change the sum.";
			Link.l2.go = "Deposit";
			Link.l3 = "I don't think I should part with my gold right now. Farewell.";
			Link.l3.go = "Exit";
		break;

		case "All":
			Pchar.Quest.Deposits.(NPC_Area).Interest = makeint(Pchar.skill.commerce) + 3;
			Pchar.Quest.Deposits.(NPC_Area).Sum = makeint(makeint(PChar.money)/10)*10;
			dialog.text = RandPhrase("All right. I can offer you, say... an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent. Per month, of course.", "All right. I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent for each month your gold stays here.", "I can offer you an interest rate of " + Pchar.Quest.Deposits.(NPC_Area).Interest + " percent - to be added to this sum for each monthly duration your funds stay with us.");
			Link.l1 = "Fine with me.";
			Link.l1.go = "Deposit_placed";
			Link.l2 = "I think I'll change the sum.";
			Link.l2.go = "Deposit";
			Link.l3 = "I don't think I should part with my gold right now. Farewell.";
			Link.l3.go = "Exit";
		break;

		case "Deposit_placed":
			dialog.text = "Now you can be sure that even the fiercest storm won't leave you broke. If you decide to withdraw your deposit, you can do so anytime.";
			Link.l1 = "Good. Farewell.";
			Link.l1.go = "Deposit_Exit";
		break;

		case "Deposit_return":
			dialog.text = "Counting in the interest we've agreed upon in the time that has passed, it seems that I owe you " + Pchar.Quest.Deposits.(NPC_Area).Result + " piasters... Are you sure you want to withdraw these funds now?";
			Link.l1 = "Absolutely. Let's see them.";
			Link.l1.go = "Deposit_return_1";
			Link.l2 = "You know, you're right. I think I'll leave them with you for a while longer. Goodbye.";
			Link.l2.go = "Exit_noChange";
		break;

		case "Deposit_return_1":
			addMoneyToCharacter(Pchar, makeint(Pchar.Quest.Deposits.(NPC_Area).Result));
			DeleteAttribute(PChar,"quest.deposits." + (NPC_Area));
			dialog.text = "Heh... I feel sorry to part with this gold... I've grown so accustomed to having it around... Oh well, come again.";
			Link.l1 = "If I ever need your services again, I will. Farewell.";
			Link.l1.go = "Exit";
		break;
		
		case "Not_good_enough":
			dialog.text = "I'm afraid that's not good enough, captain. The door is that way.";
			Link.l1 = "Fine...";
			Link.l1.go = "exit_NoChange";
		break;
		
		case "Get_out":
			dialog.text = "Get out of my establishment! And never show your face in here again.";
			Link.l1 = "...";
			Link.l1.go = "exit_NoChange";
		break;
		
		case "Dead_end":
			dialog.text = "I thought I made myself clear - you are not welcome in this establishment, captain. Please leave before I am forced to call the guards to escort you out.";
			Link.l1 = "Fine.";
			Link.l1.go = "exit_NoChange";
		break;
	}
}

//Cerez: Select a random line of text from a choice of 3
string RandPhrase(string txt1, string txt2, string txt3)
{
	switch(rand(2))
	{
		case 0:
			return txt1;
			break;
		case 1:
			return txt2;
			break;
		case 2:
			return txt3;
			break;
	}
}

//Cerez: Loan term month phrasing
string monthPhrase(int monthNum)
{
	if(monthNum > 1)
	{
		return monthNum + " months";
	}
	else
	{
		return "a month";
	}
}

//Cerez: Address player character in dialogue based on colony's native language
string colAddress(string curNat)
{
	switch(curNat)
	{
		case "Spain":
			return address_form.spa;
			break;
		case "France":
			return address_form.fra;
			break;
		case "England":
			return address_form.eng;
			break;
		case "Holland":
			return address_form.hol;
			break;
		case "Portugal":
			return address_form.por;
			break;
		//Commented out because for some reason (unknown to me) the compiler has issues with the default statement
		/*
		default:
			return "captain";
		*/
	}
}
