
int LocationInitGuadeloupe(int n)
{	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_town";
	locations[n].id.label = "Guadeloupe";
	locations[n].worldmap = "Guadeloupe";
	locations[n].filespath.models = "locations\Town_Guadeloupe\Town\";
	
	locations[n].image = "loading\Town_512.tga";
	locations[n].citizens = true;
	locations[n].soldiers = true;

	//Town sack
	locations[n].townsack = "Guadeloupe";

	//Sound
	locations[n].type = "town";
	locations[n].fastreload = "Guadeloupe";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always

	locations[n].models.always.town = "Guadeloupe";
	
	locations[n].models.always.L1 = "Guadeloupe_signsA";
	Locations[n].models.always.seabed = "Guadeloupe_sb";
	locations[n].models.always.grassPatch = "Guadeloupe_grass";
	locations[n].models.always.locators = "Guadeloupe_locators";
	
	
	//Day
	locations[n].models.day.fonar = "Guadeloupe_fd";
	locations[n].models.day.rinok = "Guadeloupe_rinok";
	locations[n].models.day.charactersPatch = "Guadeloupe_patch_day";
	
	//Night
	locations[n].models.night.fonar = "Guadeloupe_fn";
	locations[n].models.night.charactersPatch = "Guadeloupe_patch_night";
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map

	locations[n].reload.l0.name = "reload1";
	locations[n].reload.l0.go = "Guadeloupe";
	locations[n].reload.l0.emerge = "reload_1";
	locations[n].reload.l0.autoreload = "0";
	locations[n].reload.l0.label = "";
	locations[n].locators_radius.reload.reload1 = 0.2;

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Sea";
	locations[n].locators_radius.reload.reload1_back = 1.8;

	locations[n].reload.l2.name = "reload2_back";
	locations[n].reload.l2.go = "Guadeloupe";
	locations[n].reload.l2.emerge = "reload_1";
	locations[n].reload.l2.autoreload = "0";
	locations[n].reload.l2.label = "Sea";
	locations[n].locators_radius.reload.reload2_back = 1.8;

	locations[n].reload.l3.name = "reload3_back";
	locations[n].reload.l3.go = "Guadeloupe_townhall";
	locations[n].reload.l3.emerge = "reload1";
	locations[n].reload.l3.autoreload = "0";
	locations[n].reload.l3.label = "Residence";
	Locations[n].reload.l3.close_for_night = 1;

	locations[n].reload.l4.name = "reload4_back";
	locations[n].reload.l4.go = "Guadeloupe_tavern";
	locations[n].reload.l4.emerge = "reload1";
	locations[n].reload.l4.autoreload = "0";
	locations[n].reload.l4.label = "Tavern";

	locations[n].reload.l5.name = "reload5_back";
	locations[n].reload.l5.go = "Guadeloupe_shipyard";
	locations[n].reload.l5.emerge = "reload1";
	locations[n].reload.l5.autoreload = "0";
	locations[n].reload.l5.label = "Shipyard";
	Locations[n].reload.l5.close_for_night = 1;

	locations[n].reload.l6.name = "reload6_back";
	locations[n].reload.l6.go = "Guadeloupe_store";
	locations[n].reload.l6.emerge = "reload1";
	locations[n].reload.l6.autoreload = "0";
	locations[n].reload.l6.label = "Store";
	Locations[n].reload.l6.close_for_night = 1;

	locations[n].reload.l7.name = "reload7_back";
	locations[n].reload.l7.go = "Guadeloupe_church";
	locations[n].reload.l7.emerge = "reload1";
	locations[n].reload.l7.autoreload = "0";
	locations[n].reload.l7.label = "Church";
	Locations[n].reload.l7.close_for_night = 1;
	Locations[n].reload.l7.disable = 1;

	n = n + 1;

    
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_tavern";
	locations[n].id.label = "Guadeloupe tavern";
	locations[n].filespath.models = "locations\inside\Tavern04\";
	locations[n].image = "loading\Tavern_512.tga";
	locations[n].habitues = 1;
	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "tavern";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].models.always.tavern = "Tavern04";
	locations[n].models.always.locators = "Tavern04_locators";
	locations[n].models.always.window = "tavern04_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern04_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern04_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_town";
	locations[n].reload.l1.emerge = "reload4";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Guadeloupe";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_tavern_upstairs";
	locations[n].id.label = "Guadeloupe Tavern upstairs";
	locations[n].image = "loading\Tavern_512.tga";

	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Tavern_room";
	locations[n].models.always.locators = "Tavern_room_locators";
	locations[n].models.always.tavern = "Tavern_room";
	locations[n].models.always.window = "tavern_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_tavern";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Tavern";
	locations[n].locators_radius.reload.reload1 = 0.8;
	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_store";
	locations[n].id.label = "Guadeloupe store";
	locations[n].filespath.models = "locations\inside\Store02\";
	locations[n].image = "loading\Shop_512.tga";

	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shop";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].models.always.locators = "Store02_locators";
	locations[n].models.always.store = "Store02";
	locations[n].models.always.window = "Store02_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Store02_patch";

	//Night
	locations[n].models.night.charactersPatch = "Store02_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_town";
	locations[n].reload.l1.emerge = "reload6";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Guadeloupe";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	
 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_Shipyard";
	locations[n].id.label = "Guadeloupe shipyard";
	locations[n].filespath.models = "locations\inside\Shipyard01\";
	locations[n].image = "loading\Shipyard_512.tga";

	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shipyard";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].models.always.locators = "Shipyard01_locators";
	locations[n].models.always.shipyard = "Shipyard01";
	//Day
	locations[n].models.day.charactersPatch = "Shipyard01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Shipyard01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_town";
	locations[n].reload.l1.emerge = "reload5";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Guadeloupe";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_townhall";
	locations[n].id.label = "Guadeloupe townhall";
	locations[n].filespath.models = "locations\inside\Residence04";
	locations[n].image = "loading\Rezidence_512.tga";

	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "residence";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].models.always.locators = "Residence04_locators";
	locations[n].models.always.l1 = "Residence04";
	locations[n].models.always.window = "residence04_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	
	locations[n].models.always.back = "..\inside_back";
	
	//Day
	locations[n].models.day.charactersPatch = "Residence04_patch";
	
	//Night
	locations[n].models.night.charactersPatch = "Residence04_patch";
	
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_town";
	locations[n].reload.l1.emerge = "reload3";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Guadeloupe";
	LAi_LocationFightDisable(&locations[n], true);

	locations[n].locators_radius.reload.dialog_event = 0.2;
	locations[n].locators_radius.camdetector.dialog_event = 2.2;

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Guadeloupe_church";
	locations[n].id.label = "Guadeloupe Church";
	locations[n].image = "loading\Church_512.tga";

	//Town sack
	locations[n].townsack = "Guadeloupe";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "church";
	locations[n].fastreload = "Guadeloupe";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Church01";

	locations[n].models.always.locators = "Church01_locators";
	locations[n].models.always.tavern = "Church01";
	locations[n].models.always.window = "church01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Church01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Church01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Guadeloupe_town";
	locations[n].reload.l1.emerge = "reload7";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Guadeloupe";
	LAi_LocationFightDisable(&locations[n], true);
	
	n = n + 1;

	return n;
}