
int LocationInitMartinique(int n)
{	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_town";
	locations[n].id.label = "Martinique";
	locations[n].worldmap = "Martinique";
	locations[n].filespath.models = "locations\Town_Martinique\Town\";
	locations[n].image = "loading\Town_512.tga";
	locations[n].citizens = true;
	locations[n].soldiers = true;
	
	//Town sack
	locations[n].townsack = "Martinique";

	//Sound
	locations[n].type = "town";
	locations[n].fastreload = "Martinique";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	locations[n].models.always.town = "Martinique";
	locations[n].models.always.L1 = "Martinique_signsA";
	Locations[n].models.always.seabed = "Martinique_sb";
	locations[n].models.always.locators = "Martinique_locators";
	locations[n].models.always.grassPatch = "Martinique_grass";
	
	locations[n].models.always.plan = "plan1";
	locations[n].models.always.plan.level = 9;

	//Fontain
	Locations[n].models.always.Waterfall1 = "fontain1";
	Locations[n].models.always.Waterfall1.uvslide.v0 = 0.5;
        Locations[n].models.always.Waterfall1.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall1.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall1.level = 50;
	
	Locations[n].models.always.Waterfall2 = "fontain2";
	Locations[n].models.always.Waterfall2.uvslide.v0 = 0.2;
        Locations[n].models.always.Waterfall2.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall2.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall2.level = 49;

	//Day
	locations[n].models.day.fonar = "Martinique_fd";
	locations[n].models.day.charactersPatch = "Martinique_patch_day";
	locations[n].models.day.rinok = "Martinique_rinok";
	//Night
	locations[n].models.night.fonar = "Martinique_fn";
	locations[n].models.night.charactersPatch = "Martinique_patch_night";
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	locations[n].locators_radius.reload.reload2_back = 1.8;

	locations[n].reload.l2.name = "reload2_back";
	locations[n].reload.l2.go = "Martinique";
	locations[n].reload.l2.emerge = "reload_1";
	locations[n].reload.l2.autoreload = "0";
	locations[n].reload.l2.label = "Sea";
	locations[n].locators_radius.reload.reload2_back = 1.8;

	locations[n].reload.l3.name = "reload3_back";
	locations[n].reload.l3.go = "Martinique_townhall";
	locations[n].reload.l3.emerge = "reload1";
	locations[n].reload.l3.autoreload = "0";
	locations[n].reload.l3.label = "Residence";
	Locations[n].reload.l3.close_for_night = 1;

	locations[n].reload.l4.name = "reload4_back";
	locations[n].reload.l4.go = "Martinique_tavern";
	locations[n].reload.l4.emerge = "reload1";
	locations[n].reload.l4.autoreload = "0";
	locations[n].reload.l4.label = "Tavern";

	locations[n].reload.l5.name = "reload5_back";
	locations[n].reload.l5.go = "Martinique_shipyard";
	locations[n].reload.l5.emerge = "reload1";
	locations[n].reload.l5.autoreload = "0";
	locations[n].reload.l5.label = "Shipyard";
	Locations[n].reload.l5.close_for_night = 1;

	locations[n].reload.l6.name = "reload6_back";
	locations[n].reload.l6.go = "Martinique_store";
	locations[n].reload.l6.emerge = "reload1";
	locations[n].reload.l6.autoreload = "0";
	locations[n].reload.l6.label = "Store";
	Locations[n].reload.l6.close_for_night = 1;

	locations[n].reload.l7.name = "reload7_back";
	locations[n].reload.l7.go = "Martinique_church";
	locations[n].reload.l7.emerge = "reload1";
	locations[n].reload.l7.autoreload = "0";
	locations[n].reload.l7.label = "Church";
	Locations[n].reload.l7.close_for_night = 1;
	//Locations[n].reload.l7.disable = 1;

	locations[n].reload.l8.name = "reload8_back";
	locations[n].reload.l8.go = "Martinique_bank";
	locations[n].reload.l8.emerge = "reload1";
	locations[n].reload.l8.autoreload = "0";
	locations[n].reload.l8.label = "Bank";
	//locations[n].reload.l8.disable = 1;
	Locations[n].reload.l8.close_for_night = 1;
/*
	locations[n].reload.l9.name = "reload9_back";
	locations[n].reload.l9.go = "Martinique_brothel";
	locations[n].reload.l9.emerge = "reload1";
	locations[n].reload.l9.autoreload = "0";
	locations[n].reload.l9.label = "Brothel";
	Locations[n].reload.l9.disable = 1;
*/
	n = n + 1;

  	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_tavern";
	locations[n].id.label = "Martinique tavern";
	locations[n].filespath.models = "locations\inside\Tavern01\";
	locations[n].image = "loading\Tavern_512.tga";
	locations[n].habitues = 1;
	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "tavern";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.tavern = "Tavern01";
	locations[n].models.always.locators = "Tavern01_locators";
	locations[n].models.always.window = "tavern01_windows";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload4";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_tavern_upstairs";
	locations[n].id.label = "Martinique Tavern upstairs";
	locations[n].image = "loading\Tavern_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Tavern_room";
	locations[n].models.always.locators = "Tavern_room_locators";
	locations[n].models.always.tavern = "Tavern_room";
	locations[n].models.always.window = "tavern_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_tavern";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Tavern";
	locations[n].locators_radius.reload.reload1 = 0.8;
	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_store";
	locations[n].id.label = "Martinique store";
	locations[n].filespath.models = "locations\inside\Store01\";
	locations[n].image = "loading\Shop_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shop";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.locators = "Store01_locators";
	locations[n].models.always.store = "Store01";
	locations[n].models.always.window = "Store01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Store01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Store01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload6";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_Bank";
	locations[n].id.label = "Martinique Bank";
	locations[n].filespath.models = "locations\inside\bank01\";
	locations[n].image = "loading\Bank_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.locators = "bank01_locators";
	locations[n].models.always.store = "bank01";
	locations[n].models.always.window = "bank01_windows";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "bank01_patch";

	//Night
	locations[n].models.night.charactersPatch = "bank01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload8";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_Brothel";
	locations[n].id.label = "Brothel";
	locations[n].filespath.models = "locations\inside\Brothel\";
	locations[n].image = "loading\Brothel_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.locators = "Brothel_locators";
	locations[n].models.always.store = "Brothel";
	locations[n].models.always.window = "brothel_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Brothel_patch";

	//Night
	locations[n].models.night.charactersPatch = "Brothel_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload9";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;


 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_Shipyard";
	locations[n].id.label = "Martinique shipyard";
	locations[n].filespath.models = "locations\inside\Shipyard01\";
	locations[n].image = "loading\Shipyard_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shipyard";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.locators = "Shipyard01_locators";
	locations[n].models.always.shipyard = "Shipyard01";
	locations[n].models.always.window = "shipyard01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Shipyard01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Shipyard01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload5";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_townhall";
	locations[n].id.label = "Martinique townhall";
	locations[n].filespath.models = "locations\inside\Residence01";
	locations[n].image = "loading\Rezidence_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "residence";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].models.always.locators = "Residence01_locators";
	locations[n].models.always.l1 = "Residence01";
	locations[n].models.always.window = "residence01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Residence01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Residence01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload3";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);

	//locations[n].locators_radius.reload.dialog_event = 0.2;
	//locations[n].locators_radius.camdetector.dialog_event = 2.2;

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Martinique_church";
	locations[n].id.label = "Martinique Church";
	locations[n].image = "loading\Church_512.tga";

	//Town sack
	locations[n].townsack = "Martinique";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "church";
	locations[n].fastreload = "Martinique";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Church01";
	locations[n].models.always.locators = "Church01_locators";
	locations[n].models.always.tavern = "Church01";
	locations[n].models.always.window = "Church01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Church01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Church01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Martinique_town";
	locations[n].reload.l1.emerge = "reload7";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Martinique";
	LAi_LocationFightDisable(&locations[n], true);
	
	n = n + 1;

	return n;
}
