
void ProcessDialogEvent()
{
	ref NPChar;
	aref Link, NextDiag;

	DeleteAttribute(&Dialog,"Links");

	makeref(NPChar,CharacterRef);
	makearef(Link, Dialog.Links);
	makearef(NextDiag, NPChar.Dialog);

	string sAgreeLink, sDeclineLink;
	switch(Dialog.CurrentNode)
	{
		case "First time":
			dialog.text = "Introduce yourself, I want to know who I'm talking to.";
			link.l1 = "My name is " + GetCharacterFullName(pchar.id) + ".";
			link.l1.go = "Second Time";
			NextDiag.TempNode = "Second Time";
		break;

		case "Second Time":
			dialog.text = SelectHovernorGreetingsDialog(npchar);
			link.l2 = "I just came to pay my respects to you, and now I'm leaving.";
			link.l2.go = "exit";
			///////////////////////////////////////////////////////
			///     ( )
			///////////////////////////////////////////////////////
			if(!CheckForNationService(sti(npchar.nation)))
			{
				link.l1 = "I'd like to enter your service.";
				link.l1.go = "service";
			}
			///////////////////////////////////////////////////////
			///     ( )
			///////////////////////////////////////////////////////
			if(CheckForDisease(npchar) == true && !CheckForNationService(sti(npchar.nation)))
			{
				dialog.text = "I'm sorry, an epidemic of swamp-fever is ravaging the colony, I don't have time for you right now.";
				/*if(GetCargoGoods(pchar, GOOD_MEDICINE) > 1)
				{
					link.l1 = "I've got medicine on my ship, perhaps I might be of help?";
					link.l1.go = "disease_cure";
				}
				else
				{*/
					link.l1 = "Swamp-fever? Oh, hell...";
					link.l1.go = "exit";
				//}
			}
			///////////////////////////////////////////////////////
			///    
			///////////////////////////////////////////////////////
			if(CheckAttribute(npchar, "quest.questflag"))
			{
				if(sti(npchar.quest.questflag) == 1)// 
				{
					link.l2 = "Do you have any missions for me?";
					link.l2.go = "taking_quest_line";
				}
				if(sti(npchar.quest.questflag) == 2)// 
				{
					link.l2 = "I've completed your mission...";
					link.l2.go = "check_quests_lines";
				}
				if(sti(npchar.quest.questflag) == 3)// 
				{
					link.l2 = "I'd like to talk about the mission you've given me.";
					link.l2.go = "reminder_quests_lines";
				}
			}
			NextDiag.TempNode = "Second Time";
		break;

		///////////////////////////////////////////////////////
		///  
		///////////////////////////////////////////////////////
		case "taking_quest_line":
			dialog.text = SelectHovernorQuestText(npchar, &sAgreeLink, &sDeclineLink);
			link.l1 = "An interesting offer. I Accept.";
			link.l1.go = sAgreeLink;
			link.l2 = "I'm afraid I must decline your offer.";
			link.l2.go = sDeclineLink;
		break;

		///////////////////////////////////////////////////////
		///    
		///////////////////////////////////////////////////////
		case "capture_fort_accept":
			dialog.text = "Bon voyage, captain.";
			link.l1 = "Thanks.";
			link.l1.go = "exit";
			AcceptCaptureFortQuest(npchar);
		break;

		case "capture_fort_decline":
			dialog.text = "I'm afraid I'll have to disappoint you - I don't have any other missions at the moment.";
			link.l1 = "In that case I'll come back later...";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///    
		///////////////////////////////////////////////////////
		case "delivery_item_accept":
			dialog.text = "Good luck then, captain.";
			link.l1 = "Thanks.";
			link.l1.go = "exit";
			AcceptDeliveryItemQuest(npchar);
		break;

		case "delivery_item_decline":
			dialog.text = "I'm sorry old chap - there's nothing going on right now.";
			link.l1 = "Righto then. I'll check back later...";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///    
		///////////////////////////////////////////////////////
		case "escort_ship_accept":
			dialog.text = "Good luck to you then, captain.";
			link.l1 = "Thank you.";
			link.l1.go = "exit";
			AcceptEscortQuest(npchar);
		break;

		case "escort_ship_decline":
			dialog.text = "It's all gone a bit quiet at the moment. Perhaps too quiet. Hmm...";
			link.l1 = "I'll stop by another time then...";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///   / 
		///////////////////////////////////////////////////////
		case "sink_ship_accept":
			dialog.text = "Good luck and God speed.";
			link.l1 = "Thank you governor.";
			link.l1.go = "exit";
			AcceptSinkShipQuest(npchar);
		break;

		case "sink_ship_decline":
			dialog.text = "Nothing doing, I'm afraid. Perhaps another time?";
			link.l1 = "Fine. I'll come and see you next time I'm passing through.";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///  
		///////////////////////////////////////////////////////
		case "delivery_passenger_accept":
			dialog.text = "Good luck in your next endeavour, captain.";
			link.l1 = "Thank you kindly.";
			link.l1.go = "exit";
			AcceptDeliveryPassengerQuest(npchar);
		break;

		case "delivery_passenger_decline":
			dialog.text = "I'm afraid there's nothing that needs doing at the moment captain.";
			link.l1 = "Very Well. I'll give it a while then check back later...";
			link.l1.go = "exit";
			DeletePassengerQuest(npchar);
		break;

		///////////////////////////////////////////////////////
		///  
		///////////////////////////////////////////////////////
		case "delivery_trade_accept":
			//Cerez: Don't accept mission and cargo if there's not enough space on player's ship(s) to take it all on board
			int iQuest = sti(npchar.CurrentQuest);
			int iGoods = sti(Quests[iQuest].l.goods);
			int iGoodsQuantity = sti(Quests[iQuest].l.goods.quantity);
			int iSpaceNeeded = GetSquadronFreeSpace(pchar, iGoods);
			int iSpaceHave = iGoodsQuantity * sti(Goods[iGoods].units);
			if(iSpaceNeeded < iSpaceHave && sti(Quests[iQuest].l.isdelayed) == 0)
			{
				dialog.text = "Hold on, captain - I'm looking at your records here... Will you have space enough for this cargo?";
				link.l1 = "Blast it! It escaped my mind - you're right. I'll need to have some of my current goods unloaded first...";
				link.l1.go = "exit";
			}
			else
			{
				dialog.text = "May the wind always be at your back, captain. Aha ha.";
				link.l1 = "Thanks...";
				link.l1.go = "exit";
				AcceptDeliveryTradeQuest(npchar);
			}
		break;

		case "delivery_trade_decline":
			dialog.text = "Sorry to disappoint you - I've nothing that requires your services captain.";
			link.l1 = "In that case I'll come back later...";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///   
		///////////////////////////////////////////////////////
		case "check_quests_lines":
			if(CheckAttribute(npchar, "quest.punishment"))
			{
				if(sti(npchar.quest.punishment) > 0)
				{
					dialog.text = "Well, despite you being " + FindRussianDaysString(sti(npchar.quest.punishment)) + " late, I'm mostly content with your results. But I'm afraid I will have to fine you for the delay.";
					link.l1 = "Always at your service.";
					link.l1.go = "quest_done_prepare_exit";
				}
				else
				{
					dialog.text = "I'm so glad you managed to complete my mission, and in good time too. Allow me to thank you for a job well done.";
					link.l1 = "No, thank you. it's always a pleasure to be appreciated.";
					link.l1.go = "quest_done_prepare_exit";
				}
			}
			else
			{
				dialog.text = "Superb! You continue to exceed my expectations Captain. Well done, and thank you.";
				link.l1 = "Always a pleasure, governor. Always a pleasure...";
				link.l1.go = "quest_done_prepare_exit";
			}
		break;

		case "reminder_quests_lines":
			dialog.text = SelectHovernorQuestReminderText(npchar);
			link.l1 = "I'm still working on it.";
			link.l1.go = "exit";
		break;

		///////////////////////////////////////////////////////
		///   
		///////////////////////////////////////////////////////
		case "service":
			if (CheckAttribute(pchar, GetNationNameByType(sti(npchar.nation)) + "_line_counter"))
			{
				dialog.text = "If memory serves me, you've already received a letter of marque from my country.\nBut it was cancelled after you were caught double-dealing.";
				link.l1 = "Hmm... Too bad, I'll be leaving then.";
				link.l1.go = "exit";
			}
			else
			{
				dialog.text = "Excellent! We need people like you.";
				link.l1 = "What do I need to sign to be done with the formalities?";
				link.l1.go = "service_2";
			}
		break;

		case "service_2":
			dialog.text = "Think well before signing it. If you decide to switch sides after receiving a letter of marque, you will lose my sympathies as well as those of my country. And they may be the least of your losses...";
			link.l1 = "I've thought it through. I'm in.";
			link.l1.go = "service_3";
			link.l2 = "Oh. Okay, I'll need some time to think about it then, before I make that kind of decision.";
			link.l2.go = "exit";
		break;

		case "service_3":
			dialog.text = "Splendid! I like your resolve. Now, you have only to prove your loyalty by deeds, so visit me when you decide the letter is more than just decoration for your cabin, and I might have a job for you.";
			link.l1 = "Very well.";
			link.l1.go = "service_exit";
		break;

		case "service_exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
			PlayerChangeNation(npchar);
		break;

		case "quest_done_prepare_exit":
			CharacterDoneQuest(npchar);
			if(CheckForNextRank(npchar) > 0)
			{
				dialog.text = "Allow me to congratulate you on your new rank, captain!";
				link.l1 = "Thank you for your confidence.";
				link.l1.go = "quest_done_exit";
				PlayerNextRank(npchar);
			}
			else
			{
				NextDiag.CurrentNode = NextDiag.TempNode;
				DialogExit();
			}
		break;

		case "quest_done_exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
			//CharacterDoneQuest(npchar);
		break;

		case "Exit":
			NextDiag.CurrentNode = NextDiag.TempNode;
			DialogExit();
		break;
	}
}