string totalInfo = "";

void InitInterface(string iniName)
{
	
	EngineLayersOffOn(true);
	SetTimeScale(0.0);
	GameInterface.title = "titleAskForHelp";
	
	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);
	
	CalculateInfoData();
	
	SetFormatedText("INFO_TEXT",totalInfo);
	
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"INFO_TEXT",5);
	
	SetEventHandler("InterfaceBreak","ProcessBreakExit",0); 
	SetEventHandler("exitCancel","ProcessCancelExit",0); 
	SetEventHandler("ievnt_command","ProcCommand",0);
	SetEventHandler("evntDoPostExit","DoPostExit",0); 
}

void ProcessBreakExit()
{
	IDoExit( RC_INTERFACE_FOOD_INFO_EXIT );
	//wdmReloadToSea();
	SetTimeScale(1.0);
	//pchar.quest.Fight_forOtherColony_temp.help = "0";
}

void ProcessCancelExit()
{
	IDoExit( RC_INTERFACE_FOOD_INFO_EXIT );
	//wdmReloadToSea();
	SetTimeScale(1.0);
	//pchar.quest.Fight_forOtherColony_temp.help = "0";
}

void IDoExit(int exitCode)
{
	DelEventHandler("InterfaceBreak","ProcessBreakExit");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("ievnt_command","ProcCommand");
	DelEventHandler("evntDoPostExit","DoPostExit");

	interfaceResultCommand = exitCode;
	EndCancelInterface(true);
	SetTimeScale(1.0);
	
	pchar.quest.Fight_forOtherColony_temp.help = "1";
}

void ProcCommand()
{
	string comName = GetEventData();
	string nodName = GetEventData();

	switch(nodName)
	{
	case "B_OK":
		if(comName=="activate" || comName=="click")
		{
			// 
			PostEvent("evntDoPostExit",1,"l",RC_INTERFACE_FOOD_INFO_EXIT);
			SetTimeScale(1.0);
		}
	break;
	}
}

void DoPostExit()
{
	int exitCode = GetEventData();
	IDoExit(exitCode);
}

void CalculateInfoData()
{
	int iHelp;
	int iEnemy;
	int iNation;
	string sColony;
	
	iHelp = sti(pchar.quest.Fight_forOtherColony_temp.help);

	//Cerez: Get quest's nation/colony name values, and store them away for end message
	if(CheckAttribute(pchar, "quest.attack_other_fort.enemy"))
	{
		iEnemy = sti(pchar.quest.attack_other_fort.enemy);
		iNation = sti(pchar.quest.attack_other_fort.nation);
		sColony = pchar.quest.attack_other_fort.colony;
		pchar.quest.Fight_forOtherColony_temp.enemy = pchar.quest.attack_other_fort.enemy;
		pchar.quest.Fight_forOtherColony_temp.nation = pchar.quest.attack_other_fort.nation;
		pchar.quest.Fight_forOtherColony_temp.colony = pchar.quest.attack_other_fort.colony;
	}
	else
	{
		iEnemy = sti(pchar.quest.Fight_forOtherColony_temp.enemy);
		iNation = sti(pchar.quest.Fight_forOtherColony_temp.nation);
		sColony = pchar.quest.Fight_forOtherColony_temp.colony;
	}
	
	if (iHelp == 2)
	{
		totalinfo = "The governance of " + XI_ConvertString(GetNationNameByType(iEnemy) + "Gen") + " extends their gratitude to you for your role played in the defence of " + sColony + " and, as a token of their gratitude, conveys to you " + (10000 + sti(pchar.skill.commerce)*500) + " gold.";
		
		AddMoneyToCharacter(pchar, (10000 + GetSummonSkillFromName(pchar, SKILL_COMMERCE)*500));
		
		//Cerez: We're done - clean up
		DeleteAttribute(pchar, "quest.Fight_forOtherColony_temp");
	}
	else
	{
		totalinfo = "The governance of " + XI_ConvertString(GetNationNameByType(iEnemy) + "Gen") + " asks for help against the forces of " + XI_ConvertString(GetNationNameByType(iNation)+"Dat") + " that are laying siege to " + sColony + ".";
	}

	SetCurrentNode("B_OK");
}
