
#define VICTORY	0
#define	LOOSE	1

void UpdateCrewExp()
{	
	int cn;
	for (int i = 0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(pchar, i);
		if(cn != -1)
		{
			characters[cn].ship.crew.experience = sti(characters[cn].ship.crew.experience) + 1;
			if(sti(characters[cn].ship.crew.experience) > 99)
			{
				characters[cn].ship.crew.experience = 99;
			}
		}
	}

	int iBoatswain = sti(pchar.Fellows.Passengers.boatswain);
	if(iBoatswain != -1)
	{
		int iLeadership = sti(characters[iBoatswain].skill.leadership);
		iLeadership = iLeadership/2;
		pchar.ship.crew.experience = sti(pchar.ship.crew.experience) + iLeadership;
		if(sti(pchar.ship.crew.experience) > 99)
		{
			pchar.ship.crew.experience = 99;
		}
	}
}

void UpdateCrewMorale()
{
	string sQuest = "UpdateCrewMorale_" + rand(10000);
	pchar.quest.(sQuest).win_condition.l1 = "TimeEx";
	int iHour = GetHour();
	int iAddHour = 24 - iHour;
	iHour = iHour + rand(iAddHour);
	pchar.quest.(sQuest).win_condition.l1.time = iHour;
	pchar.quest.(sQuest).win_condition = "UpdateCrewMorale";
	pchar.quest.(sQuest).function = "ExecuteUpdateCrewMorale";
}

void ExecuteUpdateCrewMorale()
{
	int cn;
	float fCrew, fCrewMax;
	int iShip;
	float fMorale;
	int nOrder;

	isRiotActive = 0;

	for (int i = 0; i<COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(pchar, i);
		if(cn != -1)
		{

			if(!CheckAttribute(pchar, "arcademode.crew_morale"))
			{
				pchar.arcademode.crew_morale = 0;
			}
			
			pchar.arcademode.crew_morale = sti(pchar.arcademode.crew_morale) + 1;

			if(sti(pchar.arcademode.crew_morale) > iGameArcade)
			{
				ChangeCharacterCrewMorale(&characters[cn], -1);

				nOrder = i * 5;

				if(CheckForRiot(&characters[cn]) == 1 && pchar.location == "")
				{
					isRiotActive = 1;
					PostEvent("ievent_Riot",nOrder,"sl","mutiny", cn);
				}
				if(isRiotActive == 0)
				{
					pchar.arcademode.crew_morale = 0;
				}
			}
		}
	}
}

int CheckForRiot(aref chr)
{
	float fMorale = GetCharacterCrewMorale(chr);
	float fLeadership = GetSummonSkillFromName(chr, SKILL_LEADERSHIP);
	
	if(fMorale < MORALE_NORMAL)
	{
		if(fMorale <= I_MIN_MORALE + fLeadership && isRiotActive == 0) 
		{
			return 1;
		}
	}
	return 0;
}

void LaunchRiotOnShip()
{
	
	string deckID = GetShipLocationID(pchar);

	pchar.quest.riotondeck.win_condition.l1 = "location";
	pchar.quest.riotondeck.win_condition.l1.location = deckID;
	pchar.quest.riotondeck.win_condition = "ReachRiotDeck";

	Locations[FindLocation(deckID)].boarding = "false";
	Locations[FindLocation(deckID)].image = "loading\Mutiny_512.tga";


	//pchar.Ship.Pos.x = stf(worldMap.playerShipX) / WDM_MAP_TO_SEA_SCALE;
	//pchar.Ship.Pos.z = stf(worldMap.playerShipZ) / WDM_MAP_TO_SEA_SCALE;
	//worldMap.playerShipAY = ay;

	if(bSeaActive == 0)
	{
		worldMap.old = "";
		//worldMap.old.playerShipX = worldMap.playerShipX;
		//worldMap.old.playerShipZ = worldMap.playerShipZ;
		
		aref arOldMapPos;
		makearef(arOldMapPos, worldMap.old);

		WdmPrepareMapForAbordage(arOldMapPos):

		DoReloadFromWorldMapToLocation(deckID, "rld", "aloc1");
	}
	else
	{
		DoReloadFromSeaToLocation(deckID, "rld", "aloc1");
	}
}
	
void ReachRiotDeck()
{
	InterfaceStates.Buttons.Save.enable = false;

	string deckID = GetShipLocationID(pchar);

	locations[FindLocation(deckID)].image = "loading\boarding.tga";

	float fCrew = stf(pchar.ship.crew.quantity);
	float fMorale = GetCharacterCrewMorale(pchar);

	int iFencing = sti(pchar.skill.fencing);
	int iLeadership = GetSummonSkillFromName(pchar, SKILL_LEADERSHIP);

	float fOurCommand = fCrew * fMorale / 100;
	fOurCommand = fOurCommand + fOurCommand*iLeadership/2.0;
	float fEnemyCommand = fCrew - fOurCommand;

	//pchar.ship.crew.quantity = sti(pchar.ship.crew.quantity)*fOurCommand/100;
	int iChange = fCrew / fOurCommand;

	pchar.ship.crew.boardingcrew = sti(pchar.ship.crew.boardingcrew) / iChange;
	pchar.ship.crew.gunnercrew = sti(pchar.ship.crew.gunnercrew) / iChange;
	pchar.ship.crew.sailorcrew = sti(pchar.ship.crew.sailorcrew) / iChange;
	pchar.ship.crew.cannonercrew = sti(pchar.ship.crew.cannonercrew) / iChange;

	SetCrewForACharacter(pchar);
	
	ChangeCharacterCrewMorale(pchar, 10);//,    .     (  ,   )
	

	float rel;
	int percent;

	int limit = MAX_GROUP_SIZE;

	int locIndex = FindLocation(deckID);

	if(fOurCommand > fEnemyCommand)
	{
		if(fOurCommand > limit)
		{
			rel = fOurCommand/limit;
			fOurCommand = limit;
			fEnemyCommand = MakeInt(fEnemyCommand/rel + 0.5);
		}
	}
	else
	{
		if(fEnemyCommand > limit)
		{
			rel = fEnemyCommand/limit;
			fEnemyCommand = limit;
			fOurCommand = MakeInt(mcrew/rel + 0.5);
		}
		//   ,    .
		if (iarcadefencingai == 1 || iarcadefencingdamage == 1)
		{
			percent = fOurCommand*100/fEnemyCommand;
			fOurCommand = fOurCommand + fOurCommand*percent/50;
		}
	}

	if(fOurCommand < 1) fOurCommand = 1;
	if(fEnemyCommand < 1) fEnemyCommand = 1;
	if(fEnemyCommand > limit) fEnemyCommand = limit;
	if(fOurCommand > limit) fOurCommand = limit;

	int iChar;

	int iStep = 2;
	string sLocator;
	for(int i = 1; i <4; i++)
	{
		iChar = GetOfficersIndex(pchar, i);
		if(iChar < 0)
		{
			continue;
		}
		sLocator = "aloc" + iStep;
		ChangeCharacterAddressGroup(&characters[iChar], deckID, "rld", sLocator);
		LAi_SetOfficerType(&characters[iChar]);
		iStep = iStep + 1;
	}

	for(i = iStep; i < fOurCommand; i++)
	{
		sLocator = "aloc" + iStep;
		iChar = GenerateCharacter(sti(pchar.nation), WITHOUT_SHIP, "pirate", MAN, 0, WARRIOR);
		LAi_RemoveLoginTime(&characters[iChar]);
		ChangeCharacterAddressGroup(&characters[iChar], deckID, "rld", sLocator);
		LAi_SetOfficerType(&characters[iChar]);
		iStep = iStep + 1;
		
		//Cerez: Disable talking with autogenerated crew
		LAi_CharacterDisableDialog(&characters[iChar]);
	}

	//string sGroup = "RiotGroup";
	iStep = 0;
	for(i = 0; i < fEnemyCommand; i++)
	{
		sLocator = "loc" + iStep;
		iChar = GenerateCharacter(PIRATE, WITHOUT_SHIP, "pirate", MAN, 0, WARRIOR);
		LAi_RemoveLoginTime(&characters[iChar]);
		ChangeCharacterAddressGroup(&characters[iChar], deckID, "rld", sLocator);
		LAi_SetWarriorTypeNoGroup(&characters[iChar]);
		LAi_group_MoveCharacter(&characters[iChar], "RIOT_GROUP");
		iStep = iStep + 1;
	}

	//LAi_group_SetRelation(LAI_GROUP_PLAYER, sGroup, LAI_GROUP_ENEMY);
	LAi_group_FightGroups(LAI_GROUP_PLAYER, "RIOT_GROUP", false);

	LAi_group_SetCheck("RIOT_GROUP", "RiotEnding");
}

void DeckRiotEnding()
{
	LAi_QuestDelay("FromRiotDeckToSea", 5.0);
}

void FromRiotDeckToSea()
{

	string deckID = GetShipLocationID(pchar);
	int iLoc = FindLocation(deckID);
	
	//pchar.Ship.Pos.x
	if(UnloadLocation(&Locations[iLoc]) == true)
	{
		if(CheckAttribute(worldMap, "old"))
		{
			pchar.ship.pos.x = worldMap.old.x;
			pchar.ship.Ang.y = worldMap.old.y;
			pchar.ship.pos.z = worldMap.old.z;
			DeleteAttribute(worldMap, "old");
		}
		Land_MapLoad();
		pchar.location = "";
	}
	else
	{
		trace("-----Oh my god! Location " + deckID + " can't unloaded!----");
	}

	Locations[iLoc].boarding = "true";
	InterfaceStates.Buttons.Save.enable = true;
	isRiotActive = 0;
	pchar.arcademode.crew_morale = 0;
}

void LaunchRiotSimulationOnShip(aref chr)
{
	float fCrew = stf(chr.ship.crew.quantity);
	float fMorale = GetCharacterCrewMorale(chr);

	int iFencing = sti(chr.skill.fencing);
	int iLeadership = sti(chr.skill.leadership);
	
	iLeadership = 1.0 * (0.2 * iGameArcade);
	iFencing = 1.0 * (0.2 * iGameArcade);

	float fOurCommand = fCrew * fMorale / 100;
	fOurCommand = fOurCommand + fOurCommand * iLeadership / 2.0;
	float fEnemyCommand = fCrew - fOurCommand;
	
	int iResult = -1;
	int iRand;

	while(iResult == -1)
	{
		if(fOurCommand > 0.0 && fEnemyCommand > 0.0)
		{
			iRand = rand(1);
			if(iRand == 0)
			{
				fOurCommand = fOurCommand - 1;
			}
			else
			{
				fEnemyCommand = fEnemyCommand - 1;
			}
		}
		else
		{
			iResult = 0;
		}
	}

	if(fOurCommand <= 0.0)
	{
		while(iResult == 0)
		{
			if(fEnemyCommand > 0.0)
			{
				iRand = rand(12);
				if(iRand > iFencing)
				{
					iResult = 2;
				}
				else
				{
					fEnemyCommand = fEnemyCommand - 1;
				}
			}
			else
			{
				iResult = 1;
			}
		}
	}
	else
	{
		iResult = 1;
	}

	chr.ship.crew.quantity = fEnemyCommand + fOurCommand;
	ChangeCharacterCrewMorale(chr, +10);

	if(iResult == 1)
	{
		//  .
		pchar.RiotOnCompanionShip = 1;
		//pchar.riot.condition = VICTORY;
		//pchar.riot.enemy = iChar;
		LaunchRiotResult(chr, VICTORY, sti(chr.index));
	}
	else
	{
		pchar.RiotOnCompanionShip = 1;
		RemoveCharacterCompanion(pchar, chr);

		int iChar = GenerateCharacter(PIRATE, WITHOUT_SHIP, "pirate", MAN, 1, WARRIOR);

		SeaAI_SwapShipsAttributes(&characters[iChar], chr);
		SetCompanionIndex(pchar, -1, iChar);

		LAi_KillCharacter(chr);

		pchar.quest.CompanionRiot.win_condition.l1 = "EnterToSea";
		pchar.quest.CompanionRiot.win_condition = "CompanionRiot";
		pchar.quest.CompanionRiot.character = iChar;
		
		chr.location = "none";
		if(CheckAttribute(chr, "officernum"))
		{
			int m = chr.officernum;
			officers[m].hired = "0";
		}

		LaunchRiotResult(chr, LOOSE, iChar);
	}
}

void LaunchRiotBattle()
{
	wdmReloadToSea();
}

string GetExpName(int iExp)
{
	string sExp;
	if(iExp >= 1)
	{
		sExp = "Exp 1";
	}
	if(iExp >= 10)
	{
		sExp = "Exp 2";
	}
	if(iExp >= 20)
	{
		sExp = "Exp 3";
	}
	if(iExp >= 30)
	{
		sExp = "Exp 4";
	}
	if(iExp >= 40)
	{
		sExp = "Exp 5";
	}
	if(iExp >= 50)
	{
		sExp = "Exp 6";
	}
	if(iExp >= 60)
	{
		sExp = "Exp 7";
	}
	if(iExp >= 70)
	{
		sExp = "Exp 8";
	}
	if(iExp >= 80)
	{
		sExp = "Exp 9";
	}
	if(iExp >= 90)
	{
		sExp = "Exp 10";
	}

	return sExp;
}

int GetPercentPaymentForCrew()
{
	int iPayment = sti(pchar.paymenttype);
	iPayment = iPayment / 2;
	iPayment = iPayment / iGameArcade;
	return iPayment;
}

int GetCrewPriceForTavern(string sColony)
{
	int iColony = FindColony(sColony);
	int iLoyality = sti(colonies[iColony].loyality);
	int iCrewExp = sti(colonies[iColony].crew.experience);
	int iBasePrice = 5;
	int iPrice = iBasePrice - iLoyality/10 + iCrewExp / 10;

	return iPrice;
}

void CompanionRiot()
{
	DoQuestCheckDelay("BeginRiotSeaBattle", 3.0);
	int iChar = sti(pchar.quest.CompanionRiot.character);
	characters[iChar].nation = PIRATE;
	characters[iChar].reputation_influense = "off";
	pchar.quest.BeginRiotSeaBattle.character = pchar.quest.CompanionRiot.character;
}

void BeginRiotSeaBattle()
{
	int iChar = sti(pchar.quest.BeginRiotSeaBattle.character);

	SeaAI_SetCompanionEnemy(&characters[iChar]);
	isRiotActive = 0;
	pchar.arcademode.crew_morale = 0;


	/*RemoveCharacterCompanion(pchar, &characters[iChar]);

	string sGroup = "QuestRioteShip"+rand(100000);
	Group_CreateGroup(sGroup);

	Group_ChangeCharacter(sGroup, characters[iChar].id);
	//Group_AddCharacter(sGroup, characters[iChar].id);
	Group_SetGroupCommander(sGroup, characters[iChar].id);
	Ship_SetTaskAttack(PRIMARY_TASK, iChar, nMainCharacterIndex);
	SetCharacterRelationBoth(nMainCharacterIndex, iChar, RELATION_ENEMY);
	UpdateRelations();*/
}