
void QuestComplete(string sQuestName, string qname)
{
	ref chr;
	string sFunction = "";
	
	if(CheckAttribute(pchar, "quest." + qname + ".function"))
	{
		sFunction = pchar.quest.(qname).function;
		/*
		if(CheckFunction(sFunction) == 1)
		{
			call sFunction(qname);
			return;
		}
		*/
	}

	if(CheckAttribute(pchar, "quest." + qname + ".EmptyFunction"))
	{
		sFunction = pchar.quest.(qname).EmptyFunction;
		/*
		if(CheckFunction(sFunction) == 1)
		{
			call sFunction();
			return;
		}
		*/
	}

	switch(sQuestName)
	{	
		case "test_hide_locators":
			HideLocatorsGroup("sit");
		break;
		case "test_ai_groups":
			CheckAiGroups();
		break;
		case "test_colony_info":
			LaunchColonyInfoScreen();
		break;

		case "test_fort_abordage":
			TestFortAbordage("Guadeloupe Fort Commander");
		break;

		case "test_ship_abordage":
			TestShipAbordage();
		break;

		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////
		case "EraseWind":
			DeleteAttribute(pchar, "wind");
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -      -   
		/////////////////////////////////////////////////////////////////////////////////
		case "RechargeHovernorQuests":
			RechargeHovernorQuests(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  -   
		/////////////////////////////////////////////////////////////////////////////////
		case "smuggling_result":
			RechargeSmuggling(qname);
		break;

		case "DeleteSmugglingAlarm":
			DeleteSmugglingAlarm(qname);
		break;

		case "DelayBeforeCreateSmugglingEnemies":
			CreateSmugglingEnemies();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   - !
		/////////////////////////////////////////////////////////////////////////////////
		case "combo_1_last_hit":
			LockControl("",true);
			Combo1LastHit(qname);
		break;

		case "combo_2_last_hit":
			LockControl("",true);
			Combo2LastHit(qname);
		break;

		case "combo_finished":
			LockControl("",false);
			LAi_SetPlayerType(pchar);
			DelEventHandler("ComboFinished", "LAi_CharacterAttack");
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - !
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   - / 
		/////////////////////////////////////////////////////////////////////////////////
		case "Kill_hovernor":
			KillHovernor(qname);
		break;

		case "Ship_Capture":
			CaptureHovernor(qname);
		break;

		case "ClearHovernorSquadron":
			ClearHovernorSquadron(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - / 
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		//   
		/////////////////////////////////////////////////////////////////////////////////
		case "Change_Relation_for_Nation_by_relation_agent":
			ChangeNationRelationFromRelationAgentComplete(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		//   
		/////////////////////////////////////////////////////////////////////////////////
		case "EmptyAllShipsForIsland":
			EmptyAllShipsForIsland(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		//   
		/////////////////////////////////////////////////////////////////////////////////
		case "ShipyardCleanUp":
			ShipyardCleanUp(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "ColoniesInfoUpdate":
			ColoniesInfoUpdate();
		break;

		case "ColonyInfoQuestMan":
			ColonyInfoQuestManExecute();
		break;

		case "RechargeColonyInfoMan":
			SetQuestForMenInTavernWhoGiveUsInfo();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		case "UpdateCrewMorale":
			ExecuteUpdateCrewMorale();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "BeginRiotSeaBattle":
			BeginRiotSeaBattle();
		break;

		case "ReachRiotDeck":
			ReachRiotDeck();
		break;

		case "RiotEnding":
			DeckRiotEnding();
		break;

		case "FromRiotDeckToSea":
			FromRiotDeckToSea();
		break;

		case "CompanionRiot":
			CompanionRiot();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "kill_bounty_hunters":
			CheckBountySituations(1);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		case "Prepare_for_duel":
			PrepareForDuel(qname);
		break;

		case "Duel_Timer":
			DuelTimer(qname);
		break;

		case "Drink_Duel":
			DrinkDuel();
		break;

		case "Win_duel":
			Win_duel(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "tavern_room_cituations":
			CheckForTavernRoomSituations();
		break;

		case "tavern_cituations":
			CheckForTavernSituations();
		break;

		case "drink_man_leave":
			DrinkManLeave();
		break;

		case "drink_man_duel":
			DrinkManDuel();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		case "RechargeOfficers":
			RechargeOfficers();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "to_cabine":
			PlaceOfficerToCabine(qname);
		break;

		case "officer_erase":
			EraseOfficer();
		break;

		case "officer_away":
			AwayOfficer();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////
		case "OfficerWantFire":
			OfficerWantFire(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		case "EscortQuestTimer_Failed":
			FailedEscortTradeShipQuest(qname);
		break;

		case "EscortTradeShip_sucess":
			SucessEscortTradeShipQuest(qname);
		break;

		case "EscortTradeShip_ship_sinked":
			SinkedEscortTradeShipQuest(qname);
		break;

		case "EscortTradeShip_ship_captured":
			CapturedEscortTradeShipQuest(qname);
		break;

		case "Punishment_for_escort_trade_ship_quest":
			RechargeEscortPunishment(qname);
		break;

		case "fight_on_convoy_quest":
			FightOnConvoyQuest(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////
		case "Check_For_Dead_Ranger":
			CheckForDeadRangerFromPlayer(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "WaitForRechargeRangerAdventure":
			PrepareRechargeRangerAdventure(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "EndBattleForRanger":
			EndBattleForRanger(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////
		case "BattleForRanger":
			BattleForRanger(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -      
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "Historical_event":
			CheckHistoryEvent(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_shipfame_quest":
			pchar.shipfamelock = true;
			ShipFameUp();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		//     CALL.      
		/////////////////////////////////////////////////////////////////////////////////
		case "sneak_to_town_failed":
			SneakFailed(qname);
		break;

		case "SuccessSneakToColony":
			SneakSuccesed(qname);
		break;


		case "FailSneakToColony":
			SneakFailed(qname);
		break;
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_colonypopulation_quest":
			pchar.colonypopulationlock = true;
			RechargeColonyPopulationUp();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_colonycolonists_quest":
			pchar.colonycolonistslock = 1;
			ColonyColonistsUp();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_gold_convoy_quest":
			pchar.goldconvoylock = 1;
			GenerateGoldConvoy();
		break;

		case "ContinueGoldConvoy":
			ContinueGoldConvoy();
		break;

		case "DefeatGoldConvoy":
			DefeatGoldConvoy(qname, pchar);
		break;

		case "ClearGoldConvoy":
			EmptyGoldConvoy();
		break;

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "DeliveryPassenger":
			PrepareCompleteDeliveryPassengerQuest(qname);
		break;

		case "DeliveryPassengerTimerFailed":
			DeliveryPassengerTimerFailed(qname);
		break;

		case "Punishment_for_delivery_passenger_quest":
			RechargeDeliveryPassengerPunishment(qname, 0);
		break;

		case "Kill_passenger":
			Kill_passenger(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "RechargeDisease":
			RechargeDisease();
		break;
		
		case "Cure":
			CureColony(qname);
		break;
		
		case "Contamination":
			CheckForContamination(qname);
		break;

		case "end_of_contamination_alert_for_colony":
			EndContaminationAlert(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		case "RangerTimer":
			RangerTimer(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		case "Speak_map_enter":
			DeleteRansomCharacters();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "Fight_forOtherColony":
			EndColonyOccupation(qname, 1);
		break;
		
		case "attack_other_fort":
			AttackOtherFort();
		break;	
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "VisitIsland_Jamaica":
			IslandVisited(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "DeliveryItemQuestReachedLocation":
			DeliveryItemQuestReachedLocation(qname);
		break;

		case "deliveryitemquesttimer_failed":
			FailedDeliveryTradeQuest(qname);
		break;

		case "Punishment_for_delivery_item_quest":
			RechargeDeliveryItemPunishment(qname, 0);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "deliverytradequesttimer_failed":
			FailedDeliveryTradeQuest(qname);
		break;

		case "Punishment_for_delivery_trade_quest":
			RechargeDeliveryTradePunishment(qname, 0);
		break;

		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		case "colony_occupation_wait_player_quest":
			PlayerVisitColonyOccupation(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		case "escapefrombattlefrocollony":
			EscapeFromBattleForColony(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -     
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		case "end_colonyoccupation_quest":
			EndColonyOccupation(qname, 0);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -    
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_colonyoccupation_quest":
			pchar.colonyoccupationlock = true;
			RechargeColonyOccupation();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_goodpriceshift":
			pchar.goodpriceshift = true;
			RechargeGoodsPriceShift();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_relations":
			pchar.relationslock = true;
			RechargeRelations();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "recharge_colony_upgrade":
			pchar.colonyupgradelock = true;
			RechargeColonyUpgrades();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		case "prepare_steal":
			pchar.quest.check_steal.win_condition.l1 = "ExitFromLocation";
			pchar.quest.check_steal.win_condition.l1.location = pchar.location;
			pchar.quest.check_steal.win_condition = "check_steal";
		break;
		
		case "check_steal":
			CheckSteal();
		break;
		
		case "steal_item":
			pchar.quest.steal_item = "stealed";
			DeleteEnterLocationQuest(pchar.quest.stealitem.location, "steal_townhall_check");
		break;
		
		case "StealFight":
			StealFight(sti(pchar.steal.nation), characterFromID(pchar.steal.character));
		break;
		
		case "steal_townhall_check":
			PlaceItem();
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		//     CALL.      
		/////////////////////////////////////////////////////////////////////////////////
		case "career_money":
			CareerMoney(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   - 
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		case "prepare_kill_character":
			Lai_SetlevelHp(characterFromID("Capture_Quest_pirate"));
			Lai_SetlevelHp(characterFromID("Capture_Quest_officer_01"));
			Lai_SetlevelHp(characterFromID("Capture_Quest_officer_02"));
			PlaceCharacter(characterFromID("Capture_Quest_pirate"), "goto", "random");
			if (sti(pchar.skill.sneak) < rand(13))
			{
				PlaceCharacter(characterFromID("Capture_Quest_officer_01"), "goto", "random");
			}
			if (sti(pchar.skill.sneak) < rand(15) && pchar.location != "Kill_house")
			{
				PlaceCharacter(characterFromID("Capture_Quest_officer_02"), "goto", "random");
			}
			LAI_SetCitizenType(characterFromID("Capture_Quest_pirate"));
			LAI_SetActorType(characterFromID("Capture_Quest_officer_01"));
			LAI_SetActorType(characterFromID("Capture_Quest_officer_02"));
			LAI_ActorFollow(characterFromID("Capture_Quest_officer_01"), characterFromID("Capture_Quest_pirate"), "", -1);
			LAI_ActorFollow(characterFromID("Capture_Quest_officer_02"), characterFromID("Capture_Quest_pirate"), "", -1);
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_pirate"), GetNationNameByType(sti(pchar.quest.prepare_kill_character.group)) + "_citizens");
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_officer_01"), GetNationNameByType(sti(pchar.quest.prepare_kill_character.group)) + "_citizens");
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_officer_02"), GetNationNameByType(sti(pchar.quest.prepare_kill_character.group)) + "_citizens");
		break;
		
		case "prepare_home_kill_character":
			SelectHome(pchar.quest.kill_character.parent_location);
		break;
		
		case "quest_fight_kill_character":
			LAI_SetWarriorType(characterFromID("Capture_Quest_pirate"));
			LAI_SetWarriorType(characterFromID("Capture_Quest_officer_01"));
			LAI_SetWarriorType(characterFromID("Capture_Quest_officer_02"));
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_pirate"), "Sucrifice");
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_officer_01"), "Sucrifice");
			LAi_group_MoveCharacter(characterFromID("Capture_Quest_officer_02"), "Sucrifice");
			
			LAi_group_FightGroups(LAI_GROUP_PLAYER, "Sucrifice", true);
		break;
		
		case "give_ring":
			GiveItem2Character(pchar, pchar.quest.killcharacter.item);
			AddQuestRecord("KillCharacter", "3");
			DeleteAttribute(pchar, "quest.killcharacter");
			DeleteAttribute(Locations[FindLocation(pchar.quest.prepare_home_kill_character.parent_location)], "reload.l1000");
		break;
		
		case "kill_england_quest_pirate":
			KillCharacterForQuest(ENGLAND, sQuestname);
		break;
		
		case "kill_france_quest_pirate":
			KillCharacterForQuest(FRANCE, sQuestname);
		break;
		
		case "kill_spain_quest_pirate":
			KillCharacterForQuest(SPAIN, sQuestname);
		break;
		
		case "kill_holland_quest_pirate":
			KillCharacterForQuest(HOLLAND, sQuestname);
		break;
		
		case "kill_pirate_quest_pirate":
			KillCharacterForQuest(PIRATE, sQuestname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		//     CALL.      
		/////////////////////////////////////////////////////////////////////////////////
		case "PrepareForSinkShip":
			VisitShipSinkLocation(qname);
		break;
		
		case "Sink_Quest_pirate":
			ShipSinkForQuest(qname);
		break;		

		case "sink_ship_quest_timer_failed":
			SinkShipTimerFailed(qname);
		break;

		case "SinkShipQuest_LooseBattle_ExitToMap":
			SinkShipQuestLooseBattleExitToMap(qname);
		break;

		case "sink_ship_travel":
			SinkShipTravel(qname);
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "free_adventure_for_character_0":
			AdventureCompleted("character_0");
		break;
		
		case "free_adventure_for_character_1":
			AdventureCompleted("character_1");
		break;
		
		case "free_adventure_for_character_2":
			AdventureCompleted("character_2");
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		case "Capture_Quest_pirate":
			ShipCaptureForQuest(qname);
		break;
		
		case "Capture_Quest_pirate_failed":
			ShipFailedCaptureForQuest(qname);
		break;
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		//     CALL.      
		/////////////////////////////////////////////////////////////////////////////////
		
		case "PrepareCaptureFort":
			PrepareCaptureFort(qname);
		break;
		
		case "CaptureFort":
			FortCapturedForQuest(qname);
		break;

		case "capture_fort_quest_timer_failed":
			CaptureFortQuestFailed(qname);
		break;
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		//     CALL.      
		/////////////////////////////////////////////////////////////////////////////////
		case "check_for_capture_colony": // 
			CheckForCaptureColony(qname);
		break;
		
		
		case "wait_for_capture_colony": // 
			LooseColony(qname);
		break;

		case "LooseColonyDelay":
			LooseColonyDelay(sQuestName); // sQuestName,   qname
		break;
		
		case "wait_for_resque_colony": //  .
			PrepareResqueColony(qname);
		break;
		
		case "WinColony": //   
			RechargeColonyCapture(qname);
		break;
		
		case "LooseColony": // 
			LooseColony(qname);
		break;
		
		case "delay_before_recharge_colony": //   
			RechargeColonyCapture(pchar.quest.(qname).colony);
		break;
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -  
		/////////////////////////////////////////////////////////////////////////////////
		
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		case "sleep_in_tavern":
			DoQuestReloadToLocation(pchar.location + "_upstairs", "goto", "goto1", "restore_hp");
		break;
		
		case "restore_hp":
			int iOfficer;
			LAi_SetCurHPMax(pchar);
			for (int i=1; i<4; i++)
			{
				if (GetOfficersIndex(Pchar, i) != -1)
				{
					iOfficer = GetOfficersIndex(Pchar, i);
					LAi_SetCurHPMax(&characters[iOfficer]);
				}
			}			
		break;
		/////////////////////////////////////////////////////////////////////////////////
		//   -   
		/////////////////////////////////////////////////////////////////////////////////
		
		
	}	
}
