
int nCurScrollNum, iGoodIndex, nCrewCurScrollNum;
int nExchangeCurScrollNum, iExchangeGoodIndex;
ref refCharacter, refExCharacter;
object GoodsList[GOODS_QUANTITY];
object GoodsListExchange[GOODS_QUANTITY];
object objStoreData;

int iDiscardValue;
int iEchangeValue;
int iSlideExchange;

int isFirstTime;
int iExchangeStringsQuantity = 0;

int shipIndex;
int nCurScrollOldNum = 0;

int iPrevStep = 0;
int iStep = 0;
int iGoodsChange = 0;
ref rIn,rOut;

int irestoreCode = -1;


//----------------------------------------------------------------------------------------------------
void InitInterface_I(string iniName,int bIState)
{	
	refCharacter = pchar;
	GameInterface.title = "titleShip";

	iDiscardValue = 0;
	iEchangeValue = 0;
	iSlideExchange = 0;
	

	FillShipsScroll();
	FillPassengerScroll();

	FillSailsColorScroll();
	FillEmblemesScroll();
	FillExchangeCrewShipsList();

	SetEventHandler("GetInterfaceTexture", "ScrollGetTexture", 0);

	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);

	SetNewPicture("MAIN_CHARACTER_PICTURE", "interfaces\portraits\64\face_" + refCharacter.FaceId + ".tga");

	if(sti(refCharacter.ship.type) == SHIP_NOTUSED)
	{
		int iCharacter = sti(GameInterface.SHIPS_SCROLL.pic1.character);
		refCharacter = &characters[iCharacter];
	}

	FillExchangeShipsScroll();

	SetFormatedText("CAPTION_GOODS", XI_Convertstring("good name"));
	SetFormatedText("CAPTION_QUANTITY_SHIP", XI_Convertstring("goods capacity"));
	SetFormatedText("CAPTION_PRICE_SHIP", XI_Convertstring("last buy price"));
	SetFormatedText("CAPTION_WEIGHT", XI_Convertstring("good weight"));
	SetFormatedText("CAPTION_BESTSELL", XI_Convertstring("good bestsell"));

	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CAPTION_GOODS", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CAPTION_QUANTITY_SHIP", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CAPTION_PRICE_SHIP", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CAPTION_WEIGHT", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CAPTION_BESTSELL", 5 );

	string sText;
	
	sText  = " " + XI_Convertstring("ShipType");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText  = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("ShipClass");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText  = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Hull");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText  = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);


	sText  = " " + XI_Convertstring("Sails");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Speed");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Maneuv.");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Crew");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Cannons");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	/*
	sText  = " " + XI_Convertstring("Flow");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);

	sText  = " " + XI_Convertstring("Current Order");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 0,&sText);
	sText = " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 0,&sText);
	*/

	CreateString(true,"tempGoodsShip","",FONT_NORMAL,argb(255,255,255,255),434,437,SCRIPT_ALIGN_RIGHT,0.9);
	CreateString(true,"tempGoodsStore","",FONT_NORMAL,argb(255,255,255,255),543,437,SCRIPT_ALIGN_LEFT,0.9);

	//CreateString(true,"MainCharacter",XI_ConvertString("MainCharacter"),FONT_NORMAL,COLOR_NORMAL,82,56,SCRIPT_ALIGN_LEFT,0.8);
	CreateString(true,"CharacterName","",FONT_NORMAL,COLOR_NORMAL,82,92,SCRIPT_ALIGN_LEFT,0.8);
	CreateString(true,"CharacterFamily","",FONT_NORMAL,COLOR_NORMAL,82,108,SCRIPT_ALIGN_LEFT,0.8);
	GameInterface.strings.CharacterName = pchar.name;
	GameInterface.strings.CharacterFamily = pchar.lastname;
	
	int iShip = sti(refCharacter.ship.type);
	iShip = sti(RealShips[iShip].basetype);
	string sShip = ShipsTypes[iShip].name;

	SetNewPicture("SHIP_BIG_PICTURE", "interfaces\ships\" + sShip + ".tga");

	FillGoodsList();

	shipIndex = 0;
	OnShipScrollChange();

	iGoodIndex = sti(GoodsList[0].index);
	SetDiscardSlider();

	SetEventHandler("InterfaceBreak","ProcessCancelExit",0);
	SetEventHandler("frame","ProcessFrame",1);
	SetEventHandler("exitOk","ProcessOkExit",0);
	SetEventHandler("exitCancel","ProcessCancelExit",0);
	SetEventHandler("ievnt_command","ProcessCommandExecute",0);

	SetEventHandler("ShowGoodsInfo","ShowInfoWindow_Goods",0);
	SetEventHandler("ShowShipInfo","ShowInfoWindow_Ship",0);
	//SetEventHandler("FormatedTextActivate","OnSelectList",0);
	SetEventHandler("MouseRClickUp","HideInfoWindow",0);

	SetEventHandler("confirmShipChangeName","confirmShipChangeName",0);
	SetEventHandler("CheckForRename","CheckForRename",0);

	
	SetEventHandler("MainCharacterPictureClick","MainCharacterPictureClick",0);
	SetEventHandler("ShipsScrollClick","ShipsScrollClick",0);

	SetEventHandler("ClickDiscardOkButton","ClickDiscardOkButton",0);
	SetEventHandler("AddDiscard","AddDiscard",0);
	SetEventHandler("RemoveDiscard","RemoveDiscard",0);
	SetEventHandler("MAXDiscard","MAXDiscard",0);
	SetEventHandler("MINDiscard","MINDiscard",0);

	SetEventHandler("AddCrewExchange","AddCrewExchange",0);
	SetEventHandler("RemoveCrewExchange","RemoveCrewExchange",0);

	SetEventHandler("FTChange","ScrollPosChange",0);
	SetEventHandler("eSlideChange","ChangeDiscardProgress",0);

	SetEventHandler("ShowManageGoodsWindow","ShowManageGoodsWindow",0);
	SetEventHandler("HideManageGoodsWindow","HideManageGoodsWindow",0);
	SetEventHandler("ClickExchangeGoods","ClickExchangeGoods",0);
	SetEventHandler("ClickExchangeGoodsCancel","ClickExchangeGoodsCancel",0);

	SetEventHandler("ClickCaptainTab","ClickCaptainTab",0);
	SetEventHandler("ClickCrewTab","ClickCrewTab",0);

	SetEventHandler("ChangeCaptain","ChangeCaptain",0);
	SetEventHandler("acceptofficer","acceptofficer",0);
	SetEventHandler("ExitOfficerMenu","ExitOfficerMenu",0);

	SetEventHandler("removeShip", "removeShip", 0);
	SetEventHandler("RaiseMorale", "ShowRaiseMoraleWindow", 0);
	SetEventHandler("HideRaiseMorale", "HideRaiseMoraleWindow", 0);
	SetEventHandler("MakeRaiseMorale", "MakeRaiseMorale", 0);

	SetEventHandler("HideExchangeCrewWindow", "HideExchangeCrewWindow", 0);
	SetEventHandler("ShowExchangeCrewWindow", "ShowExchangeCrewWindow", 0);
	SetEventHandler("ExchangeGoodAction", "ExchangeGoodAction", 0);

	SetEventHandler("wndChangeSails", "wndChangeSails", 0);
	SetEventHandler("ChangeSails", "ChangeSails", 0);
	SetEventHandler("ChangeSelectScrollImage", "ChangeSelectScrollImage", 0);
	
	SetEventHandler("ShowSkillInfo", "ShowSkillInfo", 0);
	SetEventHandler("ShowUpgradeInfo", "ShowUpgradeInfo", 0);
	//SetEventHandler("ShowCompanionInfo", "ShowCompanionInfo", 0);
	SetEventHandler("ShowCrewTooltip","ShowCrewTooltip",0);
	SetEventHandler("ShowFlowDescription","ShowFlowDescription",0);
	SetEventHandler("Exchange_TakeAll","Exchange_TakeAll",0);

	ProcessFrame();
	SetSelectable("SHIPS_BUTTON", false);


	if(sti(pchar.colony_quantity) == 0)
	{
		SetSelectable("COLONIES_BUTTON", false);
	}
	else
	{
		SetSelectable("COLONIES_BUTTON", true);
	}

	SetSelectable("DISCARD_GOODS", false);
	SetSelectable("DISCARD_SLIDE", false);
	SetSelectable("DISCARD_ADD_BUTTON", false);
	SetSelectable("DISCARD_REMOVE_BUTTON", false);
	SetSelectable("DISCARD_MAX_BUTTON", false);
	SetSelectable("DISCARD_MIN_BUTTON", false);


	if(GetCompanionQuantity(pchar) < 2)
	{
		SetSelectable("MANAGE_GOODS", false);
	}
	else
	{
		if(bSeaActive == true && isEnemyAround == true)
		{
			SetSelectable("MANAGE_GOODS", false);
		}
		else
		{
			SetSelectable("MANAGE_GOODS", true);
		}
	}
	
	ClickCaptainTab();

	if(GetCompanionQuantity(pchar) > 1)
	{
		SetSelectable("EXCHANGE_CREW_BUTTON", true);
	}
	else
	{
		SetSelectable("EXCHANGE_CREW_BUTTON", false);
	}

	XI_RegistryExitKey("IExit_F2");
}
//----------------------------------------------------------------------------------------------------
void IDoExit(int exitCode, bool bCode)
{
	DelEventHandler("GetInterfaceTexture", "ScrollGetTexture");
	DelEventHandler("InterfaceBreak","ProcessCancelExit");
	DelEventHandler("frame","ProcessFrame");
	DelEventHandler("exitOk","ProcessOkExit");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("ievnt_command","ProcessCommandExecute");

	DelEventHandler("ShowGoodsInfo","ShowInfoWindow_Goods");
	DelEventHandler("ShowShipInfo","ShowInfoWindow_Ship");
	//DelEventHandler("FormatedTextActivate","OnSelectList");
	DelEventHandler("MouseRClickUp","HideInfoWindow");

	DelEventHandler("confirmShipChangeName","confirmShipChangeName");
	DelEventHandler("CheckForRename","CheckForRename");

	DelEventHandler("MainCharacterPictureClick","MainCharacterPictureClick");
	DelEventHandler("ShipsScrollClick","ShipsScrollClick");

	//DelEventHandler("showDiscardWindow","showDiscardWindow");
	DelEventHandler("ClickDiscardOkButton","ClickDiscardOkButton");
	//DelEventHandler("ClickDiscardCancelButton","hideDiscardWindow");

	DelEventHandler("AddDiscard","AddDiscard");
	DelEventHandler("RemoveDiscard","RemoveDiscard");
	DelEventHandler("MAXDiscard","MAXDiscard");
	DelEventHandler("MINDiscard","MINDiscard");

	DelEventHandler("AddCrewExchange","AddCrewExchange");
	DelEventHandler("RemoveCrewExchange","RemoveCrewExchange");
	
	DelEventHandler("FTChange","ScrollPosChange");
	DelEventHandler("eSlideChange","ChangeDiscardProgress");

	DelEventHandler("ShowManageGoodsWindow","ShowManageGoodsWindow");
	DelEventHandler("HideManageGoodsWindow","HideManageGoodsWindow");

	DelEventHandler("ClickExchangeGoods","ClickExchangeGoods");
	DelEventHandler("ClickExchangeGoodsCancel","ClickExchangeGoodsCancel");

	DelEventHandler("ClickCaptainTab","ClickCaptainTab");
	DelEventHandler("ClickCrewTab","ClickCrewTab");

	DelEventHandler("ChangeCaptain","ChangeCaptain");
	DelEventHandler("acceptofficer","acceptofficer");
	DelEventHandler("ExitOfficerMenu","ExitOfficerMenu");
	DelEventHandler("removeShip", "removeShip");
	DelEventHandler("RaiseMorale", "ShowRaiseMoraleWindow");
	DelEventHandler("HideRaiseMorale", "HideRaiseMoraleWindow");
	DelEventHandler("MakeRaiseMorale", "MakeRaiseMorale");
	DelEventHandler("HideExchangeCrewWindow", "HideExchangeCrewWindow");
	DelEventHandler("ShowExchangeCrewWindow", "ShowExchangeCrewWindow");
	DelEventHandler("ExchangeGoodAction", "ExchangeGoodAction");

	DelEventHandler("wndChangeSails", "wndChangeSails");
	DelEventHandler("ChangeSails", "ChangeSails");
	DelEventHandler("ChangeSelectScrollImage", "ChangeSelectScrollImage");

	DelEventHandler("ShowSkillInfo", "ShowSkillInfo");

	DelEventHandler("ShowUpgradeInfo", "ShowUpgradeInfo");
	//DelEventHandler("ShowCompanionInfo", "ShowCompanionInfo");

	DelEventHandler("ShowCrewTooltip","ShowCrewTooltip");
	DelEventHandler("ShowFlowDescription","ShowFlowDescription");

	DelEventHandler("Exchange_TakeAll","Exchange_TakeAll");

	interfaceResultCommand = exitCode;
	EndCancelInterface(bCode);

	if( bSeaActive && !bAbordageStarted ) {
		RefreshBattleInterface();
	}
}
//----------------------------------------------------------------------------------------------------
void ProcessFrame()
{
	string attributeName;
	int iCharacter;

	string sNode = GetCurrentNode();
	if(sNode == "SHIPS_SCROLL")
	{
		if(sti(GameInterface.SHIPS_SCROLL.current)!= nCurScrollNum)
		{
			nCurScrollNum = sti(GameInterface.SHIPS_SCROLL.current);

			attributeName = "pic" + (nCurScrollNum+1);

			iCharacter = sti(GameInterface.SHIPS_SCROLL.(attributeName).character);


			if(iCharacter > 0)
			{
				string sChrId = characters[iCharacter].id;

				refCharacter = characterFromID(sChrId);
				shipIndex= nCurScrollNum+ 1;
				if (shipIndex< 0) 
				{
					shipIndex= 0;
				}
				OnShipScrollChange();
			} 
			else 
			{

				shipIndex= -1;
			}
			return;
		}
	}

	if(sNode == "EXCHANGE_SCROLL")
	{
		if(sti(GameInterface.EXCHANGE_SCROLL.current) != nExchangeCurScrollNum)
		{
			nExchangeCurScrollNum = sti(GameInterface.EXCHANGE_SCROLL.current);
			attributeName = "pic" + (nExchangeCurScrollNum+1);

			iCharacter = sti(GameInterface.EXCHANGE_SCROLL.(attributeName).character);
			refExCharacter = &characters[iCharacter];
			int iShip = sti(refExCharacter.ship.type);
			iShip = sti(RealShips[iShip].basetype);
			string sShip = ShipsTypes[iShip].name;
			SetNewPicture("EXCHANGE_WINDOW_TARGET_PICTURE", "interfaces\ships\" + sShip + ".tga");
			FillExchangeInfo();
			//StoreExchangeGoodsData(true);
		}
	}
	if(sNode == "EXCHANGE_CREW_SCROLLER")
	{
		if(sti(GameInterface.EXCHANGE_CREW_SCROLLER.current) != nCrewCurScrollNum)
		{
			nCrewCurScrollNum = sti(GameInterface.EXCHANGE_CREW_SCROLLER.current);
			attributeName = "pic" + (nCrewCurScrollNum+1);

			iCharacter = sti(GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).character);
			refExCharacter = &characters[iCharacter];
			SetNewPicture("EXCHANGE_CREW_OTHER_SHIP", "interfaces\portraits\256\face_" + refExCharacter.FaceId + ".tga");
			UpdateExchangeCrewInfo();
			StoreCrewData(true);
		}
	}

	if(sNode == "OFFICER_WINDOW_PASSENGERSLIST")
	{
		if(sti(GameInterface.OFFICER_WINDOW_PASSENGERSLIST.current) != nCurScrollOldNum)
		{
			nCurScrollOldNum = sti(GameInterface.OFFICER_WINDOW_PASSENGERSLIST.current);
			RefreshOfficerWindow();
		}
	}
}

//----------------------------------------------------------------------------------------------------
void MainCharacterPictureClick()
{
	shipIndex= 0;
	if(CheckAttribute(&Gameinterface, "MAIN_CHARACTER_PICTURE.character"))
	{
		refCharacter = CharacterFromID(Gameinterface.MAIN_CHARACTER_PICTURE.character);
	}
	else
	{
		refCharacter = pchar;
	}
	SetCurrentNode("SHIPS_SCROLL");
	if(sti(refCharacter.ship.type) != SHIP_NOTUSED)
	{
		OnShipScrollChange();
	}
}
//----------------------------------------------------------------------------------------------------
void ShipsScrollClick()
{
	
	SetCurrentNode("SHIPS_SCROLL");
	nCurScrollNum= -1;
	ProcessFrame();

	//SetCurrentNode("SHIPS_SCROLL_RECTANGLE");
}
//----------------------------------------------------------------------------------------------------

void ProcessCancelExit()
{
	IDoExit(RC_INTERFACE_SHIPSTATE_EXIT, true);
}

void ProcessOkExit()
{
	
}



void ProcessCommandExecute()
{
	string comName = GetEventData();
	string nodName = GetEventData();

	switch(nodName)
	{
		case "CHARACTERS_BUTTON":
			if(comName=="click")
			{
				IDoExit(RC_INTERFACE_TO_CHAR, true);
				return;
			}
		break;
		
		case "SHIPS_BUTTON":
			if(comName=="click")
			{
				IDoExit(RC_INTERFACE_TO_SHIP, true);
				return;
			}
		break;
		
		case "JOURNAL_BUTTON":
			if(comName=="click")
			{
				IDoExit(RC_INTERFACE_TO_LOGBOOK, true);
				return;
			}
		break;
		
		case "COLONIES_BUTTON":
			if(comName=="click")
			{
				IDoExit(RC_INTERFACE_TO_COLONY, true);
				return;
			}
		break;
		
		case "ITEMS_BUTTON":
			if(comName=="click")
			{
				IDoExit(RC_INTERFACE_TO_ITEMS, true);
				return;
			}
		break;

	}
}

void FillShipsScroll()
{
	nCurScrollNum = -1;
	if(!CheckAttribute(&GameInterface,"SHIPS_SCROLL.current"))
	{
		GameInterface.SHIPS_SCROLL.current = 0;
	}

	string attributeName;
	string shipName;
	int iShipType, cn;
	GameInterface.SHIPS_SCROLL.ImagesGroup.t0 = "BLANK_SHIP2";

	FillShipList("SHIPS_SCROLL.ImagesGroup", refCharacter);
	GameInterface.SHIPS_SCROLL.BadTex1 = 0;
	GameInterface.SHIPS_SCROLL.BadPic1 = "Not Used2";

	int m = 0;
	for(int i = 0; i < COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(refCharacter, i);
		if(cn != -1)
		{
			iShipType = sti(characters[cn].ship.type);
			if(iShipType != SHIP_NOTUSED)
			{
				attributeName = "pic" + (m+1);
				iShipType = sti(RealShips[iShipType].basetype);
				shipName = ShipsTypes[iShipType].Name;

				GameInterface.SHIPS_SCROLL.(attributeName).character = cn;
				GameInterface.SHIPS_SCROLL.(attributeName).str1 = "#"+ShipsTypes[iShipType].Class;
				GameInterface.SHIPS_SCROLL.(attributeName).str2 = shipName;
				GameInterface.SHIPS_SCROLL.(attributeName).img1 = "ship";
				GameInterface.SHIPS_SCROLL.(attributeName).tex1 = FindFaceGroupNum("SHIPS_SCROLL.ImagesGroup","SHIPS_"+shipName);
				m++;
			}
		}
		/*else
		{
			GameInterface.SHIPS_SCROLL.(attributeName).character = -1;
			GameInterface.SHIPS_SCROLL.(attributeName).str1 = "# ";
			GameInterface.SHIPS_SCROLL.(attributeName).str2 = "# ";
			GameInterface.SHIPS_SCROLL.(attributeName).img1 = "Not Used2";
			GameInterface.SHIPS_SCROLL.(attributeName).tex1 = 0;
		}*/
	}

	GameInterface.SHIPS_SCROLL.ListSize = m;
	GameInterface.SHIPS_SCROLL.NotUsed = 5 - m + 1;
}

void OnShipScrollChange()
{
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIPQUANTITYLIST", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIPPRICELIST", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"STOREWEIGHT", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"BESTSELL", 1, 0);

	SetSelectable("REMOVE_SHIP", false);
	//Ship info window
	int iShip = sti(refCharacter.ship.type);
	iShip = sti(RealShips[iShip].basetype);
	string sShip = ShipsTypes[iShip].name;
	SetNewPicture("SHIP_BIG_PICTURE", "interfaces\ships\" + sShip + ".tga");

	SetNewPicture("MAIN_CHARACTER_PICTURE", "interfaces\portraits\64\face_" + refCharacter.FaceId + ".tga");
	GameInterface.strings.CharacterName = refCharacter.name;
	GameInterface.strings.CharacterFamily = refCharacter.lastname;
	Gameinterface.MAIN_CHARACTER_PICTURE.character = refCharacter.id;

	string sText, sTextSecond;
	int nShipType = sti(refcharacter.ship.type);
    ref refBaseShip = GetRealShip(nShipType);
	GameInterface.edit_box.str = refcharacter.ship.name;

	////////////////////////////
	/// BEGIN NEW
	////////////////////////////
	int iColor, iFood;
	int iShipCapacity = GetCargoMaxSpace(refCharacter);
	sText  = iShipCapacity;
	int iRealShipCapacity = GetCargoLoad(refCharacter);
	if(sti(refCharacter.ship.crew.quantity) > sti(refBaseShip.maxCrew))
	{
		iRealShipCapacity = iRealShipCapacity - (sti(refCharacter.ship.crew.quantity) - sti(refBaseShip.maxCrew));
	}
	//iRealShipCapacity = iShipCapacity - iRealShipCapacity;
	sText = XI_ConvertString("Capacity") + ": " + iRealShipCapacity + " / " + sText;
	SetFormatedText("CARGO", sText);
	sText = XI_ConvertString("Food") + ": ";
	iFood = CalculateFood();
	sText = sText + FindRussianDaysString(iFood);
	SetFormatedText("FOOD", sText);
	if(iFood >= 5)
	{
		iColor = argb(255,255,255,192);
	}
	if(iFood > 10)
	{
		iColor = argb(255,192,255,192);
	}
	if(iFood < 5)
	{
		iColor = argb(255,255,192,192);
	}
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"FOOD", 8,-1,iColor);
	////////////////////////////
	/// END NEW
	////////////////////////////

	sText  = XI_ConvertString(ShipsTypes[sti(refBaseShip.basetype)].name) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,0,&sText);

	sText  = ShipsTypes[sti(refBaseShip.basetype)].Class + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,1,&sText);

	sText  = sti(refCharacter.ship.hp) + " / " + sti(refBaseShip.hp) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,2,&sText);

	sText = sti(refCharacter.ship.sp) + " / " + sti(refBaseShip.sp) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,3,&sText);

	sText = fts(FindShipSpeed(refCharacter),3) + " / " + fts(stf(refBaseShip.SpeedRate),3) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,4,&sText);

	float fTurnRate;
	fTurnRate = stf(refBaseShip.turnrate) * FindShipTurnRate(refCharacter);
	sText  = fts(fTurnRate,3) + " / " + fts(stf(refBaseShip.TurnRate),3) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,5,&sText);

	sText = sti(refCharacter.ship.crew.quantity) + " / " + sti(refBaseShip.MaxCrew) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,6,&sText);
	if(GetShipDiseaseTime(refCharacter) > 1)
	{
		iColor = argb(255,145,220,250);
	}
	else
	{
		iColor = argb(255,255,255,255);
	}
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 8,6,iColor);
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 8,6,iColor);

	sText = GetCannonsNum(refCharacter) + " / " + sti(refBaseShip.CannonsQuantity) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,7,&sText);

	if(CheckForFlow(refCharacter) > 0)
	{
		SetClickable("MAIN_WINDOW_FLOW_PICTURE", true);
		SetNewGroupPicture("MAIN_WINDOW_FLOW_PICTURE", "SOME_ICONS", "flow");
		//sText = XI_ConvertString("yes") + " ";
		//iColor = argb(255,255,192,192);
	}
	else
	{
		SetClickable("MAIN_WINDOW_FLOW_PICTURE", false);
		SetNewGroupPicture("MAIN_WINDOW_FLOW_PICTURE", "SOME_ICONS", "");
		//sText = XI_ConvertString("no") + " ";
		//iColor = argb(255,255,255,255);
	}
	//SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 10,8,&sText);
	//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 8,8,iColor);
	//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 8,8,iColor);

	
	if(CheckAttribute(refCharacter, "quest.convoyquest"))
	{
		//sText = XI_ConvertString("YouNeedToEscortThisShipTo") + XI_ConvertString("Colony"+refCharacter.quest.convoyquest.colony) + XI_ConvertString("until") + refCharacter.quest.convoyquest.date + ".";
		SetNewGroupPicture("MAIN_WINDOW_QUEST_PICTURE", "SOME_ICONS", "Quest");
		//iColor = argb(255,255,192,255);
	}
	else
	{
		SetNewGroupPicture("MAIN_WINDOW_QUEST_PICTURE", "SOME_ICONS", "");
		//sText = XI_ConvertString("ThisShipIsMemberOfYourSquadron");
		//sText = XI_ConvertString("no") + " ";
		//iColor = argb(255,255,255,255);
	}
	//SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 10,9,&sText);
	//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO_TEXT", 8,9,iColor);
	//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO", 8,9,iColor);
	

	string sHullUpgr;
	sHullUpgr = "HULL_UPGRADE_" + refCharacter.ship.upgrades.hull;
	SetNewGroupPicture("MAIN_WINDOW_OUR_UPGRADE_HULL", sHullUpgr, "hull");

	string sSailsUpgr;
	sSailsUpgr = "SAILS_UPGRADE_" + refCharacter.ship.upgrades.sails;
	SetNewGroupPicture("MAIN_WINDOW_OUR_UPGRADE_SAILS", sSailsUpgr, "sails");

	string sCannonsUpgr;
	string sCannonsType;
	sCannonsUpgr= "CANNONS_UPGRADE_" + refCharacter.ship.upgrades.cannons;
	int iOurCannonType = sti(refCharacter.ship.cannons.type);
	sCannonsType = Cannon[iOurCannonType].picture;
	SetNewGroupPicture("MAIN_WINDOW_OUR_UPGRADE_CANNONS", sCannonsUpgr, sCannonsType);
	
	UpdateGoodsList();
	ClickCaptainTab();

	SetSelectable("DISCARD_GOODS", false);
	SetSelectable("DISCARD_SLIDE", false);
	SetSelectable("DISCARD_ADD_BUTTON", false);
	SetSelectable("DISCARD_REMOVE_BUTTON", false);
	SetSelectable("DISCARD_MAX_BUTTON", false);
	SetSelectable("DISCARD_MIN_BUTTON", false);
}

void FillGoodsList()
{
	int m, i, t, k, l;
	string sGood;
	string sBuy, sSell, sShipQ, sStoreQ, sStoreWeight, sGoodR, sBoard;
	int tradetype;
	aref refGoods;
	m = 0;
	k = 1;
	l = 0;

	SetFormatedText("SHIPTRADELIST", "");
	SetFormatedText("SHIPQUANTITYLIST", "");
	SetFormatedText("SHIPPRICELIST", "");
	SetFormatedText("STOREWEIGHT", "");
	SetFormatedText("BESTSELL", "");

	for(i = 0; i< GOODS_QUANTITY; i++)
	{
		sGood = Goods[i].name;
		sShipQ = GetCargoGoods(refCharacter, i);
		if(sti(sShipQ) > 0)
		{
			GoodsList[m].index = i;
			m++;
		}
	}

	for(i = 0; i< GOODS_QUANTITY; i++)
	{
		sGood = Goods[i].name;
		sShipQ = GetCargoGoods(refCharacter, i);
		if(sti(sShipQ) < 1)
		{
			GoodsList[m].index = i;
			m++;
		}
	}

	int iColor;

	for(i = 0; i<GOODS_QUANTITY; i++)
	{
			iGoodIndex = sti(GoodsList[i].index);
			sGood = goods[iGoodIndex].name;
			iColor = COLOR_NORMAL;

			if(CheckAttribute(&goods[iGoodIndex], "type"))
			{
				if(sti(goods[iGoodIndex].type) == TRADE_TYPE_AMMUNITION)
				{
					iColor = argb(255,192,192,192);
				}

				if(sti(goods[iGoodIndex].type) == TRADE_TYPE_CONTRABAND)
				{
					iColor = argb(255,200,125,125);
				}
			}
			if(CheckAttribute(pchar, "ship.cargo.goods." + sGood + ".isquest"))
			{
				iColor = argb(255,255,192,255);
			}

			sGoodR = " " + XI_ConvertString(sGood);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 0,&sGoodR);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,-1,iColor);

			sShipQ = GetCargoGoods(refCharacter,iGoodIndex);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIPQUANTITYLIST", 0,&sShipQ);

			if(CheckAttribute(refCharacter, "ship.cargo.goods." + sGood +".lastbuy"))
			{
				GoodsList[i].sell = refCharacter.ship.cargo.goods.(sGood).lastbuy;
			}
			else
			{
				GoodsList[i].sell = 0;
			}
			sSell = sti(GoodsList[i].sell);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIPPRICELIST", 0,&sSell);

			sStoreWeight = stf(goods[iGoodIndex].Weight)*stf(sShipQ)/stf(Goods[iGoodIndex].Units);
			sStoreWeight = "" + sti(sStoreWeight);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"STOREWEIGHT", 0, &sStoreWeight);

			sBoard = SearchForBestSell(iGoodIndex);
			sBoard = XI_ConvertString(sBoard);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"BESTSELL", 0, &sBoard);
	}
}

void UpdateGoodsList()
{	
	int m, i, t, k, l;
	string sGood;
	string sBuy, sSell, sShipQ, sStoreQ, sStoreWeight, sGoodR, sBoard;
	int tradetype;
	aref refGoods;
	m = 0;
	k = 1;
	l = 0;


	int iColor;

	for(i = 0; i<GOODS_QUANTITY; i++)
	{
			iGoodIndex = sti(GoodsList[i].index);
			sGood = goods[iGoodIndex].name;

			iColor = COLOR_NORMAL;
	
			if(CheckAttribute(&goods[iGoodIndex], "type"))
			{
				if(sti(goods[iGoodIndex].type) == TRADE_TYPE_AMMUNITION)
				{
					iColor = argb(255,192,192,196);
				}

				if(sti(goods[iGoodIndex].type) == TRADE_TYPE_CONTRABAND)
				{
					iColor = argb(255,200,125,125);
				}
			}

			if(CheckAttribute(pchar, "ship.cargo.goods." + sGood + ".isquest"))
			{
				iColor = argb(255,255,192,255);
			}

			sGoodR = " " + XI_ConvertString(sGood);
			SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 10,i,&sGoodR);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,i,iColor);	

			sShipQ = GetCargoGoods(refCharacter,iGoodIndex);
			SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIPQUANTITYLIST", 10,i,&sShipQ);

			if(CheckAttribute(refCharacter, "ship.cargo.goods." + sGood +".lastbuy"))
			{
				GoodsList[i].sell = refCharacter.ship.cargo.goods.(sGood).lastbuy;
			}
			else
			{
				GoodsList[i].sell = 0;
			}

			//sSell = fts(stf(GoodsList[i].sell), 1);
			//SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIPPRICELIST", 10,i,&sSell);

			sSell = sti(GoodsList[i].sell);
			SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIPPRICELIST", 10,i,&sSell);

			sStoreWeight = stf(goods[iGoodIndex].Weight)*stf(sShipQ)/stf(Goods[iGoodIndex].Units);
			sStoreWeight = "" + sti(sStoreWeight);
			SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"STOREWEIGHT", 10, i,&sStoreWeight);

			sBoard = SearchForBestSell(iGoodIndex);
			sBoard = XI_ConvertString(sBoard);
			SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"BESTSELL", 10, i, &sBoard);
			iGoodIndex = sti(GoodsList[0].index);
	}
}

/*void OnSelectList()
{
	string nodeName = GetEventData();

	if(nodeName == "SHIPTRADELIST" || nodeName == "SHIPQUANTITYLIST" || nodeName == "SHIPPRICELIST" || nodeName == "STOREWEIGHT" || nodeName == "BESTSELL")
	{
		iGoodIndex = GetEventData(); 
		iGoodIndex = sti(GoodsList[iGoodIndex].index);
		string sGoodName = Goods[iGoodIndex].name;
		SetDiscardSlider();
		if(sti(refCharacter.ship.cargo.goods.(sGoodName)) > 0)
		{
			if(GetShipRemovable(refCharacter) == 0 && refCharacter.id != pchar.id)
			{
				SetSelectable("DISCARD_SLIDE", false);
				SetSelectable("DISCARD_ADD_BUTTON", false);
				SetSelectable("DISCARD_REMOVE_BUTTON", false);
				SetSelectable("DISCARD_MAX_BUTTON", false);
				SetSelectable("DISCARD_MIN_BUTTON", false);
			}
			else
			{	
				SetSelectable("DISCARD_SLIDE", true);
				SetSelectable("DISCARD_ADD_BUTTON", true);
				SetSelectable("DISCARD_REMOVE_BUTTON", true);
				SetSelectable("DISCARD_MAX_BUTTON", true);
				SetSelectable("DISCARD_MIN_BUTTON", true);
			}
		}
		else
		{
			SetSelectable("DISCARD_SLIDE", false);
			SetSelectable("DISCARD_ADD_BUTTON", false);
			SetSelectable("DISCARD_REMOVE_BUTTON", false);
			SetSelectable("DISCARD_MAX_BUTTON", false);
			SetSelectable("DISCARD_MIN_BUTTON", false);
		}
		SetSelectable("DISCARD_GOODS", false);
	}


	if(nodeName == "SHIP_INFO" || nodeName == "SHIP_INFO_TEXT")
	{
		iGoodIndex = GetEventData(); 
		iGoodIndex = sti(GoodsList[iGoodIndex].index);
	}
}*/


void HideInfoWindow()
{	
	CloseTooltip();
	if(XI_IsWindowEnable("OFFICER_WINDOW") == true)
	{
		SetCurrentNode("OFFICER_WINDOW_CANCEL_BUTTON");
	}
	/*
	if(XI_IsWindowEnable("INFO_WINDOW") == true)
	{
		XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowShow("INFO_WINDOW", false);
		XI_WindowDisable("INFO_WINDOW", true);
	}
	*/
}


void ShowInfoWindow_Goods()
{
	//XI_WindowDisable("MAIN_WINDOW", true);
	//XI_WindowShow("INFO_WINDOW", true);
	//XI_WindowDisable("INFO_WINDOW", false);

	int lngFileID = LanguageOpenFile("GoodsDescribe.txt");
	string GoodName = goods[iGoodIndex].name;

	//SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString(GoodName));
	
	string goodsDescr = GetAssembledString( LanguageConvertString(lngFileID,goodName+"_descr"), &Goods[iGoodIndex]);
	
	
	string sText1, sText2, sText3, sPicture, sGroup, sGroupPicture;
	int iColor;

	if(checkAttribute(pchar, "ship.cargo.goods." + GoodName + ".isquest"))
	{
		string sTradeQ = pchar.ship.cargo.goods.(GoodName).isquest.quantity;
		string sColony = pchar.ship.cargo.goods.(GoodName).isquest.colony;
		sText2 = XI_ConvertString("YouNeedToDeliver") + sTradeQ + XI_ConvertString("units of this cargo on colony") + XI_ConvertString("Colony"+sColony) + ".";
		
		//SetFormatedText("INFO_WINDOW_GOODDESCRIBE", sText);
		iColor = argb(255,255,192,255);
		//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_GOODDESCRIBE", 8,-1,iColor);
	} 
	else 
	{
		if(sti(goods[iGoodIndex].type) == TRADE_TYPE_CONTRABAND)
		{
			iColor = argb(255,255,192,192);
			sText2 = XI_ConvertString("ColonyInfoContraband");
		}
		else
		{
		//SetFormatedText("INFO_WINDOW_GOODDESCRIBE", goodsDescr);

		iColor = argb(255,255,255,255);
		//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_GOODDESCRIBE", 8,-1,iColor);
		}
	}

	//SendMessage(&GameInterface,"lslss", MSG_INTERFACE_MSG_TO_NODE, "INFO_WINDOW_PICTURE" ,6, "goods", GoodName);

	sGroup = "GOODS";
	sGroupPicture = GoodName;
	SetNodeUsing("INFO_WINDOW_PICTURE", true);
	LanguageCloseFile(lngFileID);

	GoodName = XI_ConvertString(GoodName);

	CreateTooltip("#" + GoodName, goodsDescr, argb(255,255,255,255), sText2, iColor, sText3, argb(255,192,255,192), "", argb(255,255,255,255), sPicture, sGroup, sGroupPicture, 64, 64);
}



//------------------------------------------------------------------------------------------------

void ShowInfoWindow_Ship()
{

	if (shipIndex== -1) return;

	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowShow("INFO_WINDOW", true);
	XI_WindowDisable("INFO_WINDOW", false);

	SetFormatedText("INFO_WINDOW_GOODNAME", " ");	
	SetFormatedText("INFO_WINDOW_GOODDESCRIBE", " ");

	SetNodeUsing("INFO_WINDOW_PICTURE", false);

	string sText;
	int nShipType = sti(refCharacter.ship.type);
	ref refBaseShip = GetRealShip(nShipType);

	switch(iGoodIndex)
	{

		case 0: 
		break;

		case 1:
		break;

		case 2:
		break;
		
		case 3:
		break;
		
		case 4:
		break;

		case 5:
		break;

		case 6:
		break;

		case 7:
		break;

		case 8: 
		break;

		case 9:
		break;		

		case 10:
		break;

		case 11:
		break;	

		case 12:
		break;	
	}
}


void confirmShipChangeName()
{
	if (shipIndex== -1) return;

	bool isCheatCode = false;
	if(GameInterface.edit_box.str == "GodMode")
	{
		if(LAi_IsImmortal(pchar) == true)
		{
			LAi_SetImmortal(pchar, 0);
		}
		else
		{
			LAi_SetImmortal(pchar, 1);
		}
		isCheatCode = true;
	}
	if(GameInterface.edit_box.str == "ExpBooster")
	{
		AddPartyExp(pchar, 10000);
		isCheatCode = true;
	}
	if(GameInterface.edit_box.str == "MoneyBooster")
	{
		AddMoneyToCharacter(pchar, 10000);
		isCheatCode = true;
	}
	if(GameInterface.edit_box.str == "BestSaber")
	{
		GiveItem2Character(pchar, "blade18");
		isCheatCode = true;
	}
	if(GameInterface.edit_box.str == "BestGun")
	{
		GiveItem2Character(pchar, "gun7");
		isCheatCode = true;
	}
	if(isCheatCode == false)
	{
		refcharacter.ship.name = GameInterface.edit_box.str;
	}
	GameInterface.edit_box.str = refcharacter.ship.name;
	SetCurrentNode("SHIP_INFO_TEXT");
}

void CheckForRename()
{
	if(GetShipRemovable(refCharacter) == true && shipIndex!= -1)
	{
		SetCurrentNode("EDIT_BOX");
	}
}

//-----------------------------------------------------------------------------------------------------

void ClickDiscardOkButton()
{
	DropGoodsToSeaFromInterface(iDiscardValue);
	OnShipScrollChange();
	SetSelectable("DISCARD_GOODS", false);

	iDiscardValue = 0;
	string sText = " " + XI_ConvertString("Discard") + ": " + iDiscardValue;
	SetFormatedText("DISCARD_INFO_TEXT", sText);

	float fRes = 0;
	SendMessage(&GameInterface,"lslf",MSG_INTERFACE_MSG_TO_NODE,"DISCARD_SLIDE", 0,fRes);
	UpdateFoodAndCargoInfo();

}

void AddDiscard()
{
	string sGoodName = Goods[iGoodIndex].name;
	int iMaxGoods = sti(refCharacter.ship.cargo.goods.(sGoodName));
	if(iDiscardValue < iMaxGoods)
	{
		iDiscardValue = iDiscardValue + 1;
	}
	UpdateDiscardSlider();
}

void RemoveDiscard()
{
	if(iDiscardValue > 0)
	{
		iDiscardValue = iDiscardValue - 1;
	}
	UpdateDiscardSlider();
}

void MAXDiscard()
{
	string sGoodName = Goods[iGoodIndex].name;
	int iMaxGoods = sti(refCharacter.ship.cargo.goods.(sGoodName));
	iDiscardValue = iMaxGoods;
	UpdateDiscardSlider();
}

void MINDiscard()
{
	iDiscardValue = 0;
	UpdateDiscardSlider();
}

void SetDiscardSlider()
{
	string sGoodName = Goods[iGoodIndex].name;

	iDiscardValue = 0;

	int iMaxGoods = sti(refCharacter.ship.cargo.goods.(sGoodName));
	
	float fRes = 0;
	
	GameInterface.nodes.DISCARD_SLIDE.value = fRes;
	GameInterface.nodes.DISCARD_SLIDE.maxlimit = iMaxGoods;

	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"DISCARD_SLIDE", 1,iMaxGoods);
	SendMessage(&GameInterface,"lslf",MSG_INTERFACE_MSG_TO_NODE,"DISCARD_SLIDE", 0,fRes);

	string sText = " " + XI_ConvertString("Discard") + ": " + iDiscardValue;
	SetFormatedText("DISCARD_INFO_TEXT", sText);
}

void UpdateDiscardSlider()
{
	string sGoodName = Goods[iGoodIndex].name;
	int iMaxGoods = sti(refCharacter.ship.cargo.goods.(sGoodName));

	float fRes = makefloat(iDiscardValue) / makefloat(iMaxGoods);

	SendMessage(&GameInterface,"lslf",MSG_INTERFACE_MSG_TO_NODE,"DISCARD_SLIDE", 0,fRes);

	string sText = " " + XI_ConvertString("Discard") + ": " + iDiscardValue;
	SetFormatedText("DISCARD_INFO_TEXT", sText);

	if(iDiscardValue > 0)
	{
		SetSelectable("DISCARD_GOODS", true);
	}
	else
	{
		SetSelectable("DISCARD_GOODS", false);
	}
	UpdateFoodAndCargoInfo();
}

void UpdateFoodAndCargoInfo()
{
	string sText;
	int iColor;
	if(iGoodIndex == GOOD_FOOD)
	{
		sText = XI_ConvertString("Food") + ": ";
		int iFood = CalculateFoodEx(-iDiscardValue);
		sText = sText + FindRussianDaysString(iFood);
		SetFormatedText("FOOD", sText);
		if(iFood >= 5)
		{
			iColor = argb(255,255,255,192);
		}
		if(iFood > 10)
		{
			iColor = argb(255,192,255,192);
		}
		if(iFood < 5)
		{
			iColor = argb(255,255,192,192);
		}
		SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"FOOD", 8,-1,iColor);
	}

	int nShipType = sti(refCharacter.ship.type);
    ref refBaseShip = GetRealShip(nShipType);
	int iShipCapacity = GetCargoMaxSpace(refCharacter);
	sText  = iShipCapacity;
	int iRealShipCapacity = GetCargoLoadEx(refCharacter, -iDiscardValue, iGoodIndex);
	if(sti(refCharacter.ship.crew.quantity) > sti(refBaseShip.maxCrew))
	{
		iRealShipCapacity = iRealShipCapacity - (sti(refCharacter.ship.crew.quantity) - sti(refBaseShip.maxCrew));
	}
	//iShipCapacity = iShipCapacity - iRealShipCapacity;
	iShipCapacity = iRealShipCapacity;
	sText = XI_ConvertString("Capacity") + ": " + iShipCapacity + " / " + sText;
	SetFormatedText("CARGO", sText);


	sText = fts(FindShipSpeedEx(refCharacter,-iDiscardValue, iGoodIndex),3) + " / " + fts(stf(refBaseShip.SpeedRate),3) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,4,&sText);

	float fTurnRate;
	fTurnRate = stf(refBaseShip.turnrate) * FindShipTurnRateEx(refCharacter,-iDiscardValue, iGoodIndex);
	sText  = fts(fTurnRate,3) + " / " + fts(stf(refBaseShip.TurnRate),3) + " ";
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_INFO",10,5,&sText);
}

void UpdateDiscardSliderWithoutUpdate()
{
	string sGoodName = Goods[iGoodIndex].name;
	int iMaxGoods = sti(refCharacter.ship.cargo.goods.(sGoodName));

	string sText = " " + XI_ConvertString("Discard") + ": " + iDiscardValue;
	SetFormatedText("DISCARD_INFO_TEXT", sText);

	if(iDiscardValue > 0)
	{
		SetSelectable("DISCARD_GOODS", true);
	}
	else
	{
		SetSelectable("DISCARD_GOODS", false);
	}
	UpdateFoodAndCargoInfo();
}


void ScrollPosChange()
{
	string sTemp = GetEventData();
	float newPos = GetEventData();
	string sGoodName;

	if(sTemp == "SHIPTRADELIST" || sTemp == "SHIPQUANTITYLIST" || sTemp == "SHIPPRICELIST" || sTemp == "STOREWEIGHT" || sTemp == "BESTSELL")
	{
		iStep = makeint((GOODS_QUANTITY - 1) * newPos);
		SetDiscardSlider();
		/*if(!CheckAttribute(&GoodsList[iStep], "index"))
		{
			return;
		}*/
		iGoodIndex = sti(GoodsList[iStep].index);
		sGoodName = Goods[iGoodIndex].name;
		if(sti(refCharacter.ship.cargo.goods.(sGoodName)) > 0)
		{
			if(GetShipRemovable(refCharacter) == 0 && refCharacter.id != pchar.id)
			{
				SetSelectable("DISCARD_SLIDE", false);
				SetSelectable("DISCARD_ADD_BUTTON", false);
				SetSelectable("DISCARD_REMOVE_BUTTON", false);
				SetSelectable("DISCARD_MAX_BUTTON", false);
				SetSelectable("DISCARD_MIN_BUTTON", false);
			}
			else
			{
				SetSelectable("DISCARD_SLIDE", true);
				SetSelectable("DISCARD_ADD_BUTTON", true);
				SetSelectable("DISCARD_REMOVE_BUTTON", true);
				SetSelectable("DISCARD_MAX_BUTTON", true);
				SetSelectable("DISCARD_MIN_BUTTON", true);
			}
		}
		SetSelectable("DISCARD_GOODS", false);
		return;
	}

	if(sTemp == "EXCHANGE_CREW_CREW_TEXT")
	{
		UpdateCrewCounterPos( SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 11) );
	}

	float fStep = 0.0;

	if(sTemp == "EXCHANGE_SHIPTRADELIST")
	{
		fStep = iExchangeStringsQuantity * newPos;
		fStep = fStep + 0.5;
		iStep = sti(fStep);
		if(iPrevStep != iStep)
		{
			SetExchangeGoodCounterPos();
			UpdateWantTo();
			iPrevStep = iStep;
		}
	}
}

void ChangeDiscardProgress()
{
	string sNode = GetEventData();
	//iDiscardValue = GetEventData();
	float fRelativy;
	
	if(sNode == "DISCARD_SLIDE")
	{
		iDiscardValue = GetEventData();
		fRelativy = GetEventData();
		UpdateDiscardSliderWithoutUpdate();
	}
}

void DropGoodsToSeaFromInterface(int iQuantity)
{
	ref rGood;
	string sGood;

	sGood = Goods[iGoodIndex].name;

	if(CheckAttribute(refCharacter, "Ship.Cargo.Goods."+sGood))
	{		
		RemoveCharacterGoods(refCharacter, iGoodIndex, iQuantity);

		iQuantity = iQuantity / sti(Goods[iGoodIndex].Units);


		int iSwimQuantity = rand(iQuantity/4) + rand(iQuantity/4) + rand(iQuantity/4) + rand(iQuantity/4);

		if(iSwimQuantity < 1)
		{
			iSwimQuantity = 1;
		}

		RecalculateCargoLoad(refCharacter);

		if (CheckAttribute(&Goods[iGoodIndex], "Swim") && bSeaActive == 1) 
		{ 
			float fTime = stf(Goods[iGoodIndex].Swim.Time);
			string sModel = Goods[iGoodIndex].Swim.Model;

			trace ("sModel is " + sModel);

			fTime = fTime + (frnd() - 0.5) * fTime / 2.0;

			AISeaGoods_AddGood(refCharacter, sGood, sModel, fTime * 60.0, iSwimQuantity);
		}
		return;
	}
}

void ShowManageGoodsWindow()
{
	XI_WindowDisable("TABS_WINDOW", true);
	XI_WindowDisable("CREW_WINDOW", true);
	XI_WindowDisable("CAPTAIN_WINDOW", true);
	XI_WindowDisable("GOODS_WINDOW", true);
	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowShow("EXCHANGE_WINDOW", true);
	XI_WindowDisable("EXCHANGE_WINDOW", false);

	FillExchangeShipsScroll();
	FillExchangeInfo();
	//StoreExchangeGoodsData(true);

	string sText = XI_ConvertString("SwapGoods");
	SetFormatedText("EXCHANGE_WINDOW_CAPTION", sText);

	int iShip = sti(refCharacter.ship.type);
	iShip = sti(RealShips[iShip].basetype);
	string sShip = ShipsTypes[iShip].name;
	SetNewPicture("EXCHANGE_WINDOW_PICTURE", "interfaces\ships\" + sShip + ".tga");

	//EI_CreateFrame("EXCHANGE_SHIP_BORDERS",482,209,546,273);
	//EI_CreateFrame("EXCHANGE_SHIP_BORDERS",253,209,317,273);

	SetCurrentNode("EXCHANGE_SCROLL");

	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_TITLE_GOODS_OUR", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_TITLE_GOODS_OTHER", 5 );
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_TITLE_GOODS_NAME", 5 );

	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_HINT_TEXT", 5 );

	SetFormatedtext("YOU_WANT_TO", "");
	string sGood = goods[sti(GoodsListExchange[0].index)].name;
	sText = XI_ConvertString("Take goods") + " " + XI_ConvertString(sGood) + ": 0";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);

	sText = XI_ConvertString("Give goods") + " " + XI_ConvertString(sGood) + ": 0";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);

	iStep = 0;
	SetExchangeGoodCounterPos();

	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 7, "#"+XI_ConvertString("Capacity") + ": ");
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 8, "#"+XI_ConvertString("Capacity") + ": ");

	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 1, "#"+XI_ConvertString("Speed") + ": ");
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 2, "#"+XI_ConvertString("Maneuver") + ": ");

	SetShipCapacity();
	SetShipSpeedManeuver();

	HideGoods(false);

	ProcessFrame();

}

void FillExchangeInfo()
{
	string sText;
	int iColor;
	string sShip = "";
	if(GetShipRemovable(refExCharacter) == 0 && refExCharacter.id != pchar.id)
	{
		sShip = "'" + refExCharacter.ship.name + "'";
	}
	if(GetShipRemovable(refCharacter)  == 0 && refCharacter.id != pchar.id)
	{
		sShip = "'" + refCharacter.ship.name + "'";
	}
	if(GetShipRemovable(refExCharacter) == 1 && GetShipRemovable(refCharacter) == 1)
	{
		sText = XI_ConvertString("AllOperationsAllowed");
		iColor = argb(255,192,255,192);
	}
	else
	{
		sText = XI_ConvertString("Captain") + " '" + sShip + "' " + XI_ConvertString("AddOperationsAllowed");
		iColor = argb(255,255,192,192);
	}
	SetFormatedText("EXCHANGE_SHIP_WARNING", sText);
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIP_WARNING", 8,-1,iColor);
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIP_WARNING", 5 );

	FillExchangeGoodsList();

	sText = "'" + refCharacter.ship.name  + "'";
	SetFormatedText("EXCHANGE_WINDOW_SHIP1", sText);
	sText = "'" + refExCharacter.ship.name + "'";
	SetFormatedText("EXCHANGE_WINDOW_SHIP2", sText);
}

void HideManageGoodsWindow()
{
	//StoreExchangeGoodsData(false);
	ExitFromManageGoodsWindow();

	SetCurrentNode("SHIPS_SCROLL");
}

void ExitFromManageGoodsWindow()
{
	XI_WindowDisable("TABS_WINDOW", false);
	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("GOODS_WINDOW", false);
	XI_WindowShow("EXCHANGE_WINDOW", false);
	XI_WindowDisable("CREW_WINDOW", false);
	XI_WindowDisable("CAPTAIN_WINDOW", false);
	XI_WindowDisable("EXCHANGE_WINDOW", true);

	iGoodsChange = 0;

	UpdateGoodsList();
	UpdateFoodAndCargoInfo();
}

/*void StoreExchangeGoodsData(bool bStore)
{
	int n;
	string stmp;
	if( bStore ) { // 
		for( n=0; n<GOODS_QUANTITY; n++ ) {
			stmp = Goods[n].name;
			objStoreData.ourShipGoods.(stmp) = GetCargoGoods(refCharacter,n);
			objStoreData.otherShipGoods.(stmp) = GetCargoGoods(refExCharacter,n);
		}
		SetSelectable("EXCHANGE_WINDOW_OK_BUTTON", false);
	} else { //   
		for( n=0; n<GOODS_QUANTITY; n++ ) {
			stmp = Goods[n].name;
			refCharacter.Ship.Cargo.Goods.(stmp) = objStoreData.ourShipGoods.(stmp);
			refExCharacter.Ship.Cargo.Goods.(stmp) = objStoreData.otherShipGoods.(stmp);
		}
		RecalculateCargoLoad(refCharacter);
		RecalculateCargoLoad(refExCharacter);
	}
}*/

void SetExchangeGoodCounterPos()
{
	int nY = SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPTRADELIST", 12,iStep);

	if( nY < 0 ) 
	{
		return;
	}

	int pic_top;
	int pic_bottom;
	
	pic_top = nY - 1;
	pic_bottom = nY + 18;

	//307,317,485,335
	
	SendMessage(&GameInterface,"lsllllll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_COUNTER", -1, 4, 307,pic_top, 485,pic_bottom);

	SendMessage( &GameInterface,"lslllll",MSG_INTERFACE_MSG_TO_NODE,"TOP_HIDER", 0, 236,296,546,nY-2);
	SendMessage( &GameInterface,"lslllll",MSG_INTERFACE_MSG_TO_NODE,"BOTTOM_HIDER", 0, 236,nY+19,546,400);
}

void UpdateWantTo()
{
	SetFormatedText("YOU_WANT_TO", "");
	string sText;
	string sGood = goods[sti(GoodsListExchange[iStep].index)].name;
	sText = XI_ConvertString("Take goods") + " " + XI_ConvertString(sGood) + ": 0";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);

	sText = XI_ConvertString("Give goods") + " " + XI_ConvertString(sGood) + ": 0";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);
}

void ExchangeGoodAction()
{
	int nComIdx = GetEventData();
	if( nComIdx==ACTION_LEFTSTEP ) 
	{
		ExchangeGoodInOut( true );
		return;
	}
	if( nComIdx==ACTION_RIGHTSTEP ) 
	{
		ExchangeGoodInOut( false );
		return;
	}
}

void ExchangeGoodInOut( bool bIncomeGoods )
{
	int nGood = sti(GoodsListExchange[iStep].index);
	int nQ = 1;

	if(bIncomeGoods) 
	{
		//  
		rIn = refCharacter;
		rOut = refExCharacter;

		if( XI_IsKeyPressed("shift") )
		{
			nQ = GetCargoGoods(rOut,nGood) - iGoodsChange;
		}
	} 
	else 
	{ 
		//   
		rIn = refExCharacter;
		rOut = refCharacter;

		if( XI_IsKeyPressed("shift") )
		{
			nQ = GetCargoGoods(rOut,nGood) + iGoodsChange;
		}
	}

	
	if( XI_IsKeyPressed("alt") )
	{
		nQ = 100;
	}
	if( XI_IsKeyPressed("ctrl") )
	{
		nQ = 10;
	}


	if(bIncomeGoods) 
	{
		ExchangeGoodInProcess(nQ, bIncomeGoods, nGood);
	}
	else
	{
		ExchangeGoodOutProcess(nQ, bIncomeGoods, nGood);
	}
}

void ExchangeGoodInProcess(int nQ, bool bIncomeGoods, int nGood)
{
	string sGood = Goods[nGood].name;
	//       

	//   
	if(!GetShipRemovable(rOut))  
	{
		return;
	}
	
	//    -  
	if(CheckAttribute(rOut,"ship.cargo.goods."+sGood+".isquest") && sti(rOut.ship.cargo.goods.(sGood).isquest) == 1) 
	{
		return;
	}

	if(nQ + iGoodsChange > GetCargoGoods(rOut, nGood))
	{
		nQ = GetCargoGoods(rOut, nGood) - iGoodsChange;
	}

	int iCap = GetCharacterFreeSpace(rIn, nGood);

	/*int iStoreGoods = GetCargoGoods(rOut, nGood ) / sti(goods[nGood].units);
	float fShipWeight = GetCargoLoad(rIn);
	int iShipSpace = sti(RealShips[sti(rIn.ship.type)].Capacity);

	if(iShipSpace <  fShipWeight + nQ * stf(Goods[nGood].weight))
	{
		nQ = (iShipSpace - fShipWeight) / stf(Goods[nGood].weight);	
	}*/

	if(nQ + iGoodsChange > iCap)
	{
		nQ = iCap - iGoodsChange;
	}


	iGoodsChange = iGoodsChange + nQ;

	UpdateExhangeStrings(nGood);
}

void ExchangeGoodOutProcess(int nQ, bool bIncomeGoods, int nGood)
{
	string sGood = Goods[nGood].name;
	//       

	//   
	if(!GetShipRemovable(rOut))  
	{
		return;
	}
	
	//    -  
	if(CheckAttribute(rOut,"ship.cargo.goods."+sGood+".isquest") && sti(rOut.ship.cargo.goods.(sGood).isquest) == 1) 
	{
		return;
	}

	if(nQ > GetCargoGoods(rOut, nGood) + iGoodsChange)
	{
		nQ = GetCargoGoods(rOut, nGood) + iGoodsChange;
	}

	/*int iStoreGoods = GetCargoGoods(rOut, nGood ) / sti(goods[nGood].units);
	float fShipWeight = GetCargoLoad(rIn);
	int iShipSpace = sti(RealShips[sti(rIn.ship.type)].Capacity);

	if(iShipSpace <  fShipWeight - nQ * stf(Goods[nGood].weight))
	{
		nQ = (iShipSpace + fShipWeight) / stf(Goods[nGood].weight);	
	}
	*/

	int iCap = GetCharacterFreeSpace(rIn, nGood);

	if(nQ - iGoodsChange > iCap)
	{
		nQ = iCap + iGoodsChange;
	}

	iGoodsChange = iGoodsChange - nQ;

	UpdateExhangeStrings(nGood);
}

void UpdateExhangeStrings(int nGood)
{	

	string sGood = Goods[nGood].name;
	string sText = "";

	SetFormatedText("YOU_WANT_TO", "");
	if(iGoodsChange >= 0)
	{
		sText = XI_ConvertString("Take goods") + " " + XI_ConvertString(sGood) + ": " + iGoodsChange;
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);

		sText = XI_ConvertString("Give goods") + " " + XI_ConvertString(sGood) + ": 0 ";
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);
	}
	else
	{
		sText = XI_ConvertString("Take goods") + " " + XI_ConvertString(sGood) + ": 0";
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);

		sText = XI_ConvertString("Give goods") + " " + XI_ConvertString(sGood) + ": " + (-iGoodsChange);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"YOU_WANT_TO", 0,&sText);
	}

	sText = GetCargoGoods(refCharacter,nGood) + iGoodsChange;
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 10, iStep, &sText);
	sText = GetCargoGoods(refExCharacter,nGood) - iGoodsChange;
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 10, iStep, &sText);

	SetShipCapacity();
	SetShipSpeedManeuver();

	if(iGoodsChange == 0)
	{
		HideGoods(false);
	}
	else
	{
		HideGoods(true);
	}
}


void FillExchangeShipsScroll()
{
	DeleteAttribute(&GameInterface,"EXCHANGE_SCROLL");

	nExchangeCurScrollNum = -1;

	string attributeName;
	string shipName;
	int iShipType, cn;
	GameInterface.EXCHANGE_SCROLL.ImagesGroup.t0 = "BLANK_SHIP2";

	FillShipList("EXCHANGE_SCROLL.ImagesGroup", refCharacter);

	GameInterface.EXCHANGE_SCROLL.BadTex1 = 0;
	GameInterface.EXCHANGE_SCROLL.BadPic1 = "Not Used2";

	GameInterface.EXCHANGE_SCROLL.current = 0;

	int m = 0;
	int icompanionsQ = 0;
	int nExIndex = -1;
	for(int i=0;i<COMPANION_MAX;i++)
	{
		cn = GetCompanionIndex(pchar, i);
		if(cn != -1 && sti(refCharacter.index) != cn)
		{
			if( nExIndex==-1 ) {nExIndex=cn;}
			attributeName = "pic" + (m+1);
			iShipType = sti(characters[cn].ship.type);
			if(iShipType != SHIP_NOTUSED)
			{
				iShipType = sti(RealShips[iShipType].basetype);
				shipName = ShipsTypes[iShipType].Name;

				GameInterface.EXCHANGE_SCROLL.(attributeName).character = cn;
				GameInterface.EXCHANGE_SCROLL.(attributeName).str1 = "#"+ShipsTypes[iShipType].Class;
				GameInterface.EXCHANGE_SCROLL.(attributeName).str2 = shipName;
				GameInterface.EXCHANGE_SCROLL.(attributeName).img1 = "ship";
				GameInterface.EXCHANGE_SCROLL.(attributeName).tex1 = FindFaceGroupNum("EXCHANGE_SCROLL.ImagesGroup","SHIPS_"+shipName);
				icompanionsQ = icompanionsQ + 1;
				m++;
			}
		}
	}

	if( nExIndex==-1 ) {refExCharacter = refCharacter;} // !!! warning !!! wrong state.
	else {refExCharacter = GetCharacter(nExIndex);}

	GameInterface.EXCHANGE_SCROLL.ListSize = icompanionsQ;
	GameInterface.EXCHANGE_SCROLL.NotUsed = 2;

	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"EXCHANGE_SCROLL",-1);
}

void FillExchangeGoodsList()
{
	int i,n,iColor,nOur,nOther;
	string sGood;
	string sText;

	SetFormatedText("EXCHANGE_SHIPTRADELIST", "");
	SetFormatedText("EXCHANGE_SHIPQUANTITYLIST", "");
	SetFormatedText("EXCHANGE_STOREQUANTITYLIST", "");

	n = 0;
	for(i = 0; i< GOODS_QUANTITY; i++)
	{
		sGood = Goods[i].name;
		iColor = COLOR_NORMAL;
		nOur = GetCargoGoods(refCharacter, i);
		nOther = GetCargoGoods(refExCharacter, i);
		if(nOur + nOther > 0 ) 
		{
			iColor = COLOR_NORMAL;
			if(CheckAttribute(&goods[i], "type"))
			{
				if(sti(goods[i].type) == TRADE_TYPE_AMMUNITION)
				{
					iColor = argb(255,192,192,192);
				}
				if(sti(goods[i].type) == TRADE_TYPE_CONTRABAND)
				{
					iColor = argb(255,200,125,125);
				}
			}
			if(CheckAttribute(pchar, "ship.cargo.goods." + sGood + ".isquest"))
			{
				iColor = argb(255,255,192,255);
			}
			GoodsListExchange[n].index = i;
			sText = XI_ConvertString(sGood);
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPTRADELIST", 0,&sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPTRADELIST", 8,-1,iColor);
			sText = nOur;
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 0,&sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 8,-1,iColor);
			sText = nOther;
			SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 0,&sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 8,-1,iColor);
			n++;
		}
	}

	iExchangeStringsQuantity = n - 1;
}


void ClickExchangeGoods()
{
	int nGood = sti(GoodsListExchange[iStep].index);

	AddCharacterGoods(refCharacter, nGood, iGoodsChange);
	AddCharacterGoods(refExCharacter, nGood, -iGoodsChange);
	iGoodsChange = 0;
	SetShipCapacity();
	SetShipSpeedManeuver();
	HideGoods(false);
	UpdateWantTo();
}

void ClickExchangeGoodsCancel()
{
	iGoodsChange = 0;
	int nGood = sti(GoodsListExchange[iStep].index);
	string sText = GetCargoGoods(refCharacter,nGood) + iGoodsChange;
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 10, iStep, &sText);
	sText = GetCargoGoods(refExCharacter,nGood) - iGoodsChange;
	SendMessage(&GameInterface,"lslle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 10, iStep, &sText);
	SetShipCapacity();
	SetShipSpeedManeuver();
	HideGoods(false);
	UpdateWantTo();
}

void ClickCaptainTab()
{
	SetNewGroupPicture("TAB_CAPTAIN", "TABS", "TabSelected");
	SetNewGroupPicture("TAB_CREW", "TABS", "TabDeSelected");

	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"CAPTAIN_CAPTION", 8,0,argb(255,255,255,255));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"CREW_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_CAPTION", 8,0,argb(255,196,196,196));

	XI_WindowDisable("CREW_WINDOW", true);
	XI_WindowShow("CREW_WINDOW", false);
	XI_WindowShow("CAPTAIN_WINDOW", true);
	XI_WindowDisable("CAPTAIN_WINDOW", false);

	if(GetCompanionQuantity(pchar) > 1)
	{
		if(refCharacter.id != pchar.id && GetRemovableCompanionsNumber(pchar) > 1)
		{
			SetSelectable("CHANGE_CAPTAIN_BUTTON", true);
		}
		else
		{
			SetSelectable("CHANGE_CAPTAIN_BUTTON", false);
		}
	}
	else
	{
		SetSelectable("CHANGE_CAPTAIN_BUTTON", false);
	}

	string sTemp;
	int iColor = argb(255,255,255,255);

	sTemp = refCharacter.name + " " + refCharacter.lastname;
	SetFormatedText("CAPATAIN_NAME_TEXT", sTemp);

	sTemp = XI_ConvertString("Level");
	sTemp = sTemp + ": " + refCharacter.rank;
	SetFormatedText("CAPATAIN_RANK_TEXT", sTemp);

	sTemp = XI_ConvertString("Loyality");
	int iLoyality;
	if(checkAttribute(refCharacter, "Loyality"))
	{
		iLoyality = sti(refCharacter.loyality);
	}
	else
	{
		iLoyality = 99;
	}
	sTemp = sTemp + ": " + XI_ConvertString(GetLoyalityName(iLoyality));
	SetFormatedText("LOYALITY_TEXT", sTemp);
	
	if(iLoyality > 80)
	{
		iColor = argb(255,192,255,192);
	}
	if(iLoyality < 20)
	{
		iColor = argb(255,255,192,192);
	}
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"LOYALITY_TEXT", 8,0,iColor);
	
	SetNewPicture("INFO_WINDOW_CAPITAN_PICTURE", "interfaces\portraits\64\face_" + refCharacter.FaceId + ".tga");

	sTemp = refCharacter.skill.temp.leadership;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Leadership", sTemp, FONT_BOLD_NUMBERS,430,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.sailing;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Sailing", sTemp, FONT_BOLD_NUMBERS,498,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.tactic;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Tactic", sTemp, FONT_BOLD_NUMBERS,566,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.fencing;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Fencing", sTemp, FONT_BOLD_NUMBERS,632,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.gun;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Gun", sTemp, FONT_BOLD_NUMBERS,698,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.cannons;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Cannons", sTemp, FONT_BOLD_NUMBERS,764,158, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.accuracy;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Accuracy", sTemp, FONT_BOLD_NUMBERS,430,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.grappling;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Grappling", sTemp, FONT_BOLD_NUMBERS,498,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.defence;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Defence", sTemp, FONT_BOLD_NUMBERS,566,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.repair;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Repair", sTemp, FONT_BOLD_NUMBERS,632,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

	sTemp = refCharacter.skill.temp.commerce;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"commerce", sTemp, FONT_BOLD_NUMBERS,698,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);
	
	sTemp = refCharacter.skill.temp.sneak;
	SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"CAPTAINSTRINGS",0,
		"Luck", sTemp, FONT_BOLD_NUMBERS,764,190, COLOR_NORMAL,0, SCRIPT_ALIGN_CENTER, true, 
		0.7, 420);

}

void ClickCrewTab()
{
	SetNewGroupPicture("TAB_CAPTAIN", "TABS", "TabDeSelected");
	SetNewGroupPicture("TAB_CREW", "TABS", "TabSelected");

	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"CAPTAIN_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"CREW_CAPTION", 8,0,argb(255,255,255,255));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_CAPTION", 8,0,argb(255,196,196,196));

	SetNewPicture("CREW_PICTURE", "interfaces\crew.tga");

	XI_WindowDisable("CREW_WINDOW", false);
	XI_WindowShow("CREW_WINDOW", true);
	XI_WindowShow("CAPTAIN_WINDOW", false);
	XI_WindowDisable("CAPTAIN_WINDOW", true);

	SetMoraleText(refCharacter);
	SetCrewQuantityText(refCharacter);

	SetSelectable("CREW_MORALE_BUTTON", false);
}

void SetCrewQuantityText(ref rchr)
{
	SetFormatedText("CREW_TABLE1_TEXT", "");
	SetFormatedText("CREW_TABLE1", "");
	SetFormatedText("CREW_TABLE2_TEXT", "");
	SetFormatedText("CREW_TABLE2", "");

	string sText;

	int iShip = sti(refCharacter.ship.type);

	sText = " " + XI_ConvertString("Sailors");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1_TEXT", 0,&sText);
	sText = sti(refCharacter.ship.crew.SailorCrew) + " / " + sti(realShips[iShip].Sailorcrew) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1", 0,&sText);

	sText = " " + XI_ConvertString("Soldiers");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1_TEXT", 0,&sText);
	sText = sti(refCharacter.ship.crew.BoardingCrew) + " / " + sti(realShips[iShip].BoardingCrew) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1", 0,&sText);

	sText = " " + XI_ConvertString("Musketeers");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1_TEXT", 0,&sText);
	sText = sti(refCharacter.ship.crew.GunnerCrew) + " / " + sti(realShips[iShip].GunnerCrew) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1", 0,&sText);

	sText = " " + XI_ConvertString("Cannoners");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1_TEXT", 0,&sText);
	sText = sti(refCharacter.ship.crew.CannonerCrew) + " / " + sti(realShips[iShip].CannonerCrew) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1", 0,&sText);
	
	sText = " " + XI_ConvertString("Total");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE2_TEXT", 0,&sText);
	sText = sti(refCharacter.ship.crew.quantity) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE2", 0,&sText);


	int iColor = argb(255,192,255,192);
	if(CheckAttribute(refCharacter, "ship.crew.disease.time"))
	{
		if(sti(refCharacter.ship.crew.disease.time) > 0)
		{
			iColor = argb(255,255,192,192);
			sText = XI_ConvertString("EpidemyOnShip");
		}
		else
		{
			sText = XI_ConvertString("NoEpidemyOnShip");
		}
	}
	else
	{
		sText = XI_ConvertString("NoEpidemyOnShip");
	}

	SetFormatedText("EPIDEMY_TEXT", sText);
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"EPIDEMY_TEXT", 8,0,iColor);
}

void SetMoraleText(ref rchr)
{
	SendMessage(&GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"IMAGE_MORALE_OUR", 2, false, GetMoralePicture(stf(refCharacter.ship.crew.morale)) );
	SendMessage(&GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"IMAGE_EXP_OUR", 2, false, GetExperiencePicture(stf(refCharacter.ship.crew.experience)) );
	/*
	string sTemp = XI_ConvertString("Morale");
	int iMorale;
	int iColor = argb(255,255,255,255);
	iMorale = GetCharacterCrewMorale(rchr);

	sTemp = sTemp + ": " + XI_ConvertString(GetMoraleName(iMorale));
	SetFormatedText("MORALE_TEXT", sTemp);
	if(iMorale > 80)
	{
		iColor = argb(255,192,255,192);
	}
	if(iMorale < 20)
	{
		iColor = argb(255,255,192,192);
	}
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"MORALE_TEXT", 8,0,iColor);
	*/
}

void acceptofficer()
{
	DoExchangeCapitan(nCurScrollOldNum);

	ShowOfficerWindow(false);
	ClickCaptainTab();
	SetCurrentNode("SHIPS_SCROLL");
	ProcessFrame();
}

void ExitOfficerMenu()
{
	ShowOfficerWindow(false);
}

void ShowOfficerWindow(bool show)
{
	if (show)
	{
		FillPassengerScroll();
		RefreshOfficerWindow();

		XI_WindowDisable("MAIN_WINDOW", true);
		XI_WindowDisable("GOODS_WINDOW", true);
		XI_WindowDisable("TABS_WINDOW", true);
		XI_WindowDisable("CAPTAIN_WINDOW", true);
		XI_WindowDisable("OFFICER_WINDOW", false);
		XI_WindowShow("OFFICER_WINDOW", true);
		SetCurrentNode("OFFICER_WINDOW_CANCEL_BUTTON");

	} 
	else 
	{
		XI_WindowDisable("OFFICER_WINDOW", true);
		XI_WindowShow("OFFICER_WINDOW", false);
		XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowDisable("GOODS_WINDOW", false);
		XI_WindowDisable("TABS_WINDOW", false);
		XI_WindowDisable("CAPTAIN_WINDOW", false);
	}
}

void FillPassengerScroll()
{
	
	int i;
	string faceName;
	string attributeName;
	string PsgAttrName;
	int _curCharIdx;
	ref _refCurChar;
	aref pRef, pRef2;

	//ref _refCh= pchar;

	DeleteAttribute(&GameInterface, "OFFICER_WINDOW_PASSENGERSLIST");

	nCurScrollOldNum = 0;
	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.current = 0;
	makearef(pRef,pchar.Fellows.Passengers);

	int nListSize = GetPassengersQuantity(pchar);
	int nListSizeFree = GetFreePassengersQuantity(pchar);

	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.NotUsed = 6;
	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.ListSize = nListSizeFree + 2;

	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup.t0 = "EMPTYFACE";

	FillFaceList("OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup", pchar, 2);
	FillFaceList("OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup", pchar, 1);

	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.BadTex1 = 0;
	GameInterface.OFFICER_WINDOW_PASSENGERSLIST.BadPic1 = "emptyface";

	int m = 0;

	/*if(sti(pchar.ship.type) == SHIP_NOTUSED)
	{
		attributeName = "pic" + (m + 1);
		GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).character = sti(pchar.index);
		GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).img1 = GetFacePicName(pchar);
		GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).tex1 = FindFaceGroupNum("OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup","FACE128_"+pchar.FaceID);
		m = m + 1;
	}*/
	for(i = 1; i < nListSize; i++)
	{
		attributeName = "pic" + (m + 1);
		PsgAttrName = "id"  + i;
		makearef(pRef2,GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName));

		if(CheckAttribute(pRef, PsgAttrName))
		{
			_curCharIdx = sti(pRef.(PsgAttrName));

			if(_curCharIdx > 0 && !CheckAttribute(&characters[_curCharIdx], "isfree") && !CheckAttribute(&characters[_curCharIdx], "isquest") && sti(characters[_curCharIdx].prisoned) != 1)
			{
				GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).character = _curCharIdx;
				GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).img1 = GetFacePicName(GetCharacter(_curCharIdx));
				GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).tex1 = FindFaceGroupNum("OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup","FACE128_"+Characters[_curCharIdx].FaceID);
				m++;
			}
		}
	}

	nListSize = nListSize + GetCompanionQuantity(pchar);
	for(i = 0; i < COMPANION_MAX; i++)
	{
		_curCharIdx = GetCompanionIndex(pchar, i);
		if(_curCharIdx > 0)
		{
			if(characters[_curCharIdx].id != refCharacter.id)
			{
				if(GetShipRemovable(&characters[_curCharIdx]) == 1 || characters[_curCharIdx].id == pchar.id)
				{
					attributeName = "pic" + (m + 1);
					GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).character = _curCharIdx;
					GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).img1 = GetFacePicName(GetCharacter(_curCharIdx));
					GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).tex1 = FindFaceGroupNum("OFFICER_WINDOW_PASSENGERSLIST.ImagesGroup","FACE128_"+Characters[_curCharIdx].FaceID);
					m++;
				}
			}
		}
	}


	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"OFFICER_WINDOW_PASSENGERSLIST",-1);
}
void RefreshOfficerWindow()
{	

	string sCharacter = "pic"+(sti(GameInterface.OFFICER_WINDOW_PASSENGERSLIST.current)+1);
	if (checkAttribute(GameInterface, "OFFICER_WINDOW_PASSENGERSLIST."+sCharacter))
	{
		sCharacter = GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(sCharacter).character;
		ref otherchr = &characters[sti(sCharacter)];

		SetFormatedText("OFFICER_SUB_CAPTION", GetCharacterFullName(otherchr.id));
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"leadershipoc", otherchr.skill.temp.Leadership, FONT_BOLD_NUMBERS,	285,296, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.Leadership))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);	
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"sailingoc", otherchr.skill.temp.sailing, FONT_BOLD_NUMBERS,	349,296, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.sailing))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);	
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"fencingoc", otherchr.skill.temp.fencing, FONT_BOLD_NUMBERS,	415,296, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.fencing))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"gunoc", otherchr.skill.temp.gun, FONT_BOLD_NUMBERS,	481,296, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.gun))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"cannonsoc", otherchr.skill.temp.cannons, FONT_BOLD_NUMBERS,	547,296, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.cannons))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Accuracyoc", otherchr.skill.temp.accuracy, FONT_BOLD_NUMBERS,	285,329, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.accuracy))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Grapplingoc", otherchr.skill.temp.grappling, FONT_BOLD_NUMBERS,	349,329, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.grappling))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Defenceoc", otherchr.skill.temp.defence, FONT_BOLD_NUMBERS,	415,329, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.defence))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"repairoc", otherchr.skill.temp.repair, FONT_BOLD_NUMBERS,	481,329, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.repair))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"sneakoc", otherchr.skill.temp.sneak, FONT_BOLD_NUMBERS,	547,329, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(otherchr.skill.temp.sneak))),0, SCRIPT_ALIGN_CENTER, true, 0.7, 420);

		string sTemp = XI_ConvertString("Loyality");
		int iLoyality = 0;
		if(checkAttribute(otherchr, "Loyality"))
		{
			iLoyality = sti(otherchr.loyality);
		}
		else
		{
			iLoyality = 99;
		}
		sTemp = sTemp + ": " + XI_ConvertString(GetLoyalityName(iLoyality));
		SetFormatedText("OFFICER_LOYALITY_TEXT", sTemp);

		int iColor = argb(255,255,255,255);

		if(iLoyality > 80)
		{
			iColor = argb(255,192,255,192);
		}
		if(iLoyality < 20)
		{
			iColor = argb(255,255,192,192);
		}
		SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"OFFICER_LOYALITY_TEXT", 8,0,iColor);
	}
}

void DoExchangeCapitan(int iOfficerIndex)
{
	//AddNewShip
	string attributeName = "pic" + its(iOfficerIndex + 1);
	int iCharacterIndex = GameInterface.OFFICER_WINDOW_PASSENGERSLIST.(attributeName).character;

	ref refCompanion = GetCharacter(iCharacterIndex);
					
	//refCompanion.ship.basetype = refCharacter();

	//RemoveOldShip
	int iOldCharacter = sti(refCharacter.index);

	//characters[iOldCharacter].ship.type = SHIP_NOTUSED;

	//CopyCharacterShips(&refCharacter, &refCompanion);

	if(sti(refCompanion.ship.type) == SHIP_NOTUSED)
	{
		refCompanion.ship.type = refCharacter.ship.type;
		CopyCharacterShips(&refCharacter, &refCompanion);
		refCharacter.ship.type = SHIP_NOTUSED;
	}
	else
	{
		SeaAI_SwapShipsAttributes(refCharacter, refCompanion);
	}

	if(refCharacter.id != pchar.id)
	{
		if(sti(refCharacter.ship.type) == SHIP_NOTUSED)
		{
			RemoveCharacterCompanion(pchar, refCharacter);

			SetCompanionIndex(pchar,-1, iCharacterIndex);
			//SetCompanionIndex(pchar, iOldCharacter, -1);

			RemovePassenger(pchar, refCompanion);
			if(characters[iOldCharacter].id != pchar.id)
			{
				AddPassenger(pchar, &characters[iOldCharacter], false);
			}
		}
	}
	
	//OnShipScrollChange();

	//refCharacter = GetCharacter(iCharacterIndex);

	//refCharacter = refCompanion;

	//FillPassengerScroll();
	UpdateShipScroll();
	//UpdateCharacterInfo();
}

void UpdateShipScroll()
{
	refCharacter = pchar;

	DeleteAttribute(&GameInterface,"SHIPS_SCROLL");

	if(!CheckAttribute(&GameInterface,"SHIPS_SCROLL.current"))
	{
		GameInterface.MAIN_WINDOW_SCROLLITEMS.current = 0;
	}

	FillShipsScroll();

	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"SHIPS_SCROLL",-1);
}


void ChangeCaptain()
{
	ShowOfficerWindow(true);
}

void removeShip()
{
}

void ShowRaiseMoraleWindow()
{
	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("CREW_WINDOW", true);
	XI_WindowDisable("GOODS_WINDOW", true);
	XI_WindowDisable("RAISE_MORALE_WINDOW", false);
	XI_WindowShow("RAISE_MORALE_WINDOW", true);	

	SetFormatedText("RAISE_MORALE_CAPTION", XI_ConvertString("RaiseMorale"));
	
	int iMoney = GetCharacterRaiseCrewMoraleMoney(refCharacter);
	string sText = XI_ConvertString("RaiseMoraleMoney") + FindRussianMoneyString(iMoney) + ".";
	SetFormatedText("RAISE_MORALE_TEXT", stext);

	sText = XI_ConvertString("OurMoney") + FindRussianMoneyString(sti(pchar.money)) + ".";
	SetFormatedText("RAISE_MORALE_OUR_MONEY_TEXT", stext);
	int iColor = argb(255,192,255,192);
	if(iMoney > sti(pchar.money) || iMoney == 0)
	{
		iColor = argb(255,255,192,192);
		SetSelectable("RAISE_MORALE_OK_BUTTON", false);
	}
	else
	{
		SetSelectable("RAISE_MORALE_OK_BUTTON", true);
	}

	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"RAISE_MORALE_OUR_MONEY_TEXT", 8,-1,iColor);
}

void HideRaiseMoraleWindow()
{
	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("CREW_WINDOW", false);
	XI_WindowDisable("GOODS_WINDOW", false);
	XI_WindowDisable("RAISE_MORALE_WINDOW", true);
	XI_WindowShow("RAISE_MORALE_WINDOW", false);	
}

void MakeRaiseMorale()
{
	int iMoney = sti(pchar.money) - GetCharacterRaiseCrewMoraleMoney(refCharacter);
	if( iMoney < 0 ) 
	{
		iMoney = 0;
	}
	pchar.money = iMoney;

	int iNextMorale = sti(refCharacter.ship.crew.morale) + 10;
	if( iNextMorale > 99 ) {
		iNextMorale = 99;
	}
	refCharacter.ship.crew.morale = iNextMorale;

	SetMoraleText(refCharacter);
	HideRaiseMoraleWindow();
}

void FillSailsColorScroll()
{
	// fill colors list
	for (int i = 0; i < SAILS_COLOR_QUANTITY; i++)
	{
		string attrName = "pic" + (i + 1);
		GameInterface.SHIP_WINDOW_SAILS_COLOR.(attrName).name1 = SailsColors[i].icon;
	}
	GameInterface.SHIP_WINDOW_SAILS_COLOR.ListSize = SAILS_COLOR_QUANTITY;
	GameInterface.SHIP_WINDOW_SAILS_COLOR.current = 0;
}

void FillEmblemesScroll()
{
	EnumerateIcons("resource\textures\" + sUserSailsPath, "*.tga.tx", "SHIP_WINDOW_EMBLEME", 0);
}

int ScrollGetTexture()
{
	string sName = GetEventData();
	int iPicIndex = GetEventData();
	string sScrollID = GetEventData();
	int iTexture = NFGetTexture(sScrollID, sName);
	Trace("ScrollGetTexture: " + iTexture + ", " + sName);
	
	return iTexture;
}

void ShowExchangeCrewWindow()
{
	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("CREW_WINDOW", true);
	XI_WindowDisable("GOODS_WINDOW", true);
	XI_WindowDisable("EXCHANGE_CREW_WINDOW", false);
	XI_WindowShow("EXCHANGE_CREW_WINDOW", true);	

	SetCurrentNode("EXCHANGE_CREW_SCROLLER");

	SetFormatedText("EXCHANGE_CREW_CAPTION", XI_ConvertString("Crew Transfer"));

	FillExchangeCrewShipsList();
	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"EXCHANGE_CREW_SCROLLER",-1);
	ProcessFrame();
	

	EI_CreateFrame("EXCHANGE_CREW_PIC_BORDERS",251,334,315,398);
	EI_CreateFrame("EXCHANGE_CREW_PIC_BORDERS",490,334,554,398);

	SetCurrentNode("EXCHANGE_CREW_SCROLLER");


	SetQuantityNotate();

	UpdateExchangeCrewInfo();
	UpdateCrewCounterPos(0);
}

void StoreCrewData(bool bStore)
{
	if( bStore ) {
		objStoreData.our.crew.quantity = refCharacter.ship.crew.quantity;
		objStoreData.our.crew.SailorCrew = refCharacter.ship.crew.SailorCrew;
		objStoreData.our.crew.BoardingCrew = refCharacter.ship.crew.BoardingCrew;
		objStoreData.our.crew.GunnerCrew = refCharacter.ship.crew.GunnerCrew;
		objStoreData.our.crew.CannonerCrew = refCharacter.ship.crew.CannonerCrew;
		objStoreData.our.crew.morale = refCharacter.ship.crew.morale;
		objStoreData.our.crew.experience = refCharacter.ship.crew.experience;

		objStoreData.other.crew.quantity = refExCharacter.ship.crew.quantity;
		objStoreData.other.crew.SailorCrew = refExCharacter.ship.crew.SailorCrew;
		objStoreData.other.crew.BoardingCrew = refExCharacter.ship.crew.BoardingCrew;
		objStoreData.other.crew.GunnerCrew = refExCharacter.ship.crew.GunnerCrew;
		objStoreData.other.crew.CannonerCrew = refExCharacter.ship.crew.CannonerCrew;
		objStoreData.other.crew.morale = refExCharacter.ship.crew.morale;
		objStoreData.other.crew.experience = refExCharacter.ship.crew.experience;
	} else {
		refCharacter.ship.crew.quantity = objStoreData.our.crew.quantity;
		refCharacter.ship.crew.SailorCrew = objStoreData.our.crew.SailorCrew;
		refCharacter.ship.crew.BoardingCrew = objStoreData.our.crew.BoardingCrew;
		refCharacter.ship.crew.GunnerCrew = objStoreData.our.crew.GunnerCrew;
		refCharacter.ship.crew.CannonerCrew = objStoreData.our.crew.CannonerCrew;
		refCharacter.ship.crew.morale = objStoreData.our.crew.morale;
		refCharacter.ship.crew.experience = objStoreData.our.crew.experience;

		refExCharacter.ship.crew.quantity = objStoreData.other.crew.quantity;
		refExCharacter.ship.crew.SailorCrew = objStoreData.other.crew.SailorCrew;
		refExCharacter.ship.crew.BoardingCrew = objStoreData.other.crew.BoardingCrew;
		refExCharacter.ship.crew.GunnerCrew = objStoreData.other.crew.GunnerCrew;
		refExCharacter.ship.crew.CannonerCrew = objStoreData.other.crew.CannonerCrew;
		refExCharacter.ship.crew.morale = objStoreData.other.crew.morale;
		refExCharacter.ship.crew.experience = objStoreData.other.crew.experience;
	}
}

void SetQuantityNotate()
{
	string sText = "";
	sText = refCharacter.ship.name;
	SetFormatedText("EXCHANGE_CREW_OUR_SHIP_CAPTION", sText);
	sText = refExCharacter.ship.name;
	SetFormatedText("EXCHANGE_CREW_OTHER_SHIP_CAPTION", sText);

	int iOurShip = sti(refCharacter.ship.type);
	int iOtherShip = sti(refExCharacter.ship.type);
	
	int iOurCrewMin = sti(RealShips[iOurShip].mincrew);
	int iOurCrewCur = sti(refCharacter.ship.crew.quantity);
	int iOurCrewMax = sti(RealShips[iOurShip].maxcrew);
	
	int iOtherCrewMin = sti(RealShips[iOtherShip].mincrew);
	int iOtherCrewCur = sti(refExCharacter.ship.crew.quantity);
	int iOtherCrewMax = sti(RealShips[iOtherShip].maxcrew);

	int iOurFreeSpace = GetCargoFreeSpace(refCharacter);
	int iOtherFreeSpace = GetCargoFreeSpace(refExCharacter);
	
	//Cerez: Fixed crew overflow alert wrong content bug
	if( iOurCrewCur > iOurCrewMax ) {
		sText = XI_ConvertString( "CrewOverflow" );
		SetFormatedText("EXCHANGE_CREW_OUR_SHIP_Q_TEXT", sText);
	}

	if( iOtherCrewCur > iOtherCrewMax ) {
		sText = XI_ConvertString( "CrewOverflow" );
		SetFormatedText("EXCHANGE_CREW_OTHER_SHIP_Q_TEXT", sText);
	}

	sText = XI_ConvertString("Crew") + ": " + makeint(refCharacter.ship.crew.quantity) + " / " + iOurCrewMax;
	SetFormatedText("EXCHANGE_CREW_OUR_SHIP_TEXT", sText);

	sText = " " + XI_ConvertString("Crew") + ": " + makeint(refExCharacter.ship.crew.quantity) + " / " + iOtherCrewMax;
	SetFormatedText("EXCHANGE_CREW_OTHER_SHIP_TEXT", sText);

	sText = XI_ConvertString("Crew") + ": " + makeint(refCharacter.ship.crew.quantity) + " / " + iOurCrewMax;
	SetFormatedText("EXCHANGE_CREW_OUR_SHIP_TEXT", sText);
	sText = " " + XI_ConvertString("Crew") + ": " + makeint(refExCharacter.ship.crew.quantity) + " / " + iOtherCrewMax;
	SetFormatedText("EXCHANGE_CREW_OTHER_SHIP_TEXT", sText);

	SetNewPicture("EXCHANGE_CREW_OUR_SHIP", "interfaces\portraits\256\face_" + refCharacter.FaceId + ".tga");
	SetNewPicture("EXCHANGE_CREW_OTHER_SHIP", "interfaces\portraits\256\face_" + refExCharacter.FaceId + ".tga");
}

void HideExchangeCrewWindow()
{
	int nComCode = GetEventData();
	string nodName = GetEventData();

	bool bConfirmCrewExchange = false;
	if( nodName=="EXCHANGE_CREW_OK_BUTTON" ) {
		if( nComCode==ACTION_MOUSECLICK || nComCode==ACTION_ACTIVATE ) {
			bConfirmCrewExchange = true;
		}
	}

	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("CREW_WINDOW", false);
	XI_WindowDisable("GOODS_WINDOW", false);
	XI_WindowDisable("EXCHANGE_CREW_WINDOW", true);
	XI_WindowShow("EXCHANGE_CREW_WINDOW", false);

	if( bConfirmCrewExchange ) {
		SetMoraleText(refCharacter);
		//SetCrewQuantityText(refCharacter);
	} else {
		StoreCrewData(false);
	}
}

void FillExchangeCrewShipsList()
{
	nCrewCurScrollNum = -1;

	DeleteAttribute(&GameInterface,"EXCHANGE_CREW_SCROLLER");

	GameInterface.EXCHANGE_CREW_SCROLLER.current = 0;

	string attributeName;
	string shipName;
	int iShipType, cn;
	GameInterface.EXCHANGE_CREW_SCROLLER.ImagesGroup.t0 = "BLANK_SHIP2";

	FillShipList("EXCHANGE_CREW_SCROLLER.ImagesGroup", refCharacter);
	GameInterface.EXCHANGE_CREW_SCROLLER.BadTex1 = 0;
	GameInterface.EXCHANGE_CREW_SCROLLER.BadPic1 = "Not Used2";

	int m = 0;
	for(int i = 0; i < COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(pchar, i);
		attributeName = "pic" + (m+1);
		if(cn != -1)
		{
			if(characters[cn].id != refCharacter.id)
			{
				iShipType = sti(characters[cn].ship.type);
				if(iShipType != SHIP_NOTUSED)
				{
					iShipType = sti(RealShips[iShipType].basetype);
					shipName = ShipsTypes[iShipType].Name;

					GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).character = cn;
					GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).str1 = "#"+ShipsTypes[iShipType].Class;
					GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).str2 = shipName;
					GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).img1 = "ship";
					GameInterface.EXCHANGE_CREW_SCROLLER.(attributeName).tex1 = FindFaceGroupNum("EXCHANGE_CREW_SCROLLER.ImagesGroup","SHIPS_"+shipName);
					m++;
				}
			}
		}
	}

	GameInterface.EXCHANGE_CREW_SCROLLER.ListSize = m;
	GameInterface.EXCHANGE_CREW_SCROLLER.NotUsed = 5 - m + 1;
}

void AddCrewExchange()
{
	int nCurCrewType = 1 + SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 11);//sti(GameInterface.EXCHANGE_CREW_TABLE.select);
	int nAddQuantity = 1; //   
	if( XI_IsKeyPressed("control") ) {nAddQuantity=10;}

	int iOurShip = sti(refCharacter.ship.type);
	int iOtherShip = sti(refExCharacter.ship.type);
	int iMin = 0;

	string sCrewAttr = "";
	switch( nCurCrewType )
	{
	case 1:
		sCrewAttr = "SailorCrew";
		iMin = sti(RealShips[iOtherShip].mincrew);
		break;
	case 2:
		sCrewAttr = "BoardingCrew";
		iMin = sti(RealShips[iOtherShip].BoardingCrew) / 10;
		break;
	case 3:
		sCrewAttr = "GunnerCrew";
		iMin = sti(RealShips[iOtherShip].GunnerCrew) / 10;
		break;
	case 4:
		sCrewAttr = "CannonerCrew";
		iMin = sti(RealShips[iOtherShip].CannonerCrew) / 10;
		break;
	}
	if( sCrewAttr=="" ) {return;}

	if( XI_IsKeyPressed("shift") ) {nAddQuantity=sti(refExCharacter.ship.crew.(sCrewAttr));}
	if( XI_IsKeyPressed("alt") ) {nAddQuantity=100;}
	if( XI_IsKeyPressed("ctrl") ) {nAddQuantity=10;}

	//     ( )
	if( sti(refExCharacter.ship.crew.(sCrewAttr)) - nAddQuantity < iMin ) {
		nAddQuantity = sti(refExCharacter.ship.crew.(sCrewAttr)) - iMin;
	}
	if( nAddQuantity<=0 ) {return;}

	//     (     )
	if( sti(refCharacter.ship.crew.(sCrewAttr)) + nAddQuantity > sti(RealShips[iOurShip].(sCrewAttr)) ) {
		nAddQuantity = sti(RealShips[iOurShip].(sCrewAttr)) - sti(refCharacter.ship.crew.(sCrewAttr));
	}
	if( nAddQuantity<=0 ) {return;}

	//  
	refCharacter.ship.crew.quantity = sti(refCharacter.ship.crew.quantity) + nAddQuantity;
	refExCharacter.ship.crew.quantity = sti(refExCharacter.ship.crew.quantity) - nAddQuantity;
	refCharacter.ship.crew.(sCrewAttr) = sti(refCharacter.ship.crew.(sCrewAttr)) + nAddQuantity;
	refExCharacter.ship.crew.(sCrewAttr) = sti(refExCharacter.ship.crew.(sCrewAttr)) - nAddQuantity;

	RecalculateMoraleAndExp();
	SetQuantityNotate();
	UpdateExchangeCrewInfo();
}

void RemoveCrewExchange()
{
	int nCurCrewType = 1 + SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 11);//sti(GameInterface.EXCHANGE_CREW_TABLE.select);
	int nRemoveQuantity = 1; //   

	if( XI_IsKeyPressed("control") ) {nRemoveQuantity=10;}

	int iOurShip = sti(refCharacter.ship.type);
	int iOtherShip = sti(refExCharacter.ship.type);
	int iMin = 0;

	string sCrewAttr = "";
	switch( nCurCrewType )
	{
	case 1:
		sCrewAttr = "SailorCrew";
		iMin = sti(RealShips[iOurShip].mincrew);
		break;
	case 2:
		sCrewAttr = "BoardingCrew";
		iMin = sti(RealShips[iOurShip].BoardingCrew) / 10;
		break;
	case 3:
		sCrewAttr = "GunnerCrew";
		iMin = sti(RealShips[iOurShip].GunnerCrew) / 10;
		break;
	case 4:
		sCrewAttr = "CannonerCrew";
		iMin = sti(RealShips[iOurShip].CannonerCrew) / 10;
		break;
	}
	if( sCrewAttr=="" ) {return;}

	if( XI_IsKeyPressed("shift") ) {nRemoveQuantity=sti(refCharacter.ship.crew.(sCrewAttr));}
	if( XI_IsKeyPressed("alt") ) {nRemoveQuantity=100;}
	if( XI_IsKeyPressed("ctrl") ) {nRemoveQuantity=10;}

	//     ( )
	if( sti(refCharacter.ship.crew.(sCrewAttr)) - nRemoveQuantity < iMin ) {
		nRemoveQuantity = sti(refCharacter.ship.crew.(sCrewAttr)) - iMin;
	}
	if( nRemoveQuantity<=0 ) {return;}

	//     (     )
	if( sti(refExCharacter.ship.crew.(sCrewAttr)) + nRemoveQuantity > sti(RealShips[iOtherShip].(sCrewAttr)) ) {
		nRemoveQuantity = sti(RealShips[iOtherShip].(sCrewAttr)) - sti(refExCharacter.ship.crew.(sCrewAttr));
	}
	if( nRemoveQuantity<=0 ) {return;}

	//  
	refCharacter.ship.crew.quantity = sti(refCharacter.ship.crew.quantity) - nRemoveQuantity;
	refExCharacter.ship.crew.quantity = sti(refExCharacter.ship.crew.quantity) + nRemoveQuantity;
	refCharacter.ship.crew.(sCrewAttr) = sti(refCharacter.ship.crew.(sCrewAttr)) - nRemoveQuantity;
	refExCharacter.ship.crew.(sCrewAttr) = sti(refExCharacter.ship.crew.(sCrewAttr)) + nRemoveQuantity;

	RecalculateMoraleAndExp();
	SetQuantityNotate();
	UpdateExchangeCrewInfo();
}

void RecalculateMoraleAndExp()
{
	int nIncome,nOutcome;
	CalculateInOutCrew(&nIncome,&nOutcome);

	float fOurMorale = stf(objStoreData.our.crew.morale);
	float fOtherMorale = stf(objStoreData.other.crew.morale);

	float fOurExp = stf(objStoreData.our.crew.experience);
	float fOtherExp = stf(objStoreData.other.crew.experience);

	int nComOurQ = GetCrewQuantity(refCharacter) - nIncome;
	if( nIncome!=0 ) {
		refCharacter.ship.crew.morale = (nComOurQ*fOurMorale + nIncome*fOtherMorale) / (nComOurQ + nIncome);
		refCharacter.ship.crew.experience = (nComOurQ*fOurExp + nIncome*fOtherExp) / (nComOurQ + nIncome);
	} else {
		refCharacter.ship.crew.morale = fOurMorale;
		refCharacter.ship.crew.experience = fOurExp;
	}

	int nComOtherQ = GetCrewQuantity(refExCharacter) - nOutcome;
	if( nIncome!=0 ) {
		refExCharacter.ship.crew.morale = (nComOtherQ*fOtherMorale + nOutcome*fOurMorale) / (nComOtherQ + nOutcome);
		refExCharacter.ship.crew.experience = (nComOtherQ*fOtherExp + nOutcome*fOurExp) / (nComOtherQ + nOutcome);
	} else {
		refExCharacter.ship.crew.morale = fOtherMorale;
		refExCharacter.ship.crew.experience = fOtherExp;
	}
}

void CalculateInOutCrew(ref rnIncome,ref rnOutcome)
{
	int nIncome = 0;
	int nOutcome = 0;

	int nTmp = sti(refCharacter.ship.crew.SailorCrew) - sti(objStoreData.our.crew.SailorCrew);
	if( nTmp > 0 ) {nIncome = nIncome + nTmp;}
	if( nTmp < 0 ) {nOutcome = nOutcome - nTmp;}

	nTmp = sti(refCharacter.ship.crew.BoardingCrew) - sti(objStoreData.our.crew.BoardingCrew);
	if( nTmp > 0 ) {nIncome = nIncome + nTmp;}
	if( nTmp < 0 ) {nOutcome = nOutcome - nTmp;}

	nTmp = sti(refCharacter.ship.crew.GunnerCrew) - sti(objStoreData.our.crew.GunnerCrew);
	if( nTmp > 0 ) {nIncome = nIncome + nTmp;}
	if( nTmp < 0 ) {nOutcome = nOutcome - nTmp;}

	nTmp = sti(refCharacter.ship.crew.CannonerCrew) - sti(objStoreData.our.crew.CannonerCrew);
	if( nTmp > 0 ) {nIncome = nIncome + nTmp;}
	if( nTmp < 0 ) {nOutcome = nOutcome - nTmp;}

	rnIncome = nIncome;
	rnOutcome = nOutcome;
}

void UpdateExchangeCrewInfo()
{
	string sText;

	int iOurShip = sti(refCharacter.ship.type);
	int iOtherShip = sti(refExCharacter.ship.type);

	int nOldCurIdx = SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 11);

	SetFormatedText("EXCHANGE_CREW_OUR_CREW", "");
	SetFormatedText("EXCHANGE_CREW_CREW_TEXT", "");
	SetFormatedText("EXCHANGE_CREW_OTHER_CREW", "");

	sText = sti(refCharacter.ship.crew.SailorCrew) + " / " + sti(realShips[iOurShip].SailorCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OUR_CREW", 0,&sText);
	sText = sti(refCharacter.ship.crew.BoardingCrew) + " / " + sti(realShips[iOurShip].BoardingCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OUR_CREW", 0,&sText);
	sText = sti(refCharacter.ship.crew.GunnerCrew) + " / " + sti(realShips[iOurShip].GunnerCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OUR_CREW", 0,&sText);
	sText = sti(refCharacter.ship.crew.CannonerCrew) + " / " + sti(realShips[iOurShip].CannonerCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OUR_CREW", 0,&sText);
	
	sText = XI_ConvertString("Sailors");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 0,&sText);
	sText = XI_ConvertString("Soldiers");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 0,&sText);
	sText = XI_ConvertString("Musketeers");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 0,&sText);
	sText = XI_ConvertString("Cannoners");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 0,&sText);
	

	sText = sti(refExCharacter.ship.crew.SailorCrew) + " / " + sti(realShips[iOtherShip].SailorCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OTHER_CREW", 0,&sText);
	sText = sti(refExCharacter.ship.crew.BoardingCrew) + " / " + sti(realShips[iOtherShip].BoardingCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OTHER_CREW", 0,&sText);
	sText = sti(refExCharacter.ship.crew.GunnerCrew) + " / " + sti(realShips[iOtherShip].GunnerCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OTHER_CREW", 0,&sText);
	sText = sti(refExCharacter.ship.crew.CannonerCrew) + " / " + sti(realShips[iOtherShip].CannonerCrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OTHER_CREW", 0,&sText);

	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OUR_CREW", 1, nOldCurIdx);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_CREW_TEXT", 1, nOldCurIdx);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_OTHER_CREW", 1, nOldCurIdx);

	UpdateCrewCounterPos( nOldCurIdx );

	SetQuantityNotate();
	//SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_CREW_TABLE", 0);
}

void UpdateCrewCounterPos(int nLine)
{
	int pic_top = 344 + 19*nLine;
	int pic_bottom = 362 + 19*nLine;
	SendMessage(&GameInterface,"lsllllll",MSG_INTERFACE_MSG_TO_NODE,"CREW_COUNTER", -1, 4, 334,pic_top, 468,pic_bottom);
}

int GetRealMaxCrewQuantity(ref rChar)
{
	int iShip = sti(rChar.ship.type);
	int nCrewMaxQ = sti(RealShips[iShip].maxcrew);
	int nCrewCur = GetCrewQuantity(rChar);
	int nFreeSpace = GetCargoFreeSpace(rChar);
	if( nCrewCur > nCrewMaxQ ) { //        
		nFreeSpace = nFreeSpace + nCrewCur - nCrewMaxQ;
	}
	if( nCrewMaxQ*2 > nFreeSpace ) {
		nCrewMaxQ = nCrewMaxQ + nFreeSpace;
	} else {
		nCrewMaxQ = nCrewMaxQ * 3;
	}
	return nCrewMaxQ;
}

void wndChangeSails()
{
	SetChangeSailStartData();
	ShowChangeSailWindow(true);
}

void ChangeSelectScrollImage()
{
	string sNod = GetEventData();
	int nIdx = GetEventData();
	if( sNod=="SHIP_WINDOW_SAILS_COLOR" || sNod=="SHIP_WINDOW_EMBLEME" )
	{
		if( sNod=="SHIP_WINDOW_SAILS_COLOR" ) {
			GameInterface.SHIP_WINDOW_SAILS_COLOR.current = nIdx;
		} else {
			GameInterface.SHIP_WINDOW_EMBLEME.current = nIdx;
		}
		CheckChangeSailStatus();
	}
}

void CheckChangeSailStatus()
{
	bool bNewValue = true;
	if( CheckAttribute(refCharacter,"ship.sails.gerald_name") &&
		CheckAttribute(refCharacter,"ship.sails.color") )
	{
		bNewValue = false;

		int nColor = sti(GameInterface.SHIP_WINDOW_SAILS_COLOR.current);
		int nEmblem = sti(GameInterface.SHIP_WINDOW_EMBLEME.current);

		string sattr = "pic"+(nEmblem+1);
		if( GameInterface.SHIP_WINDOW_EMBLEME.(sattr).name1 != refCharacter.ship.sails.gerald_name ) {
			bNewValue = true; }
		if( SailsColors[nColor].color != refCharacter.ship.sails.color ) {
			bNewValue = true; }
	}
	SetSelectable( "CHANGE_SAILS_OK",bNewValue );
}

void SetChangeSailStartData()
{
	int n;

	int nColorIdx = -1;
	int nColor = argb(255,255,255,255);
	if( CheckAttribute(refCharacter,"ship.sails.color") ) {
		nColor = sti(refCharacter.ship.sails.color);
	}
	for(n=0; n < SAILS_COLOR_QUANTITY; n++) {
		if( sti(SailsColors[n].color) == nColor ) {
			nColorIdx = n;
			break;
		}
	}

	int nEmblemeIdx = -1;
	string sEmblemeName = "";
	if( CheckAttribute(refCharacter,"ship.sails.gerald_name") ) {
		sEmblemeName = refCharacter.ship.sails.gerald_name;
	}
	string stmp;
	for(n=0; n<1000; n++) {
		stmp = "pic" + (n+1);
		if( !CheckAttribute(&GameInterface,"SHIP_WINDOW_EMBLEME."+stmp+".name1") ) {break;}
		if( GameInterface.SHIP_WINDOW_EMBLEME.(stmp).name1 == sEmblemeName ) {
			nEmblemeIdx = n;
			break;
		}
	}

	if( nColorIdx>=0 ) {
		SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_SAILS_COLOR", 1,nColorIdx);
	}
	if( nEmblemeIdx>=0 ) {
		SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_EMBLEME", 1,nEmblemeIdx);
	}

	CheckChangeSailStatus();
}

void ShowChangeSailWindow(bool bShow)
{
	
	if( bShow ) 
	{
		irestoreCode = XI_StoreNodeLocksWithOff();
		//XI_WindowDisable("TABS_WINDOW", true);
		//XI_WindowDisable("GOODS_WINDOW", true);
		//XI_WindowDisable("MAIN_WINDOW", true);
		//XI_WindowDisable("CREW_WINDOW", true);
		//XI_WindowDisable("CAPTAIN_WINDOW", true);
		XI_WindowDisable("CHANGE_SAIL_WINDOW", false);
		XI_WindowShow("CHANGE_SAIL_WINDOW", true);
		SetCurrentNode("CHANGE_SAILS_CANCEL");
	} 
	else 
	{
		//XI_WindowDisable("TABS_WINDOW", false);
		//XI_WindowDisable("GOODS_WINDOW", false);
		//XI_WindowDisable("CREW_WINDOW", true);
		//XI_WindowDisable("CAPTAIN_WINDOW", true);
		//XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowDisable("CHANGE_SAIL_WINDOW", true);
		XI_WindowShow("CHANGE_SAIL_WINDOW", false);
		SetCurrentNode("MAIN_WINDOW_CHANGE_SAIL");
		XI_RestoreNodeLocks(irestoreCode);
	}
}

void ChangeSails()
{
	int nComName = GetEventData();
	string sNodeName = GetEventData();
	if(sNodeName=="CHANGE_SAILS_OK") 
	{
		if( nComName==ACTION_ACTIVATE ||
			nComName==ACTION_MOUSECLICK ) {
				int nColorIdx = sti(GameInterface.SHIP_WINDOW_SAILS_COLOR.current);
				int nGeraldIdx = sti(GameInterface.SHIP_WINDOW_EMBLEME.current);
				if( nColorIdx<0 || nGeraldIdx<0 ) {return;}

				refCharacter.ship.sails.color = SailsColors[nColorIdx].color;

				string attrName = "pic"+(nGeraldIdx+1);
				refCharacter.ship.sails.gerald_name = GameInterface.SHIP_WINDOW_EMBLEME.(attrName).name1;

				/*SetSelectable( "CHANGE_SAILS_OK", false );
				SetCurrentNode( "CHANGE_SAILS_CANCEL" );
				return;*/
			}
	}

	ShowChangeSailWindow(false);
}

/*void ShowCompanionInfo()
{
	string sHeader = "";
	string sText1 = "";
	string sText2 = "";
	string sText3 = "";
	string sPicture = "";
	string sGroupPicture = "";
	string sGroup = "";

	int nChooseNum = SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"SHIPS_SCROLL", 2 );
	string attributeName = "pic" + (nChooseNum+1);
	int iCharacter = sti(GameInterface.CHARACTERS_SCROLL.(attributeName).character);

	if(iCharacter != 0)
	{
		ref rchr = &Characters[iCharacter];
		if(FindFellowtravellers(pchar,rchr) != FELLOWTRAVEL_COMPANION)
		{
			string sResult;
			string sColony;
			int iSalary;
			sText1 = GetCharacterFullName(Characters[iCharacter].id);
			sHeader = XI_ConvertString("passengership");
			if(checkAttribute(rchr, "quest.deliverymoney") && sti(rchr.prisoned) != 1)
			{
				sText3 = SelectPassengerQuestInfo(rchr);
			}
			if(sti(rchr.prisoned) == 1 && !CheckAttribute(rchr, "isprisonquest"))
			{
				sText3 = SelectPrisonerInfo(rchr);
			}
			if(sti(rchr.prisoned) == 1 && CheckAttribute(rchr, "isprisonquest"))
			{
				sText3 = SelectPrisonerQuestInfo(rchr);
			}
			if(CheckAttribute(rchr, "quest.OfficerPrice") && rchr != pchar.id)
			{
				sText3 = SelectOfficerSalaryInfo(rchr);
			}
		}
		else
		{
			if(CheckAttribute(rchr, "quest.convoyquest.money"))
			{
				sText3 = SelectEscortQuestInfo(rchr);
			}
			sText1 = GetCharacterFullName(Characters[iCharacter].id);
			sHeader = XI_ConvertString("companionship");
		}
		sPicture = "interfaces\portraits\64\face_" + rchr.FaceId + ".tga"
	}

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,192,192), sText3, argb(255,192,255,192), "", argb(255,255,255,255), sPicture, sGroup, sGroupPicture, 64, 64);
}*/

void ShowUpgradeInfo()
{
	string sNode = GetCurrentNode();

	string sHeader = "";
	string sText1 = "";
	string sText2 = "";
	string sText3 = "";
	string sPicture = "";
	string sGroupPicture = "";
	string sGroup = "";
	switch(sNode)
	{
		case "MAIN_WINDOW_OUR_UPGRADE_HULL":
			sHeader = XI_ConvertString("HullUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoHull" + refCharacter.ship.upgrades.hull);
			
			sGroup = "HULL_UPGRADE_" + refCharacter.ship.upgrades.hull;
			sGroupPicture = "hull";
		break;
		case "MAIN_WINDOW_OUR_UPGRADE_SAILS":
			sHeader = XI_ConvertString("SailsUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoSails" + refCharacter.ship.upgrades.sails);
			
			sGroup = "SAILS_UPGRADE_" + refCharacter.ship.upgrades.sails;
			sGroupPicture = "sails";
		break;
		case "MAIN_WINDOW_OUR_UPGRADE_CANNONS":
			sHeader = XI_ConvertString("CannonsUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoCannons" + refCharacter.ship.upgrades.cannons);
			
			int iOurCannonType = sti(refCharacter.ship.cannons.type);
			sGroupPicture = Cannon[iOurCannonType].picture;
			sGroup = "CANNONS_UPGRADE_" + refCharacter.ship.upgrades.cannons;
			int iCannonType =  Cannon[sti(refCharacter.ship.cannons.type)].type;
			if(iCannonType == CANNON_NAME_CULVERINE)
			{
				sText2 = XI_ConvertString("cannon type") + ": " + XI_ConvertString("Culverine");
			}
			if(iCannonType == CANNON_NAME_CANNON)
			{
				sText2 = XI_ConvertString("cannon type") + ": " + XI_ConvertString("Cannon");
			}

			sText2 = sText2 + "\n" + XI_ConvertString("Caliber_info");
			sText2 = sText2 + ": " + XI_ConvertString(Cannon[sti(refCharacter.ship.cannons.type)].name);
		break;
	}

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,255,255), sText3, argb(255,192,255,192), "", argb(255,255,255,255), sPicture, sGroup, sGroupPicture, 64, 64);
}

void ShowSkillInfo() 
{
	string sCurrentNode = GetCurrentNode();

	int iCurrentSkill = -1;

	if(sCurrentNode == "LEADERSHIP_R")
	{
		iCurrentSkill = 0;
	}
	if(sCurrentNode == "NAVIGATION_R")
	{
		iCurrentSkill = 1;
	}
	if(sCurrentNode == "TACTIC_R")
	{
		iCurrentSkill = 2;
	}
	if(sCurrentNode == "FENCING_R")
	{
		iCurrentSkill = 3;
	}
	if(sCurrentNode == "GUN_R")
	{
		iCurrentSkill = 4;
	}
	if(sCurrentNode == "CANNONS_R")
	{
		iCurrentSkill = 5;
	}
	if(sCurrentNode == "ACCURACY_R")
	{
		iCurrentSkill = 6;
	}
	if(sCurrentNode == "GRAPPLING_R")
	{
		iCurrentSkill = 7;
	}
	if(sCurrentNode == "DEFENCE_R")
	{
		iCurrentSkill = 8;
	}
	if(sCurrentNode == "REPAIR_R")
	{
		iCurrentSkill = 9;
	}
	if(sCurrentNode == "COMMERCE_R")
	{
		iCurrentSkill = 10;
	}
	if(sCurrentNode == "LUCK_R")
	{
		iCurrentSkill = 11;
	}
	
	int iSkillModifierUp;
	string sModifDown, sModifUp;
	int nSkill, nTempSkill, nUpSkill;
	string sHeader, sText1, sText2, sText3;
	string sPicture, sGroup, sGroupPicture;
	sGroup = "SKILLS";
	switch(iCurrentSkill)
	{
		case 0:
			sHeader = XI_ConvertString("Leadership");
			sText1 = XI_ConvertString("Leadership_descr");
			sText2 = XI_ConvertString("Leadership_Up");

			sGroupPicture = "Leadership";
			nSkill = sti(refCharacter.skill.leadership);
		break;
		case 1:
			sHeader = XI_ConvertString("Sailing");
			sText1 = XI_ConvertString("Sailing_descr");
			sText2 = XI_ConvertString("Sailing_Up");

			sGroupPicture = "navigation";
			
			nSkill = sti(refCharacter.skill.sailing);
		break;
		case 2:
			sHeader = XI_ConvertString("Tactic");
			sText1 = XI_ConvertString("Tactic_descr");
			sText2 = XI_ConvertString("Tactic_Up");

			sGroupPicture = "Tactic";
			
			nSkill = sti(refCharacter.skill.tactic);
		break;
		case 3:
			sHeader = XI_ConvertString("Fencing");
			sText1 = XI_ConvertString("Fencing_descr");
			sText2 = XI_ConvertString("Fencing_Up");

			sGroupPicture = "Fencing";
			
			nSkill = sti(refCharacter.skill.fencing);
		break;
		case 4:
			sHeader = XI_ConvertString("Gun");
			sText1 = XI_ConvertString("Gun_descr");
			sText2 = XI_ConvertString("Gun_Up");

			sGroupPicture = "Gun";
			
			nSkill = sti(refCharacter.skill.gun);
		break;
		case 5:
			sHeader = XI_ConvertString("Cannons");
			sText1 = XI_ConvertString("Cannons_descr");
			sText2 = XI_ConvertString("Cannons_Up");

			sGroupPicture = "Cannons";
			
			nSkill = sti(refCharacter.skill.cannons);
		break;
		case 6:
			sHeader = XI_ConvertString("Accuracy");
			sText1 = XI_ConvertString("Accuracy_descr");
			sText2 = XI_ConvertString("Accuracy_Up");

			sGroupPicture = "Accuracy";
			
			nSkill = sti(refCharacter.skill.accuracy);
		break;
		case 7:
			sHeader = XI_ConvertString("Grappling");
			sText1 = XI_ConvertString("Grappling_descr");
			sText2 = XI_ConvertString("Grappling_Up");

			sGroupPicture = "Grappling";
			
			nSkill = sti(refCharacter.skill.grappling);
		break;
		case 8:
			sHeader = XI_ConvertString("Defence");
			sText1 = XI_ConvertString("Defence_descr");
			sText2 = XI_ConvertString("Defence_Up");

			sGroupPicture = "Defence";
			
			nSkill = sti(refCharacter.skill.defence);
		break;
		case 9:
			sHeader = XI_ConvertString("Repair");
			sText1 = XI_ConvertString("Repair_descr");
			sText2 = XI_ConvertString("Repair_Up");

			sGroupPicture = "Repair";
			
			nSkill = sti(refCharacter.skill.repair);
		break;
		case 10:
			sHeader = XI_ConvertString("Commerce");
			sText1 = XI_ConvertString("Commerce_descr");
			sText2 = XI_ConvertString("Commerce_Up");

			sGroupPicture = "Commerce";
			
			nSkill = sti(refCharacter.skill.commerce);
		break;
		case 11:
			sHeader = XI_ConvertString("Sneak");
			sText1 = XI_ConvertString("Sneak_descr");
			sText2 = XI_ConvertString("Sneak_Up");

			sGroupPicture = "Luck";
			
			nSkill = sti(refCharacter.skill.sneak);
		break;
	}
	//SetFormatedText("INFO_WINDOW_CENTER_TEXT", sModifDown);
	//int iColor = argb(255,255,192,192);
	//SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_CENTER_TEXT", 8,-1,iColor);
	//SetFormatedText("INFO_WINDOW_CENTER2_TEXT", sModifUp);

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,192,192), sText3, argb(255,192,255,192), "", argb(255,255,255,255), sPicture, sGroup, sGroupPicture, 64, 64);
}

void ShowCrewTooltip()
{
	//g_bToolTipStarted = true;
	string sHeader = "";
	string sText1 = "";
	string stext2 = "";
	string sText3 = "";
	string sText4 = "";
	//int iColor1, iColor2, iColor3, iColor4;
	string sPicture = "none";
	string sGroup = "";
	string sGroupPicture = "";

	string sNode = GetCurrentNode();
	if(sNode == "CREW_TABLE1_TEXT" || sNode == "CREW_TABLE1")
	{
		int iChangerStep = SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CREW_TABLE1_TEXT", 11 );;

		switch(iChangerStep)
		{
			case 0:
				sHeader = XI_ConvertString("sailors");
				sText1 = XI_ConvertString("sailors_descr");
				sText2 = XI_ConvertString("Sailors_max") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].SailorCrew), "acc") + "\n" + XI_ConvertString("Sailors_min") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].SailorCrew)/10, "acc");
				//sText3 = XI_ConvertString("sailors_cost") + FindRussianMoneyString(SAILOR_PRICE) + ".";
			break;
			case 1:
				sHeader = XI_ConvertString("soldiers");
				sText1 = XI_ConvertString("soldiers_descr");
				sText2 = XI_ConvertString("soldiers_max") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].BoardingCrew), "acc") + "\n" + XI_ConvertString("Soldiers_min") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].BoardingCrew)/10, "acc");
				//sText3 = XI_ConvertString("soldiers_cost") + FindRussianMoneyString(BOARDING_PRICE) + ".";
			break;
			case 2:
				sHeader = XI_ConvertString("musketeers");
				sText1 = XI_ConvertString("musketeers_descr");
				sText2 = XI_ConvertString("musketeers_max") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].GunnerCrew), "acc") + "\n" + XI_ConvertString("musketeers_min") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].GunnerCrew)/10, "acc");
				//sText3 = XI_ConvertString("musketeers_cost") + FindRussianMoneyString(GUNNER_PRICE) + ".";
			break;
			case 3:
				sHeader = XI_ConvertString("cannoners");
				sText1 = XI_ConvertString("cannoners_descr");
				sText2 = XI_ConvertString("cannoners_max") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].CannonerCrew), "acc") + "\n" + XI_ConvertString("Cannoners_min") + FindRussianPeoplesString(sti(RealShips[sti(refCharacter.ship.type)].CannonerCrew)/10, "acc");
				//sText3 = XI_ConvertString("cannoners_cost") + FindRussianMoneyString(CANNONER_PRICE) + ".";
			break;
		}
	}
	if(GetCurrentNode() == "IMAGE_MORALE_OUR")
	{
		sHeader = XI_ConvertString("Morale");
		sText1 = XI_ConvertString("morale_descr");
		sText2 = XI_ConvertString("CrewMorale") + ": " + XI_ConvertString(GetMoraleName(sti(refCharacter.Ship.crew.morale)));
	}
	
	if(GetCurrentNode() == "IMAGE_EXP_OUR")
	{
		sHeader = XI_ConvertString("Experience");
		sText1 = XI_ConvertString("exp_descr");
		sText2 = XI_ConvertString("CrewExp") + ": " + XI_ConvertString(GetExpName(sti(refCharacter.Ship.crew.experience)));
	}

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,255,255), sText3, argb(255,192,255,192), stext4, argb(255,255,192,192), sPicture, sGroup, sGroupPicture, 64, 64);
}

void ShowFlowDescription()
{
	if(GetCurrentNode() == "MAIN_WINDOW_FLOW_PICTURE")
	{
		string sHeader = "";
		string sText1 = "";
		string stext2 = "";
		string sText3 = "";
		string sText4 = "";
		//int iColor1, iColor2, iColor3, iColor4;
		string sPicture = "none";
		string sGroup = "";
		string sGroupPicture = "";

		sHeader = XI_ConvertString("Flow");
		sText1 = XI_ConvertString("FlowDescription");

		CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,255,255), sText3, argb(255,192,255,192), stext4, argb(255,255,192,192), sPicture, sGroup, sGroupPicture, 64, 64);
	}
}

void SetShipCapacity()
{
	int nGood = sti(GoodsListExchange[iStep].index);
	string sOurCargo = GetCargoLoadEx(refCharacter, iGoodsChange, nGood) + " / " + GetCargoMaxSpace(refCharacter);
	string sOtherCargo = GetCargoLoadEx(refExCharacter, -iGoodsChange, nGood) + " / " + GetCargoMaxSpace(refExCharacter);
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 9, "#"+sOurCargo );
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 10, "#"+sOtherCargo );
}

void SetShipSpeedManeuver()
{
	int iShip;
	float fTmp;
	string sText;

	int nGood = sti(GoodsListExchange[iStep].index);

	/*int iGoodsQ, iGoodsQOther;
	if(iGoodsChange >= 0)
	{
		iGoodsQ = iGoodsChange;
		iGoodsQOther = -iGoodsChange;
	}
	else
	{
		iGoodsQ = iGoodsChange;
		iGoodsQOther = -iGoodsChange;
	}*/

	iShip = sti(refCharacter.ship.type);
	// our maneuver
	fTmp = stf(RealShips[iShip].turnrate) * FindShipTurnRateEx(refCharacter, iGoodsChange, nGood);
	sText  = FloatToString(fTmp,2) + " / " + FloatToString(stf(RealShips[iShip].TurnRate),2);
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 4, "#"+sText );
	// our speed
	fTmp = FindShipSpeedEx(refCharacter, iGoodsChange, nGood);
	sText  = FloatToString(fTmp,2) + " / " + FloatToString(stf(RealShips[iShip].SpeedRate),2);
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 3, "#"+sText );

	iShip = sti(refExCharacter.ship.type);
	// enemy maneuver
	fTmp = stf(RealShips[iShip].turnrate) * FindShipTurnRateEx(refExCharacter, -iGoodsChange, nGood);
	sText  = FloatToString(fTmp,2) + " / " + FloatToString(stf(RealShips[iShip].TurnRate),2);
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 6, "#"+sText );
	// enemy speed
	sText  = FloatToString(FindShipSpeedEx(refExCharacter, -iGoodsChange, nGood),2) + " / " + FloatToString(stf(RealShips[iShip].SpeedRate),2);
	SendMessage( &GameInterface,"lslls",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STRINGS", 1, 5, "#"+sText );
}

void HideGoods(bool bHide)
{
	if( bHide ) {
		SetNodeUsing("TOP_HIDER",true);
		SetNodeUsing("BOTTOM_HIDER",true);
		SetClickable("EXCHANGE_BUY_OK_BUTTON",true);
		SetClickable("EXCHANGE_BUY_CANCEL_BUTTON",true);
		SetSelectable("EXCHANGE_TAKE_ALL",false);
		SetSelectable("EXCHANGE_SCROLLER",false);
		SetSelectable("EXCHANGE_WINDOW_CANCEL_BUTTON",false);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPTRADELIST", 13, true);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 13, true);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 13, true);
	} else {
		SetNodeUsing("TOP_HIDER",false);
		SetNodeUsing("BOTTOM_HIDER",false);
		SetClickable("EXCHANGE_BUY_OK_BUTTON",false);
		SetClickable("EXCHANGE_BUY_CANCEL_BUTTON",false);
		SetSelectable("EXCHANGE_TAKE_ALL",true);
		SetSelectable("EXCHANGE_SCROLLER",true);
		SetSelectable("EXCHANGE_WINDOW_CANCEL_BUTTON",true);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPTRADELIST", 13, false);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_SHIPQUANTITYLIST", 13, false);
		SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"EXCHANGE_STOREQUANTITYLIST", 13, false);
	}
}

void Exchange_TakeAll()
{
	int nQ;
	for(int i = 0; i < GOODS_QUANTITY; i ++)
	{
		iGoodsChange = 0;
		nQ = GetCargoGoods(refExCharacter,i);
		if(nq > 0)
		{
			ExchangeGoodInProcessEx(nQ, true, i);
		}
	}

	iGoodsChange = 0;
	FillExchangeInfo();
	SetShipCapacity();
	SetShipSpeedManeuver();
	UpdateWantTo();

	iStep = 0;
	SetExchangeGoodCounterPos();
}

void ExchangeGoodInProcessEx(int nQ, bool bIncomeGoods, int nGood)
{
	string sGood = Goods[nGood].name;
	//       

	//   
	if(!GetShipRemovable(refExCharacter))  
	{
		return;
	}
	
	//    -  
	if(CheckAttribute(refExCharacter,"ship.cargo.goods."+sGood+".isquest") && sti(refExCharacter.ship.cargo.goods.(sGood).isquest) == 1) 
	{
		return;
	}

	if(nQ > GetCargoGoods(refExCharacter, nGood))
	{
		nQ = GetCargoGoods(refExCharacter, nGood);
	}

	int iCap = GetCharacterFreeSpace(refCharacter, nGood);

	if(nQ > iCap)
	{
		nQ = iCap;
	}

	AddCharacterGoods(refCharacter, nGood, nQ);
	AddCharacterGoods(refExCharacter, nGood, -nQ);
}