
#define HULL			0
#define SAILS			1
#define CANNONS			2

int iUpgradeMode = HULL;
int iCannonMaterial;

string OldNodeName = "";

aref arShipList;
ref refCharacter;
ref refPassenger;

int shipsCount= 0;

//shipScroll
int nCurSScrollNum = 0;
int nCurOScrollNum = 0;

int nCurScrollNum = 0;

//repair

float newRepairHullValuePercent = 0.0;
float newRepairSailValuePercent = 0.0;

float newRepairSailValue = 0;
float newRepairHullValue = 0;
int newRepairCannonValue = 0;
int isFirstTimeSlider = 0;

int iCost, iRepairCost;
int iHullRepairCost = 0;
int iSailsRepairCost = 0;
int iCannonsRepairCost = 0;
int iFullPrice = 0;

int SquadronSize = 0;
int iStoreLine = 0;
//

//store
int iShipStoreListIndex=0;
//

//officers
int nCurScrollOldNum= 0;
//
float fColony;

#define MODE_BUY	1
#define MODE_SELL	2
#define MODE_EXCHANGE	3
#define MODE_SHOW	4

object ShipInfo[COMPANION_MAX];


int iConfirmMode = MODE_SHOW;

bool bDebugMode = true;

bool g_bToolTipStarted = false;
ref refShipMaster;
//-------------------------------------------------------------------------------------
void InitInterface_R(string iniName,ref shipmaster)
{
	newRepairHullValuePercent = 0.0;
	newRepairSailValuePercent = 0.0;

    GameInterface.title = "titleShipyard";
	makearef(arShipList,shipmaster.shipyard);
	int iColony = FindLocation(shipmaster.location);
	iColony = FindColony(Locations[iColony].fastreload);
	if(sti(colonies[iColony].capture_flag) == 1)
	{
		fColony = 0.8;
	}
	else
	{
		fColony = 1.0;
	}
	refCharacter = pchar;
	refShipMaster = shipmaster;

	iCannonMaterial = refCharacter.ship.upgrades.cannons;

    FillShipScroll();
	UpdateCharacterInfo();
	FillUpgradeScroll("Hull");

	SendMessage(&GameInterface,"ls",MSG_INTERFACE_INIT,iniName);
	FillShipStoreScroll();
	FillPassengersScroll("passengers");

	string sColony = shipmaster.location;
	int iLocation = FindLocation(sColony);
	sColony = locations[iLocation].townsack
	
	string sText = XI_ConvertString("Colony"+sColony) + " " + XI_ConvertString("Shipyard");
	SetFormatedText("MAIN_WINDOW_CAPTION1", sText);

	sText = XI_ConvertString("OurMoney") + ": " + FindRussianMoneyString(sti(pchar.money));
	SetFormatedText("MAIN_WINDOW_INFO", sText);
	
	SetEventHandler("InterfaceBreak","ProcessCancelExit",0);
    SetEventHandler("frame","ProcessFrame",1);
    SetEventHandler("exitCancel","ProcessCancelExit",0);
	SetEventHandler("ievnt_command","ProcessCommandExecute",0);
	SetEventHandler("FTChange","OnSelectList",0);
	SetEventHandler("CloseMessageWindow","CloseMessageWindow",0);
	SetEventHandler("ShowInfoWindow","ShowInfoWindow",0);
	SetEventHandler("BuyShip","BuyShip",0);
	SetEventHandler("SellShip","SellShip",0);
	SetEventHandler("CancelBuyShip","HideInfoWindow",0);
	SetEventHandler("ChangeCaptain","ChangeCaptain",0);
	SetEventHandler("acceptofficer","acceptofficer",0);
	SetEventHandler("ConfirmSellBuyShip","ConfirmSellBuyShip",0);
	SetEventHandler("ConfirmUpgradeShip","ConfirmUpgradeShip",0);
	SetEventHandler("CancelUpgradeShip","CancelUpgradeShip",0);
	SetEventHandler("PrepareUpgrade","PrepareUpgrade",0);
	SetEventHandler("ClickHullUpgrade","ClickHullUpgrade",0);
	SetEventHandler("ClickSailsUpgrade","ClickSailsUpgrade",0);
	SetEventHandler("ClickCannonsUpgrade","ClickCannonsUpgrade",0);
	SetEventHandler("CheckButtonChange","CannonMaterialChange",0);
	SetEventHandler("ClickRepairWindow","ClickRepairWindow",0);
	SetEventHandler("ClickRepairOkButton", "ClickRepairOkButton",0);
	SetEventHandler("ClickRepairCancelButton", "ClickRepairCancelButton",0);
	SetEventHandler("AddHull", "AddHull",0);
	SetEventHandler("RemoveHull", "RemoveHull",0);
	SetEventHandler("AddSails", "AddSails",0);
	SetEventHandler("RemoveSails", "RemoveSails",0);
	SetEventHandler("AddCannons", "AddCannons",0);
	SetEventHandler("RemoveCannons", "RemoveCannons",0);
	SetEventHandler("ShowShipTooltip", "ShowShipTooltip",0);
	SetEventHandler("MouseRClickUP","EndTooltip",0);
	
	SetSelectable("UPGRADE_WINDOW_OK_BUTTON", false);
	SetNodeUsing("CANNONS_CALIBER", false);

	FillCrewQuantityArray();
	ClickBuyTab();
	ProcessFrame();
}

void FillCrewQuantityArray()
{
	int cn = -1;
	int m = 0;
	
	refShipMaster.shipyard.crew.quantity = 0;
	refShipMaster.shipyard.crew.BoardingCrew = 0;
	refShipMaster.shipyard.crew.SailorCrew = 0;
	refShipMaster.shipyard.crew.GunnerCrew = 0;
	refShipMaster.shipyard.crew.CannonerCrew = 0;

	/*for (int i = 0; i < COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(pchar, i);
		if(cn != -1)
		{
			ShipInfo[m].character = cn;
			ShipInfo[m].crew.quantity = sti(characters[cn].ship.crew.quantity);
			ShipInfo[m].crew.BoardingCrew = sti(characters[cn].ship.crew.BoardingCrew);
			ShipInfo[m].crew.SailorCrew = sti(characters[cn].ship.crew.SailorCrew);
			ShipInfo[m].crew.GunnerCrew = sti(characters[cn].ship.crew.GunnerCrew);
			ShipInfo[m].crew.CannonerCrew = sti(characters[cn].ship.crew.CannonerCrew);
			m ++;
		}
	}*/
}
//-------------------------------------------------------------------------------------
//     ...shipsScroll....
//-------------------------------------------------------------------------------------
ref GetCharacterRefFromScroll()
{
	int scrollIndex = nCurSScrollNum + 1;
	if (scrollIndex< 1) scrollIndex = 1;

	string attributeName = "pic" + scrollIndex;


	int cn = GetCompanionIndex(pchar, 0);

	string str = "SHIPS_SCROLL."+attributeName+".companionIndex";

	string sText = "";
	if(CheckAttribute(&GameInterface,str))
	{
		cn = sti(GameInterface.SHIPS_SCROLL.(attributeName).companionIndex);
		sText = characters[cn].ship.name;
		sText = "'" + sText + "'";
		SetFormatedText("MAIN_WINDOW_CAPTION2", sText);
	}

	return &Characters[cn];
}
//-------------------------------------------------------------------------------------
int GetCharacterIDFromScroll()
{
	int scrollIndex = nCurSScrollNum + 1;
	if (scrollIndex< 1) scrollIndex = 1;

	string attributeName = "pic" + scrollIndex;

	int cn = -1;
	if(CheckAttribute(GameInterface, "SHIPS_SCROLL." + attributeName))
	{
		cn = sti(GameInterface.SHIPS_SCROLL.(attributeName).companionIndex);
	}

	return cn;
}
//-------------------------------------------------------------------------------------
int GetShipBaseTypeFromScroll()
{
	int scrollIndex = nCurSScrollNum + 1;
	if (scrollIndex< 1) scrollIndex = 1;

	string attributeName = "pic" + scrollIndex;

	int basetype = -1;
	if(CheckAttribute(&GameInterface, "SHIPS_SCROLL." + attributeName + ".companionIndex"))
	{
		int cn = sti(GameInterface.SHIPS_SCROLL.(attributeName).companionIndex);
		cn = sti(Characters[cn].ship.type);

		basetype = sti(RealShips[cn].basetype);
	}
	else
	{
		return SHIP_NOTUSED;
	}

	return basetype;
}
//-------------------------------------------------------------------------------------
void UpdateShipScroll()
{

	DeleteAttribute(&GameInterface,"SHIPS_SCROLL");

	if(!CheckAttribute(&GameInterface,"SHIPS_SCROLL.current"))
	{
		GameInterface.SHIPS_SCROLL.current = 0;
	}

	FillShipScroll();

	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"SHIPS_SCROLL",-1);
}


//-------------------------------------------------------------------------------------
void FillShipScroll()
{
	nCurSScrollNum = -1;

	DeleteAttribute(&GameInterface, "SHIPS_SCROLL");
	
	GameInterface.SHIPS_SCROLL.ImagesGroup.t0 = "BLANK_SHIP2";
	GameInterface.SHIPS_SCROLL.BadTex1 = 0;
	GameInterface.SHIPS_SCROLL.BadPic1 = "Not Used2";

	FillShipList("SHIPS_SCROLL.ImagesGroup", pchar);

	nCurSScrollNum = -1;

	string attributeName;
	string shipName;
	int iShipType, cn;

	shipsCount= 0;

	string tex;

	int m = 0;
	for(int i = 0; i < COMPANION_MAX; i++)
	{
		cn = GetCompanionIndex(pchar, i);

		if(cn != -1)
		{

			iShipType = GetCharacterShipBaseType(cn);

			if (iShipType!= SHIP_NOTUSED)
			{

				shipName = ShipsTypes[iShipType].Name;

				attributeName = "pic" + (m+1);

				GameInterface.SHIPS_SCROLL.(attributeName).companionIndex = cn;
				GameInterface.SHIPS_SCROLL.(attributeName).str1 = "#"+ShipsTypes[iShipType].Class;
				GameInterface.SHIPS_SCROLL.(attributeName).str2 = XI_ConvertString(shipName);
				GameInterface.SHIPS_SCROLL.(attributeName).img1 = "ship";

				tex= FindFaceGroupNum("SHIPS_SCROLL.ImagesGroup","SHIPS_"+shipName);
				if (tex == "-1") tex= "0";

				GameInterface.SHIPS_SCROLL.(attributeName).tex1 = tex;

				shipsCount++;
				m++;		
			}
		} 
	}

	GameInterface.SHIPS_SCROLL.ListSize = m;
	GameInterface.SHIPS_SCROLL.NotUsed = 5;	
	
}
//-------------------------------------------------------------------------------------
//     ...characterInfo....
//-------------------------------------------------------------------------------------
void UpdateCharacterInfo()
{

	if(!shipsCount || nCurSScrollNum>= shipsCount || nCurSScrollNum>= GetCompanionQuantity(pchar))
	{
		SetFormatedText("SHIP_WINDOW_INFO", " ");

		SetSelectable("REPAIR_BUTTON",   false);
		SetSelectable("SELLSHIP_BUTTON", false);
		SetSelectable("CHANGE_CAPTAIN",  false);
		SetSelectable("BUYSHIP_BUTTON",  IsEnableBuyShip());
	}

	if (nCurSScrollNum == 0)
	{

		SetSelectable("SELLSHIP_BUTTON", false);
	} 
	else 
	{
		SetSelectable("SELLSHIP_BUTTON", IsEnableSellShip());
	}


	SetNodeUsing("MAIN_CHARACTER_PICTURE", true);

	refCharacter = GetCharacterRefFromScroll(); 

	sText = XI_ConvertString("OurMoney") + ": " + FindRussianMoneyString(sti(pchar.money));
	SetFormatedText("MAIN_WINDOW_INFO", sText);

	string sText;
	SetFormatedText("SHIP_WINDOW_INFO", "");
	SetFormatedText("SHIP_SELL_PRICE", "");
	

	if(sti(refCharacter.ship.type) != SHIP_NOTUSED)
	{
		sText = "HULL_UPGRADE_" + refCharacter.ship.upgrades.hull;
		SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_HULL", 6, sText, "hull");
		
		sText = "SAILS_UPGRADE_" + refCharacter.ship.upgrades.sails;
		SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_SAILS", 6, sText, "sails");
		
		sText = "CANNONS_UPGRADE_" + refCharacter.ship.upgrades.cannons;
		string sCannonPict = Cannon[sti(refCharacter.ship.cannons.type)].picture;
		SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_CANNONS", 6, sText, sCannonPict);

		int basetype = sti(refCharacter.ship.type);
		string sShipClassName = ShipsTypes[sti(Realships[basetype].basetype)].name;
		if(sShipClassName == "WarTartane")
		{
			sShipClassName = "Tartane";
		}
		
		sText = XI_ConvertString(sShipClassName);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = Realships[basetype].class;
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = sti(refCharacter.ship.hp) + " / " + sti(Realships[basetype].HP);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = sti(refCharacter.ship.sp) + " / " + sti(Realships[basetype].SP);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = GetIntactCannonQuantity(refCharacter) + " / " + Realships[basetype].CannonsQuantity;
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);
		
		sText = XI_ConvertString(Cannon[sti(refCharacter.ship.cannons.type)].name);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = XI_ConvertString("caliber" + RealShips[basetype].MaxCaliber);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = fts(stf(Realships[basetype].SpeedRate), 3);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);
		sText = fts(stf(Realships[basetype].TurnRate), 3);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);


		sText = GetCargoLoad(refCharacter) + " / " + Realships[basetype].Capacity;
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = sti(refCharacter.ship.crew.quantity) + " / " + sti(Realships[basetype].maxcrew);
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 0,	&sText);

		sText = XI_ConvertString("SellCost") + "\n" + FindRussianMoneyString(GetSellPrice());
		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_PRICE", 0, &sText);


		int iRealShipType = sti(RealShips[basetype].basetype);
		string shipName = ShipsTypes[iRealShipType].name;
		SetNewPicture("SHIP_PICTURE", "interfaces\ships\" + shipName + ".tga");
		SetNewPicture("CAPTAIN_PICTURE", "interfaces\portraits\64\face_" + refCharacter.FaceId + ".tga");
	}

	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 1, 0);
	SendMessage(&GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 1, 0);


	SetSelectable("REPAIR_BUTTON",   IsEnableRepairShip());
	SetSelectable("SELLSHIP_BUTTON", IsEnableSellShip());
	SetSelectable("UPGRADE_BUTTON",   IsEnableUpgradeShip());
	SetSelectable("BUYSHIP_BUTTON",  IsEnableBuyShip());
	
	//Cerez: Disabled buggy double implementation of 'Replace Captain'
	//SetSelectable("EXCHANGE_BUTTON",  IsEnableChangeCaptain());
	SetSelectable("EXCHANGE_BUTTON",  false);

	FillShipStoreScroll();

	if(!CheckAttribute(refShipMaster, "shipyard.crew.quantity"))
	{
		refShipMaster.shipyard.crew.quantity = 0;
	}
	sText = XI_ConvertString("FreeCrewLeftInShipyard") + FindRussianPeoplesString(sti(refShipMaster.shipyard.crew.quantity), "Acc");
	SetFormatedText("CREW_STORE_QUANTITY", sText);
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"CREW_STORE_QUANTITY", 5 );
}

string GetCharacterShipHull()
{
	string sResult;
	int iShip = sti(refCharacter.ship.type);
	sResult = sti(refCharacter.ship.hp) + "/" + sti(Realships[iShip].hp);
	return sResult;
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
//     ...events....
//-------------------------------------------------------------------------------------
void ProcessFrame()
{
	if(nCurSScrollNum!= sti(GameInterface.SHIPS_SCROLL.current))
	{
		nCurSScrollNum = sti(GameInterface.SHIPS_SCROLL.current);
		UpdateCharacterInfo();
	}


	if(nCurOScrollNum!= sti(GameInterface.OFFICERS_SCROLL.current))
	{
		nCurOScrollNum = sti(GameInterface.OFFICERS_SCROLL.current);
		RefreshOfficerWindow();
	}

	if(nCurScrollNum!= sti(GameInterface.UPGRADE_SCROLL.current) && GetCurrentNode() == "UPGRADE_SCROLL")
	{
		nCurScrollNum = sti(GameInterface.UPGRADE_SCROLL.current);
		string sMode;
		switch(iUpgradeMode)
		{
			case HULL:
				sMode = "hull";
			break;
			case SAILS:
				sMode = "sails";
			break;
			case CANNONS:
				sMode = "cannons";
			break;
		}
		FillUpgradeInfo(sMode);
		if(CheckForUpgrade())
		{
			SetSelectable("UPGRADE_WINDOW_OK_BUTTON",true);
		}
		else
		{
			SetSelectable("UPGRADE_WINDOW_OK_BUTTON",false);
		}
	}
}

//-------------------------------------------------------------------------------------
void ProcessCancelExit()
{

	//SetTimeScale(1.0);
	//locCameraSleep(false);

	DelEventHandler("InterfaceBreak","ProcessCancelExit");
	DelEventHandler("frame","ProcessFrame");
	DelEventHandler("exitCancel","ProcessCancelExit");
	DelEventHandler("ievnt_command","ProcessCommandExecute");
	//DelEventHandler("FormatedTextActivate","OnSelectList");
	DelEventHandler("FTChange","OnSelectList");
	DelEventHandler("CloseMessageWindow","CloseMessageWindow");
	DelEventHandler("ShowInfoWindow","ShowInfoWindow");
	DelEventHandler("BuyShip","BuyShip");
	DelEventHandler("SellShip","SellShip");
	DelEventHandler("CancelBuyShip","HideInfoWindow");
	DelEventHandler("ChangeCaptain","ChangeCaptain");
	DelEventHandler("acceptofficer","acceptofficer");
	DelEventHandler("ConfirmSellBuyShip","ConfirmSellBuyShip");
	DelEventHandler("ConfirmUpgradeShip","ConfirmUpgradeShip");
	DelEventHandler("CancelUpgradeShip","CancelUpgradeShip");
	DelEventHandler("PrepareUpgrade","PrepareUpgrade");
	DelEventHandler("ClickHullUpgrade","ClickHullUpgrade");
	DelEventHandler("ClickSailsUpgrade","ClickSailsUpgrade");
	DelEventHandler("ClickCannonsUpgrade","ClickCannonsUpgrade");
	DelEventHandler("CheckButtonChange","CannonMaterialChange");
	DelEventHandler("ClickRepairWindow","ClickRepairWindow");
	DelEventHandler("ClickRepairOkButton", "ClickRepairOkButton");
	DelEventHandler("ClickRepairCancelButton", "ClickRepairCancelButton");
	DelEventHandler("AddHull", "AddHull");
	DelEventHandler("RemoveHull", "RemoveHull");
	DelEventHandler("AddSails", "AddSails");
	DelEventHandler("RemoveSails", "RemoveSails");
	DelEventHandler("AddCannons", "AddCannons");
	DelEventHandler("RemoveCannons", "RemoveCannons");
	DelEventHandler("ShowShipTooltip", "ShowShipTooltip");
	DelEventHandler("MouseRClickUP","EndTooltip");
	
	interfaceResultCommand = RC_INTERFACE_SHIPYARD_EXIT;

	if (checkAttribute(pchar, "shipfame"))
	{
		if (pchar.ship.name != pchar.shipfame.shipname)
		{
			ShipFameErase(pchar);
		}
	}

	if(CheckAttribute(refShipMaster, "shipyard.crew.quantity"))
	{
		int iColony = FindLocation(refShipMaster.location);
		iColony = FindColony(Locations[iColony].fastreload);

		colonies[iColony].crew.sailors = sti(colonies[iColony].crew.sailors) + sti(refShipMaster.shipyard.crew.BoardingCrew);
		colonies[iColony].crew.soldiers = sti(colonies[iColony].crew.soldiers) + sti(refShipMaster.shipyard.crew.SailorCrew);
		colonies[iColony].crew.musketeers = sti(colonies[iColony].crew.musketeers) + sti(refShipMaster.shipyard.crew.GunnerCrew);
		colonies[iColony].crew.cannoners = sti(colonies[iColony].crew.cannoners) + sti(refShipMaster.shipyard.crew.CannonerCrew);
	}

	EndCancelInterface(true);
}

//-------------------------------------------------------------------------------------
void ProcessCommandExecute()
{
	int i,cn;
	int hullcost,sailcost;

	string comName = GetEventData();
	string nodName = GetEventData();

	switch(nodName)
	{

	case "MAIN_WINDOW_LEFTSCROLLBUTTON":
		if(comName == "click")
		{

			SetCurrentNode("SHIPS_SCROLL");
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPS_SCROLL",-1, 0,ACTION_LEFTSTEP);
		}
		break;

	case "MAIN_WINDOW_RIGHTSCROLLBUTTON":
		if(comName == "click")
		{
			SetCurrentNode("SHIPS_SCROLL");
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPS_SCROLL",-1, 0,ACTION_RIGHTSTEP);
		}
		break;

	}
}


//-------------------------------------------------------------------------------------
void OnSelectList()
{
	string nodeName = GetEventData();
	float newPos = GetEventData(); 

	if(nodeName == "SHIPTRADELIST")
	{
		iShipStoreListIndex =  SendMessage(&GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 11);
		iStoreLine = iShipStoreListIndex;
		iShipStoreListIndex = GetShipStoreBaseType();
		SetStoreShipDescription();
	}
}
//-------------------------------------------------------------------------------------
//     ...officerWindow....
//-------------------------------------------------------------------------------------
void RefreshOfficerWindow()
{	

	string sCharacter = "pic"+(sti(GameInterface.OFFICERS_SCROLL.current)+1);
	if (checkAttribute(GameInterface, "OFFICERS_SCROLL."+sCharacter))
	{
		sCharacter = GameInterface.OFFICERS_SCROLL.(sCharacter).character;
		SetFormatedText("INFO_WINDOW_SUB_CAPTION", GetCharacterFullName(sCharacter));
		refPassenger = CharacterFromID(sCharacter);

		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"leadershipoc", refPassenger.skill.temp.Leadership, FONT_BOLD_NUMBERS,	292,328, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.Leadership))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);	
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"sailingoc", refPassenger.skill.temp.sailing, FONT_BOLD_NUMBERS,	359,328, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.sailing))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);	
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"fencingoc", refPassenger.skill.temp.fencing, FONT_BOLD_NUMBERS,	426,328, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.fencing))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"gunoc", refPassenger.skill.temp.gun, FONT_BOLD_NUMBERS,	493,328, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.gun))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"cannonsoc", refPassenger.skill.temp.cannons, FONT_BOLD_NUMBERS,	560,328, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.cannons))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Accuracyoc", refPassenger.skill.temp.accuracy, FONT_BOLD_NUMBERS,	292,362, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.accuracy))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Grapplingoc", refPassenger.skill.temp.grappling, FONT_BOLD_NUMBERS,	359,362, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.grappling))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"Defenceoc", refPassenger.skill.temp.defence, FONT_BOLD_NUMBERS,	426,362, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.defence))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"repairoc", refPassenger.skill.temp.repair, FONT_BOLD_NUMBERS,	493,362, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.repair))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);
		SendMessage(&GameInterface,"lslsssllllllfl", MSG_INTERFACE_MSG_TO_NODE,"OFFICER_WINDOW_STRINGS",0,"commerceoc", refPassenger.skill.temp.commerce, FONT_BOLD_NUMBERS,	560,362, SetAlphaIntoColor(COLOR_NORMAL,GetAlphaFromSkill(sti(refPassenger.skill.temp.commerce))),0, SCRIPT_ALIGN_RIGHT, true, 0.7, 420);

		int iPenalty = CheckSkillDownModifier(refCharacter, iShipStoreListIndex);
		string sText = "";
		if(iPenalty > 0)
		{
			sText = XI_ConvertString("SkillsPenalty") + ": " + iPenalty;
			SetFormatedText("INFO_WINDOW_TEXT_SHIP_PENALTY", sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_TEXT_SHIP_PENALTY", 8,0,argb(255,255,196,196));
		}
		else
		{
			sText = XI_ConvertString("NoSkillsPenalty");
			SetFormatedText("INFO_WINDOW_TEXT_SHIP_PENALTY", sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_TEXT_SHIP_PENALTY", 8,0,argb(255,255,255,255));
		}

		int iShip = sti(RealShips[iShipStoreListIndex].basetype);
		string shipName = ShipsTypes[iShip].name;

		sText = XI_ConvertString("QuestionBuyCost") + " " + XI_ConvertString(shipName) + " " + XI_ConvertString("for_cost") + " " + FindRussianMoneyString(GetBuyPrice(iShipStoreListIndex + 1)) + "?";
		SetFormatedText("INFO_WINDOW_TEXT_PRICE", sText);

		bool isCanBuyShip = IsEnableBuyShipForCharacter();
		SetSelectable("CONFIRM_WINDOW_OK_BUTTON", isCanBuyShip);
		if(isCanBuyShip == false)
		{
			sText = XI_ConvertString("TacticSkillIsNotEnoughOnlyPlayerAllowed");
			SetFormatedText("INFO_WINDOW_TEXT_SHIP_PENALTY", sText);
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_TEXT_SHIP_PENALTY", 8,0,argb(255,255,196,196));
		}

		SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"INFO_WINDOW_TEXT_SHIP_PENALTY", 5 );

	}
}

//-------------------------------------------------------------------------------------
//     ...show hide windows....
//-------------------------------------------------------------------------------------
void ShowInfoWindow()
{
	iConfirmMode = MODE_SHOW;
	ShowInfoWindowComplete(0);
}

void BuyShip()
{
	iConfirmMode = MODE_BUY;
	ShowInfoWindowComplete(1);
}

void SellShip()
{
	iConfirmMode = MODE_SELL;
	ShowInfoWindowComplete(1);
}

void ShowInfoWindowComplete(int iMode)
{

	if(iConfirmMode == MODE_BUY)
	{
		XI_WindowDisable("MAIN_WINDOW", true);
		XI_WindowDisable("STORE_WINDOW", true);
		XI_WindowShow("INFO_WINDOW", true);
		XI_WindowDisable("INFO_WINDOW", false);

		FillPassengersScroll("passengers");
		SetCurrentNode("OFFICERS_SCROLL");

		SetFormatedText("INFO_WINDOW_CAPTION", XI_ConvertString("AddCompanionCaption"));
		
	}
	if(iConfirmMode == MODE_SELL)
	{
		XI_WindowDisable("MAIN_WINDOW", true);
		XI_WindowDisable("STORE_WINDOW", true);
		XI_WindowShow("SELL_WINDOW", true);
		XI_WindowDisable("SELL_WINDOW", false);

		int iShip = sti(refCharacter.ship.type);
		int iBaseType = sti(RealShips[iShip].basetype);
		string sShipName = ShipsTypes[iBaseType].name;
		SetNewPicture("SELL_WINDOW_PICTURE", "interfaces\ships\" + sShipName + ".tga");

		string sText = XI_ConvertString("QuestionSellCost") + " '" + refCharacter.ship.name + "' " + XI_ConvertString("for_cost") + " " + FindRussianMoneyString(GetSellPrice()) + "?";
		SetFormatedText("SELL_WINDOW_TEXT_PRICE", sText);

		SetCurrentNode("CONFIRM_WINDOW_CLOSE_BUTTON");
		SetSelectable("CONFIRM_WINDOW_OK_BUTTON", true);
	}
	

	// 
	/*string isSold = FindPosForShip(iRealShip);
	if(CheckAttribute(arShipList, isSold + ".buyed"))
	{
		if(sti(arShipList.(isSold).buyed) == 1)
		{
			SetFormatedText("INFO_WINDOW_TEXT_PRICE", XI_ConvertString("ShipSolded"));
		}
	}*/
}
//-------------------------------------------------------------------------------------
void HideInfoWindow()
{
	if(XI_IsWindowEnable("INFO_WINDOW") == true)
	{
		XI_WindowShow("INFO_WINDOW", false);
		XI_WindowDisable("INFO_WINDOW", true);
		XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowDisable("STORE_WINDOW", false);

		SetCurrentNode("SHIPS_SCROLL");
	}
	if(XI_IsWindowEnable("SELL_WINDOW") == true)
	{
		XI_WindowShow("SELL_WINDOW", false);
		XI_WindowDisable("SELL_WINDOW", true);
		XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowDisable("STORE_WINDOW", false);

		SetCurrentNode("SHIPS_SCROLL");
	}

	if(XI_IsWindowEnable("OFFICER_WINDOW") == true)
	{
		XI_WindowShow("OFFICER_WINDOW", false);
		XI_WindowDisable("OFFICER_WINDOW", true);
		XI_WindowDisable("MAIN_WINDOW", false);
		XI_WindowDisable("STORE_WINDOW", false);

		SetCurrentNode("SHIPS_SCROLL");
	}
}
//-------------------------------------------------------------------------------------
void ShowMessage(string message)
{

	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("STORE_WINDOW", true);
	XI_WindowDisable("MESSAGE_WINDOW", false);
	XI_WindowShow("MESSAGE_WINDOW", true);

	SetFormatedText("MESSAGE_WINDOW_TEXT", message);
	SetFormatedText("MESSAGE_WINDOW_CAPTION", XI_ConvertString("salesman"));
}
//-------------------------------------------------------------------------------------
void CloseMessageWindow()
{
	XI_WindowShow("MESSAGE_WINDOW", false);
	XI_WindowDisable("MESSAGE_WINDOW", true);
	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("STORE_WINDOW", false);
}
//-------------------------------------------------------------------------------------
	SetEventHandler("CloseMessageWindow","CloseMessageWindow",0);
//-------------------------------------------------------------------------------------
void ShowOfficerWindow()
{

	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("STORE_WINDOW", true);
	XI_WindowDisable("OFFICER_WINDOW", false);
	XI_WindowShow("OFFICER_WINDOW", true);

	FillPassengersScroll("companions");
	RefreshOfficerWindow();

	SetCurrentNode("OFFICERS_SCROLL");
}

//-------------------------------------------------------------------------------------
//     ...shipsStore....
//-------------------------------------------------------------------------------------
int GetShipStoreBaseType()
{
	int iNum = iShipStoreListIndex + 2;// + SHIP_LUGGER;
	string attributeName = "ship"+ iNum;

	int ship = sti(arShipList.(attributeName));
	//ship = sti(RealShips[ship].basetype)
	return ship;
}

//-------------------------------------------------------------------------------------
int GetShipStoreID()
{
	int iNum = iShipStoreListIndex + 2;// + SHIP_LUGGER;
	string attributeName = "ship"+ iNum;

	int ship = sti(arShipList.(attributeName));
		return     ship;
}

//-------------------------------------------------------------------------------------
void FillShipStoreScroll()
{
	SetFormatedText("SHIPTRADELIST", "");

	string sText;

	aref curref;
	ref currShip;
	int price;

	string attributeName;
	int ship,shipID;
	int m = 0;
	//int cannonType = CANNON_TYPE_NONECANNON;

	for(int i= SHIP_LUGGER; i< GetAttributesNum(arShipList); i++)
	{
		attributeName= "ship"+ i;

		shipID = sti(arShipList.(attributeName));
		price = GetBuyPrice(m + 1);

		ship = sti(RealShips[shipID].basetype);

		sText = " " + XI_ConvertString(ShipsTypes[ship].name);

		SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 0,&sText);

		/*if(CheckSkillDownModifier(refCharacter, shipID) > 0)
		{
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,m,argb(255,255,196,196));
		}
		else
		{
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,m,argb(255,255,255,255));
		}*/

		//cannonType = sti(ShipsTypes[ship].CannonsQuantity);
		
		//
		if(CheckAttribute(arShipList, attributeName + ".notforsale"))
		{
			if(sti(arShipList.(attributeName).notforsale) == 1)
			{
				SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,m,argb(255,192,192,192));
			}
		}
		if(CheckAttribute(arShipList, attributeName + ".buyed"))
		{
			if(sti(arShipList.(attributeName).buyed) == 1)
			{
				SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,m,argb(255,192,192,192));
			}
		}
		
		m++;		
	}
}

//-------------------------------------------------------------------------------------
void FillCharacterShipFields(ref rCharacter)
{
	int iShip = sti(rCharacter.ship.type);
	ref rBaseShip = GetRealShip(iShip);
	
	//ship name
	SetRandomNameToShip(rCharacter);

	//full repair
	rCharacter.ship.sp = rBaseShip.sp;
	rCharacter.ship.hp = rBaseShip.hp;

	if(CheckAttribute(rCharacter, "ship.sails.color"))
	{
		rCharacter.ship.oldsails.color = rCharacter.ship.sails.color;
	}
	if(CheckAttribute(rCharacter, "ship.sails.gerald_name"))
	{
		rCharacter.ship.oldsails.gerald_name = rCharacter.ship.sails.gerald_name;
	}
	DeleteAttribute(rCharacter,"ship.sails");
	DeleteAttribute(rCharacter,"ship.masts");
	DeleteAttribute(rCharacter,"ship.blots");

	//crew
	rCharacter.ship.crew.quantity = rBaseShip.MaxCrew;
	rCharacter.ship.crew.morale = "45";
	rCharacter.ship.crew.experience= "10";
	//pos
	rCharacter.ship.Pos.x = 0;
	rCharacter.ship.Pos.z = 0;
	rCharacter.ship.Ang = "";

	//cannons
	rCharacter.ship.cannons.borts = rBaseShip.cannons.borts;
	rCharacter.ship.cannons.charge.type = GOOD_BALLS;
	rCharacter.ship.cannons.type = rBaseShip.cannon);
	rCharacter.ship.CannonsQuantity = rBaseShip.CannonsQuantity;

	rCharacter.ship.upgrades.hull = 1;
	rCharacter.ship.upgrades.sails = 1;
	rCharacter.ship.upgrades.cannons = 1;

	RealShips[iShip].lock = 1;

	if(CheckAttribute(rCharacter, "ship.oldsails.color"))
	{
		rCharacter.ship.sails.color = rCharacter.ship.oldsails.color;
	}
	if(CheckAttribute(rCharacter, "ship.oldsails.gerald_name"))
	{
		rCharacter.ship.sails.gerald_name = rCharacter.ship.oldsails.gerald_name;
	}

	DeleteAttribute(rCharacter.ship,"ShipRemovable");
}
//-------------------------------------------------------------------------------------

void ConfirmSellBuyShip()
{
	if(iConfirmMode == MODE_BUY)
	{
		DoBuyShip();
	}
	if(iConfirmMode == MODE_SELL)
	{
		DoSellShip();
	}

	HideInfoWindow();
}

void DoBuyShip()
{	
	if(refPassenger.id == pchar.id)
	{
		refShipMaster.shipyard.crew.quantity = sti(refShipMaster.shipyard.crew.quantity) + sti(refPassenger.ship.crew.quantity);
		refShipMaster.shipyard.crew.BoardingCrew = sti(refShipMaster.shipyard.crew.BoardingCrew) + sti(refPassenger.ship.crew.BoardingCrew);
		refShipMaster.shipyard.crew.SailorCrew = sti(refShipMaster.shipyard.crew.SailorCrew) + sti(refPassenger.ship.crew.SailorCrew);
		refShipMaster.shipyard.crew.GunnerCrew = sti(refShipMaster.shipyard.crew.GunnerCrew) + sti(refPassenger.ship.crew.GunnerCrew);
		refShipMaster.shipyard.crew.CannonerCrew = sti(refShipMaster.shipyard.crew.CannonerCrew) + sti(refPassenger.ship.crew.CannonerCrew);
	}

	int sq = GetRealShipsCount();

	int shipType = iShipStoreListIndex;

	string sPos = FindPosForShip(shipType);
	//arShipList.(sPos).buyed = 1;
	
	int iPos = FindStringPosForShip(shiptype);
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"SHIPTRADELIST", 8,iPos,argb(255,192,192,192));

	refPassenger.ship.basetype = RealShips[shipType].basetype;
	refPassenger.ship.type = shipType;

	FillCharacterShipFields(&refPassenger);
	refPassenger.ship.cargo.load = 0;

	if(refPassenger.id != pchar.id)
	{
		RemovePassenger(pchar, refPassenger);
		SetCompanionIndex(pchar,-1, sti(refPassenger.index));
	}

	SetBaseShipData(refPassenger);

	//money
	int price = GetBuyPrice(iShipStoreListIndex);
	AddMoneyToCharacter(pchar, -price);

	//bool isSuccessFillCrewInfo = false;
	FillCrewToShip(refPassenger);
	/*int cn = -1;
	int m = 0;
	for(int n = 0; n < COMPANION_MAX; n++)
	{
		cn = GetCompanionIndex(pchar, n);
		if(cn == sti(ShipInfo[m].character))
		{
			characters[cn].ship.crew.BoardingCrew = ShipInfo[m].crew.BoardingCrew;
			if(sti(RealShips[shipType].BoardingCrew) < sti(characters[cn].ship.crew.BoardingCrew))
			{
				characters[cn].ship.crew.BoardingCrew = RealShips[shipType].BoardingCrew;
			}

			characters[cn].ship.crew.SailorCrew = ShipInfo[m].crew.SailorCrew;
			if(sti(RealShips[shipType].SailorCrew) < sti(characters[cn].ship.crew.SailorCrew))
			{
				characters[cn].ship.crew.SailorCrew = RealShips[shipType].SailorCrew;
			}

			characters[cn].ship.crew.GunnerCrew = ShipInfo[m].crew.GunnerCrew;
			if(sti(RealShips[shipType].GunnerCrew) < sti(characters[cn].ship.crew.GunnerCrew))
			{
				characters[cn].ship.crew.GunnerCrew = RealShips[shipType].GunnerCrew;
			}

			characters[cn].ship.crew.CannonerCrew = ShipInfo[m].crew.CannonerCrew;
			if(sti(RealShips[shipType].CannonerCrew) < sti(characters[cn].ship.crew.CannonerCrew))
			{
				characters[cn].ship.crew.CannonerCrew = RealShips[shipType].CannonerCrew;
			}

			characters[cn].ship.crew.quantity = sti(characters[cn].ship.crew.BoardingCrew) + sti(characters[cn].ship.crew.SailorCrew) + sti(characters[cn].ship.crew.GunnerCrew) + sti(characters[cn].ship.crew.CannonerCrew);

			isSuccessFillCrewInfo = true;

			m++;
		}
	}
	*/

	/*if(isSuccessFillCrewInfo == false)
	{
		refCharacter.ship.crew.BoardingCrew = sti(RealShips[shipType].BoardingCrew) / 10;
		refCharacter.ship.crew.SailorCrew = RealShips[shipType].mincrew;
		refCharacter.ship.crew.GunnerCrew = sti(RealShips[shipType].GunnerCrew) / 10;
		refCharacter.ship.crew.CannonerCrew = sti(RealShips[shipType].CannonerCrew) / 10;

		refCharacter.ship.crew.quantity = sti(refCharacter.ship.crew.BoardingCrew) + sti(refCharacter.ship.crew.SailorCrew) + sti(refCharacter.ship.crew.GunnerCrew) + sti(refCharacter.ship.crew.CannonerCrew);
	}*/

	UpdateShipScroll();
	RecalculateCargoLoad(refCharacter);
	UpdateCharacterInfo();

}
//-------------------------------------------------------------------------------------
void DoSellShip()
{
	int sellPrice = GetSellPrice();

	refShipMaster.shipyard.crew.quantity = sti(refShipMaster.shipyard.crew.quantity) + sti(refCharacter.ship.crew.quantity);
	refShipMaster.shipyard.crew.BoardingCrew = sti(refShipMaster.shipyard.crew.BoardingCrew) + sti(refCharacter.ship.crew.BoardingCrew);
	refShipMaster.shipyard.crew.SailorCrew = sti(refShipMaster.shipyard.crew.SailorCrew) + sti(refCharacter.ship.crew.SailorCrew);
	refShipMaster.shipyard.crew.GunnerCrew = sti(refShipMaster.shipyard.crew.GunnerCrew) + sti(refCharacter.ship.crew.GunnerCrew);
	refShipMaster.shipyard.crew.CannonerCrew = sti(refShipMaster.shipyard.crew.CannonerCrew) + sti(refCharacter.ship.crew.CannonerCrew);

	if(pchar.id != refCharacter.id)
	{
		RemoveCharacterCompanion(pchar, refCharacter);
		AddPassenger(pchar, refCharacter, false);
	}
	
	EmptyOneShip(sti(refCharacter.ship.type));
	DeleteAttribute(refCharacter, "ship.cannons");
	
	if(refCharacter.id == pchar.id)
	{
		refCharacter.ship.type = GenerateShip(SHIP_WAR_TARTANE, 1);
		SetBaseShipData(refCharacter);

		FillCrewToShip(refCharacter);

		/*
		int cn = -1;
		int shipType = sti(refCharacter.ship.type);
		for(int m = 0; m < COMPANION_MAX; m++)
		{
			cn = GetCompanionIndex(pchar, m);
			if(cn == sti(ShipInfo[m].character))
			{
				characters[cn].ship.crew.BoardingCrew = ShipInfo[m].crew.BoardingCrew;
				if(sti(RealShips[shipType].BoardingCrew) < sti(characters[cn].ship.crew.BoardingCrew))
				{
					characters[cn].ship.crew.BoardingCrew = RealShips[shipType].BoardingCrew;

					ShipInfo[m].crew.BoardingCrew = sti(ShipInfo[m].crew.BoardingCrew) - sti(characters[cn].ship.crew.BoardingCrew);
				}

				characters[cn].ship.crew.SailorCrew = ShipInfo[m].crew.SailorCrew;
				if(sti(RealShips[shipType].SailorCrew) < sti(characters[cn].ship.crew.SailorCrew))
				{
					characters[cn].ship.crew.SailorCrew = RealShips[shipType].SailorCrew;
					ShipInfo[m].crew.SailorCrew = sti(ShipInfo[m].crew.SailorCrew) - sti(characters[cn].ship.crew.SailorCrew);
				}

				characters[cn].ship.crew.GunnerCrew = ShipInfo[m].crew.GunnerCrew;
				if(sti(RealShips[shipType].GunnerCrew) < sti(characters[cn].ship.crew.GunnerCrew))
				{
					characters[cn].ship.crew.GunnerCrew = RealShips[shipType].GunnerCrew;
					ShipInfo[m].crew.GunnerCrew = sti(ShipInfo[m].crew.GunnerCrew) - sti(characters[cn].ship.crew.GunnerCrew);
				}

				characters[cn].ship.crew.CannonerCrew = ShipInfo[m].crew.CannonerCrew;
				if(sti(RealShips[shipType].CannonerCrew) < sti(characters[cn].ship.crew.CannonerCrew))
				{
					characters[cn].ship.crew.CannonerCrew = RealShips[shipType].CannonerCrew;
					ShipInfo[m].crew.GunnerCrew = sti(ShipInfo[m].crew.CannonerCrew) - sti(characters[cn].ship.crew.CannonerCrew);
				}
				
				characters[cn].ship.crew.quantity = sti(characters[cn].ship.crew.BoardingCrew) + sti(characters[cn].ship.crew.SailorCrew) + sti(characters[cn].ship.crew.GunnerCrew) + sti(characters[cn].ship.crew.CannonerCrew);

				
			}
		}
		*/
	}
	else
	{
		refCharacter.ship.type = SHIP_NOTUSED;
	}
	
	//money
	AddMoneyToCharacter(pchar, sellPrice);

	UpdateShipScroll();
	UpdateCharacterInfo();


	//if (bDebugMode) trace("Shipyard: DoSellShip: = " + its(sq)+ "/"+ its(GetRealShipsCount())+ ", "+ its(FindFirstEmptyShip()));
}
//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
string GetShipStoreName(int i)
{
	return XI_ConvertString(ShipsTypes[i].name);	
}
//-------------------------------------------------------------------------------------
string GetShipStoreOriginalName(int i)
{
	return ShipsTypes[i].name;	
}
//-------------------------------------------------------------------------------------
int GetShipStorePrice(int i)
{
	aref curref = GetAttributeN(arShipList,i);
	int iPrice = GetBuyPrice(sti(GetAttributeValue(curref)));
	return iPrice;
	//return GetShipPriceByType(sti(GetAttributeValue(curref)));
}
//-------------------------------------------------------------------------------------
int GetShipPriceByType(int shipType)
{
	if(shipType == SHIP_NOTUSED) return 0;

	ref shref = GetRealShip(shipType);
	return sti(shref.Price);
}
//-------------------------------------------------------------------------------------
//     ...repair....
//-------------------------------------------------------------------------------------
void UpdateRepairWindow()
{

	int cn = GetCharacterIndex(refCharacter.id);
	int st = GetCharacterShipType(GetCharacter(cn));
	int hp = MakeInt(GetHullPercentWithModifier(GetCharacter(cn), newRepairHullValue));
	int sp = MakeInt(GetSailPercent(GetCharacter(cn)) + newRepairSailValuePercent);
	int cd = (GetIntactCannonQuantity(refCharacter) + newRepairCannonValue) * 100 / sti(Realships[sti(refCharacter.ship.type)].cannonsquantity);

	if(hp > 100) hp = 100;
	if(sp > 100) sp = 100;
	if(cd > 100) cd = 100;

	string sText;

	if(sti(refCharacter.ship.hp) > sti(RealShips[sti(refCharacter.ship.type)].HP))
	{
		refCharacter.ship.hp = RealShips[sti(refCharacter.ship.type)].HP;
	}

	sText = XI_ConvertString("Hull") + ": " + (sti(refCharacter.ship.hp) + makeint(newRepairHullValue)) + " / " + sti(RealShips[sti(refCharacter.ship.type)].HP);
	SetFormatedText("REPAIR_WINDOW_HULL_HP", sText);

	sText = hp + "%";
	SetFormatedText("REPAIR_WINDOW_HULL_HP_PERCENT", sText);	

	sText = XI_ConvertString("SAILS") + ": " + (sti(refCharacter.ship.sp) + makeint(newRepairSailValue)) + " / " + sti(RealShips[sti(refCharacter.ship.type)].SP);
	SetFormatedText("REPAIR_WINDOW_SAILS_HP", sText);	

	sText = sp + "%";
	SetFormatedText("REPAIR_WINDOW_SAILS_HP_PERCENT", sText);	

	sText = XI_ConvertString("Cannons") + ": " + (GetIntactCannonQuantity(refCharacter) + newRepairCannonValue) + " / " + sti(Realships[sti(refCharacter.ship.type)].cannonsquantity);
	SetFormatedText("REPAIR_WINDOW_CANNONS", sText);	

	sText = cd + "%";
	SetFormatedText("REPAIR_WINDOW_CANNONS_PERCENT", sText);	

	sText = XI_ConvertString("RepairCost") + ": " + FindRussianMoneyString(iFullPrice) + ".";
	SetFormatedText("REPAIR_WINDOW_TEXT4", sText);	
}


//-------------------------------------------------------------------------------------
//     ...utils....
//-------------------------------------------------------------------------------------
int GetCharacterShipBaseType(int iCharacterID)
{
	int iShipType = sti(characters[iCharacterID].ship.type);
	if(iShipType != SHIP_NOTUSED)
	{
		iShipType = sti(RealShips[iShipType].basetype);
	}

	return iShipType;
}
//-------------------------------------------------------------------------------------
int GetScrollShipType(int scrollIdx)
{
	if(scrollIdx<0 || scrollIdx>=GetAttributesNum(arShipList)) return SHIP_NOTUSED;
	return sti(GetAttributeValue(GetAttributeN(arShipList,scrollIdx)));
}


//-------------------------------------------------------------------------------------
int GetBuyPrice(int scrollIdx)
{
	int iResult = GetShipPriceByType(iShipStoreListIndex);
	float fCommerce = GetSummonSkillFromName(pchar, SKILL_COMMERCE);
	fCommerce = fCommerce * 0.01;
	iResult = iResult - (iResult*fCommerce);
	iResult = makefloat(iResult) * fColony;
	iResult = iResult - iResult * (0.1 * makefloat(iGameArcade)));

	return iResult;
}

int GetFakeBuyPrice(int iShip)
{
	int iResult = GetShipPriceByType(iShip);
	float fCommerce = GetSummonSkillFromName(pchar, SKILL_COMMERCE);
	fCommerce = fCommerce * 0.01;
	iResult = iResult - (iResult*fCommerce);
	iResult = makefloat(iResult) * fColony;
	iResult = iResult - iResult * (0.1 * makefloat(iGameArcade)));

	return iResult;
}
//-------------------------------------------------------------------------------------
int GetSellPrice()
{
	int st = refCharacter.ship.type;	
	int price = sti(RealShips[st].price);

	price = price - GetFullRepairCost(st);
	
	price = price / 5;

	price = price + GetCannonsDiffPrice(refCharacter);

	if(sti(RealShips[st].basetype) == SHIP_WAR_TARTANE)
	{
		price = 0;
	}

	return price;
}


//-------------------------------------------------------------------------------------
int GetFullRepairCost(int shipType)
{
	int SailDamage = GetSailDamagePercent();	
	int HullDamage = GetHullDamagePercent();

	int iCannDamage = sti(Realships[shipType].cannonsquantity) - GetIntactCannonQuantity(refCharacter);

	int iCost = GetSailRepairCost(shipType,SailDamage);
	iCost = iCost + GetHullRepairCost(shipType,HullDamage));
	iCost = iCost + GetCannonsRepairCost(iCannDamage);

	return iCost;
}
//-------------------------------------------------------------------------------------
int GetSailDamagePercent()
{
	return 100 - MakeInt(GetSailPercent(refCharacter));
}
//-------------------------------------------------------------------------------------
int GetHullDamagePercent()
{
	return 100 - MakeInt(GetHullPercent(refCharacter));
}
//-------------------------------------------------------------------------------------
int GetHullDamagePercentWithModif()
{
	return 100 - MakeInt(GetHullPercentWithModifier(refCharacter, newRepairHullValue));
}
//-------------------------------------------------------------------------------------
int GetSailRepairCost(int shipType,int repairPercent)
{
	float shipPrice = 20;
	int iShipClass = 7 - sti(RealShips[shipType].Class);

	float fCommerce = GetSummonSkillFromName(pchar, SKILL_COMMERCE);
	fCommerce = 0.01 * fCommerce;

	shipPrice = shipPrice * (sti(refCharacter.ship.upgrades.sails));

	shipPrice = shipPrice - shipPrice * fCommerce;
	shipPrice = shipPrice - (shipPrice * (0.1 * makefloat(iGamearcade)));

	shipPrice = shipPrice * repairPercent;

	return makeint(shipPrice);
}
//-------------------------------------------------------------------------------------
int GetHullRepairCost(int shipType,int repairPercent)
{
	int shipPrice = GetShipPriceByType(shipType);

	if(shipPrice <= 0) 
	{
		return 0;
	}
	
	float fCommerce = GetSummonSkillFromName(pchar, SKILL_COMMERCE);
	fCommerce = 0.01 * fCommerce;

	shipPrice = shipPrice * (sti(refCharacter.ship.upgrades.hull));

	shipPrice = shipPrice - shipPrice * fCommerce;
	//shipPrice = shipPrice - (shipPrice * (0.1 * makefloat(iGamearcade)));

	shipPrice = repairPercent * shipPrice / (400 * iGamearcade);

	return shipPrice;
}

int GetCannonsRepairCost(int iCannonsRepair)
{
	int iCannon = sti(refCharacter.ship.cannons.type);

	int iCost = sti(cannon[iCannon].cost) * iCannonsRepair;

	iCost = iCost * (sti(refCharacter.ship.upgrades.cannons));

	float fCommerce = GetSummonSkillFromName(pchar, SKILL_COMMERCE);
	fCommerce = 0.01 * fCommerce;

	iCost = iCost - iCost * fCommerce;

	iCost = iCost -  (iCost * (0.1 * makefloat(iGameArcade)));

	return iCost;
}

//-------------------------------------------------------------------------------------
int GetMyMoney()
{
	ref mychref = pchar;
	return sti(mychref.Money);
}
//-------------------------------------------------------------------------------------
bool IsEnableBuyShipForCharacter()
{
	int iPcharShip = sti(pchar.ship.type);
	int iOurTactic = GetSummonSkillFromName(pchar, SKILL_TACTIC);
	int iMaxSquadronSize = GetCompanionQuantity(pchar);
	if(iPcharShip != SHIP_NOTUSED)
	{
		iPcharShip = sti(RealShips[iPcharShip].basetype);
		if(ShipsTypes[iPcharShip].name == "WarTartane" && refPassenger.id == pchar.id)
		{
			iMaxSquadronSize = iMaxSquadronSize - 1;
		}
	}
	if(iOurTactic / 2 <= iMaxSquadronSize)
	{
		return false;
	}
	return true;
}

bool IsEnableBuyShip()
{

	int myMoney = GetMyMoney();
	int price = GetBuyPrice(iShipStoreListIndex + 1);
	int iship = sti(refCharacter.ship.type);

	if (price > myMoney)
	{
		return false;
	}

	if(sti(refCharacter.index) == nMainCharacterIndex && sti(RealShips[iship].basetype) == SHIP_WAR_TARTANE)
	{
		return true;
	}

	if(GetFreePassengersQuantity(pchar) < 1)
	{
		return false;
	}
	
	int iOurTactic = GetSummonSkillFromName(pchar, SKILL_TACTIC);
	int iMaxSquadronSize = GetCompanionQuantity(pchar);

	if(iship != SHIP_NOTUSED)
	{
		if(sti(RealShips[iship].basetype) != SHIP_WAR_TARTANE)
		{
			if(iOurTactic / 2 <= iMaxSquadronSize)
			{
				return false;
			}
		}
	}

	if(!CheckAttribute(refCharacter, "quest.officerprice") && refCharacter.id != pchar.id)
	{
		return false;
	}
	string sPos = FindPosForShip(iShipStoreListIndex);
	if(CheckAttribute(arShipList, sPos + ".buyed"))
	{
		if(sti(arShipList.(sPos).buyed) == 1)
		{
			return false;
		}
	}

	if(CheckAttribute(arShipList, sPos + ".notforsale"))
	{
		if(sti(arShipList.(sPos).notforsale) == 1)
		{
			return false;
		}
	}

	/*if (price <= myMoney)
	{
		if(iship == SHIP_NOTUSED)
		{
			return true;
		}
		if(CheckAttribute(RealShips[iship], "basetype"))
		{
			if(sti(RealShips[iship].basetype) == SHIP_WAR_TARTANE)
			{
				return true;
			}
		}
	}*/


	return true;
}
//-------------------------------------------------------------------------------------
bool IsEnableSellShip()
{
	if(sti(refCharacter.ship.type) != SHIP_NOTUSED)
	{
		int type = sti(RealShips[sti(refCharacter.ship.type)].basetype);
		if(type == SHIP_WAR_TARTANE || type == SHIP_NOTUSED) 
		{
			return false;
		}

		if(!CheckAttribute(refCharacter, "quest.officerprice") && refCharacter != pchar.id)
		{
			return false;
		}

		return GetShipRemovableEx(refCharacter);
	}
	return false;
}
//-------------------------------------------------------------------------------------
bool IsEnableRepairShip()
{
	
	if(GetShipBaseTypeFromScroll()== SHIP_NOTUSED) 
	{
		return false;
	}
	int iShip = (refCharacter.ship.type);
	if(iShip == SHIP_NOTUSED)
	{
		return false;
	}
	int iCannonsQ = sti(RealShips[iShip].cannonsquantity);
	int iRealCannonsQ = GetIntactCannonQuantity(refCharacter);
	if(GetSailPercent(refCharacter)>= 100.0 && GetHullPercent(refCharacter)>= 100.0 && iCannonsQ == iRealCannonsQ) 
	{
		return false;
	}
	
	return true;
}

bool IsEnableUpgradeShip()
{
	if(GetShipBaseTypeFromScroll()== SHIP_NOTUSED) 
	{
		return false;
	}

	return true;
}
//-------------------------------------------------------------------------------------
bool IsEnableChangeCaptain()
{
	if(nCurSScrollNum < 0) 
	{
		return false;
	}

	/*int iOurTactic = GetSummonSkillFromName(pchar, SKILL_TACTIC);
	int iMaxSquadronSize = GetCompanionQuantity(pchar);

	if(refCharacter.id != pchar.id)
	{
		if(iOurTactic < iMaxSquadronSize * 2)
		{
			return false;
		}
	}*/

	//int iOurTactic = GetSummonSkillFromName(pchar, SKILL_TACTIC);
	int iMaxSquadronSize = GetCompanionQuantity(pchar);

	if(iMaxSquadronSize == 1)
	{
		return false;
	}
	/*if(iship != SHIP_NOTUSED)
	{
		if(sti(RealShips[iship].basetype) != SHIP_WAR_TARTANE)
		{
			if(iOurTactic / 2 <= iMaxSquadronSize)
			{
				return false;
			}
		}
	}*/

	int cn = GetCharacterIDFromScroll();

	if(cn>=0)
	{
		ref chref = GetCharacter(cn);
		int iShip = sti(chref.ship.type);
		if(iShip == SHIP_NOTUSED)
		{
			return false;
		}
		if(sti(RealShips[iship].basetype) == SHIP_WAR_TARTANE)
		{
			return false;
		}
		if(!GetRemovable(chref)) 
		{
			return false;
		}
		if(GetCompanionQuantity(pchar) <= 1 && GetNotQuestFreePassengersQuantity(pchar) < 1 && sti(pchar.ship.type) != SHIP_NOTUSED)
		{
			return false;
		}
		if(CheckAttribute(chref, "prisoned"))
		{
			if(sti(chref.prisoned) == 1)
			{
				return false;
			}
		}

		return true;
	}
	return false;
}
//-------------------------------------------------------------------------------------
int GetCannonsDiffPrice(ref chref)
{
	int cannonsQ = GetCannonQuantity(chref);
	if(cannonsQ<=0) return 0;
	int st = GetCharacterShipType(chref);
	if(st==SHIP_NOTUSED) return 0;
	int ct = GetCaracterShipCannonsType(chref);
	int ctbase = RealShips[st].Cannon;
	if(ct==ctbase) return 0;
	return cannonsQ*(GetCannonPrice(ct)-GetCannonPrice(ctbase));
}

//-------------------------------------------------------------------------------------
int GetCannonPrice(int nCannonType)
{
	if(nCannonType==CANNON_TYPE_NONECANNON) return 0;
	ref rCannon = GetCannonByType(nCannonType);
	return sti(rCannon.Cost);
}


void ChangeCaptain()
{
	iConfirmMode = MODE_EXCHANGE;
	ShowOfficerWindow();
}

void acceptofficer()
{
	if(XI_IsWindowEnable("OFFICER_WINDOW") == true)
	{
		DoExchangeCapitan(nCurOScrollNum);
		HideInfoWindow();
	}
}

//-------------------------------------------------------------------------------------
void DoExchangeCapitan(int iOfficerIndex)
{
	string attributeName = "pic" + (iOfficerIndex + 1);
	int iCompanionIndex = sti(GameInterface.OFFICERS_SCROLL.(attributeName).index);

	ref refCompanion = GetCharacter(iCompanionIndex);

	SeaAI_SwapShipsAttributes(refCharacter, refCompanion);

	if(IsCompanion(refCompanion) != 1 || IsCompanion(refCharacter) != 1)
	{
		if(refCharacter.id != pchar.id)
		{
			RemoveCharacterCompanion(pchar, refCharacter);
			RemovePassenger(pchar, refCompanion);
			SetCompanionIndex(pchar,-1, iCompanionIndex);
			AddPassenger(pchar, refCharacter, false);
		}
		else
		{
			RemovePassenger(pchar, refCompanion);
			SetCompanionIndex(pchar, -1, iCompanionIndex);
		}
	}

	UpdateShipScroll();
	ProcessFrame();
	//refCharacter = CharacterFromID(refCompanion.id);
	//UpdateCharacterInfo();
}

void ShowUpgradeWindow()
{
	iFullPrice = 0;
	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("STORE_WINDOW", true);
	XI_WindowShow("UPGRADE_WINDOW", true);
	XI_WindowDisable("UPGRADE_WINDOW", false);
}

void HideUpgradeWindow()
{
	XI_WindowShow("UPGRADE_WINDOW", false);
	XI_WindowDisable("UPGRADE_WINDOW", true);
	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("STORE_WINDOW", false);

	SetCurrentNode("SHIPS_SCROLL");
}

void CancelUpgradeShip()
{
	HideUpgradeWindow();
}

void ConfirmUpgradeShip()
{
	//HideUpgradeWindow();	
	
	SetSelectable("UPGRADE_WINDOW_OK_BUTTON", false);
	int iUpgradeStep = sti(GameInterface.UPGRADE_SCROLL.current) + 1;

	//string smode;
	switch(iUpgradeMode)
	{
		case HULL:
			refcharacter.ship.upgrades.hull = iUpgradeStep;
			DeleteAttribute(refCharacter, "ship.flow");
			//smode = "hull";
		break;

		case SAILS:
			refcharacter.ship.upgrades.sails = iUpgradeStep;
			refcharacter.ship.sp = RealShips[sti(refcharacter.ship.type)].sp;
			//smode = "sails";
		break;

		case CANNONS:
			refcharacter.ship.upgrades.cannons = iCannonMaterial;

			string attributeName = "pic" + iUpgradeStep;
			string sCannonType = GameInterface.UPGRADE_SCROLL.(attributeName).text;
			trace("sCannonType = " + sCannonType);
			int iPrevCannonType = sti(refCharacter.ship.cannons.type);
			int iCannonType = FindCannonByText(sCannonType);
			refcharacter.ship.cannons.type = iCannonType;
			
			aref arDamages;
			string sBort;
			for (int i =0; i<4; i++)
			{
				switch (i)
				{
					case 0: sBort = "cannonf"; break;
					case 1: sBort = "cannonb"; break;
					case 2: sBort = "cannonl"; break;
					case 3: sBort = "cannonr"; break;
				}
				makearef(arDamages, refCharacter.Ship.Cannons.Borts.(sBort).damages);

				int iNumRealCannons = GetAttributesNum(arDamages);
			
				int iNumIntactCannons = 0;
				string attr;
				for (int k=0; k<iNumRealCannons; k++)
				{
					attr = "c"+k;
					if(arDamages.(attr) > 0.0)
					{
						arDamages.(attr) = 0.0;
					}
				}
			}
		break;
	}

	//FillUpgradeInfo(smode);

	AddMoneyToCharacter(pchar, -iCost);
	
	ShipCheckUpgrade(refCharacter);
	UpdateCharacterInfo();
	UpdateShipUpgrades();

	//ClickRepairOkButton();
}

void PrepareUpgrade()
{
	ShowUpgradeWindow();

	string sText = XI_ConvertString("UpgradeShip");
	SetFormatedText("UPGRADE_WINDOW_CAPTION" , sText);

	int iShip = sti(refCharacter.ship.type);
	int iBaseType = sti(RealShips[iShip].basetype);
	string sShipName = ShipsTypes[iBaseType].name;
	SetNewPicture("INFO_WINDOW_PICTURE", "interfaces\ships\" + sShipName + ".tga");

	UpdateShipUpgrades();
	
	ClickHullUpgrade();
}

void UpdateShipUpgrades()
{
	int iShip = sti(refCharacter.ship.type);
	int iBaseType = sti(RealShips[iShip].basetype);
	int iUpgrade;
	string sText;

	SetFormatedText("UPGRADE_WINDOW_HULL_VALUE", "");
	SetFormatedText("UPGRADE_WINDOW_SAILS_VALUE", "");
	SetFormatedText("UPGRADE_WINDOW_CANNONS_VALUE", "");

	sText = makeint(refCharacter.ship.hp) + "/" + makeint(RealShips[iShip].hp) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_HULL_VALUE", 0,	&sText);
	iUpgrade = sti(refCharacter.ship.upgrades.hull);
	sText = XI_ConvertString("hull" + iUpgrade) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_HULL_VALUE", 0,	&sText);

	sText = makeint(refCharacter.ship.sp) + " " + makeint(RealShips[iShip].sp) + " ";;
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_SAILS_VALUE", 0,	&sText);
	iUpgrade = sti(refCharacter.ship.upgrades.sails);
	sText = XI_ConvertString("sails" + iUpgrade) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_SAILS_VALUE", 0,	&sText);

	int iCannonType = sti(refCharacter.ship.cannons.type);
	string sCannonName = XI_ConvertString(Cannon[iCannonType].name);
	string sCannonType;
	iCannonType = Cannon[iCannonType].type;
	if(iCannonType == CANNON_NAME_CULVERINE)
	{
		sCannonType = XI_ConvertString("CulverineShort");
	}
	else
	{
		sCannonType = XI_ConvertString("Cannon");
	}
	sText = " " + Realships[iShip].CannonsQuantity + " (" + sCannonType + " " + sCannonName + ")";

	//sText = Realships[iShip].CannonsQuantity + " (" + XI_ConvertString(Cannon[sti(refCharacter.ship.cannons.type)].name) + ")  ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_CANNONS_VALUE", 0,	&sText);
	iUpgrade = sti(refCharacter.ship.upgrades.cannons);
	sText = XI_ConvertString("cannons" + iUpgrade) + " ";
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_CANNONS_VALUE", 0,	&sText);
}

void FillUpgradeInfo(string sMode)
{
	int iUpgrade;
	if(smode == "cannons")
	{
		iUpgrade = iCannonMaterial;
	}
	else
	{
		iUpgrade = sti(GameInterface.UPGRADE_SCROLL.(attributeName).current) + 1;
	}

	string sText = "UpgradeShipInfo" + sMode + iUpgrade;
	sText = XI_ConvertString(sText);

	string sUpgrade = sMode + iUpgrade;
	
	SetFormatedText("UPGRADE_WINDOW_TEXT", "");
	SetFormatedText("UPGRADE_WINDOW_GOLD_TEXT", "");
	
	int iShip = sti(refCharacter.ship.type);
	if(iShip < SHIP_NOTUSED)
	{
		if(sMode == "cannons")
		{
			string attributeName = "pic" + (sti(GameInterface.UPGRADE_SCROLL.(attributeName).current) + 1);
			string sCannonType = GameInterface.UPGRADE_SCROLL.(attributeName).text;
			trace("sCannonType = " + sCannonType);
			int iPrevCannonType = sti(refCharacter.ship.cannons.type);
			int iCannonType = FindCannonByText(sCannonType);
			sText = sText + " " + XI_ConvertString(GetCannonType(iCannonType)) + " " + XI_ConvertString(Cannon[iCannonType].name) + ".";
			sText = sText + " " + XI_ConvertString("Fire range") + " " + fts(stf(Cannon[iCannonType].FireRange), 4) + " " + XI_ConvertString("Reload time") + " " + Cannon[iCannonType].ReloadTime + " " + XI_ConvertString("sec.");
			iCost = (sti(ShipUpgrades[FindShipUpgrade(sUpgrade)].cost) * sti(RealShips[iShip].CannonsQuantity));
			iCost = iCost + (sti(Cannon[iCannonType].cost) * sti(RealShips[iShip].CannonsQuantity));
			
			int iRealCannons = sti(Realships[iShip].cannonsquantity);
			int iCurrentCannons = GetIntactCannonQuantity(refCharacter);

			iCost = iCost - (sti(Cannon[iPrevCannonType].cost) * sti(iCurrentCannons))/2;

			newRepairCannonValue = iRealCannons - iCurrentCannons;

			iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);
			iCost = iCost + iCannonsRepairCost;
			iCannonsRepairCost = 0;
		}
		SetFormatedText("UPGRADE_WINDOW_TEXT", sText);
		if(sMode == "hull")
		{
			int iRealHullHP = sti(Realships[iShip].hp);
			int iCurrentHullHP = sti(refCharacter.ship.hp);

			int iCheckValue = newRepairHullValue  + iCurrentHullHP;
			
			newRepairHullValue = iRealHullHP - iCurrentHullHP;
			newRepairHullValuePercent = makefloat(iRealHullHP - iCurrentHullHP) * 100.0 / makefloat(iRealHullHP);

			iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));

			iCost =  sti(ShipUpgrades[FindShipUpgrade(sUpgrade)].cost) * sti(RealShips[iShip].HP) / 2;
			iCost = iCost + iHullRepairCost;
			iHullRepairCost = 0;
		}
		if(sMode == "Sails")
		{
			int iRealHullSP = sti(RealShips[iShip].sp);
			int iCurrentHullSP = sti(refCharacter.ship.sp);
			iCost =  sti(ShipUpgrades[FindShipUpgrade(sUpgrade)].cost) * (7 - sti(RealShips[iShip].Class)) * iRealHullSP;
			newRepairSailValue = iRealHullSP - iCurrentHullSP;
			newRepairSailValuePercent = makefloat(iRealHullSP - iCurrentHullSP) * 100.0 / makefloat(iRealHullSP);

			iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));
			iCost = iCost + iSailsRepairCost;
			iSailsRepairCost = 0;
		}
		sText = XI_ConvertString("UpgradeCost") + FindRussianMoneyString(iCost);
		SetFormatedText("UPGRADE_WINDOW_GOLD_TEXT", sText);
	}
}

void ClickHullUpgrade()
{
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_HULL", "TABS", "TabSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_SAILS", "TABS", "TabDeSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_CANNONS", "TABS", "TabDeSelected");
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_HULL_CAPTION", 8,0,argb(255,255,255,255));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_SAILS_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_CANNONS_CAPTION", 8,0,argb(255,196,196,196));
	FillUpgradeScroll("Hull");
	FillUpgradeInfo("Hull");
	iUpgradeMode = HULL;
	SetNodeUsing("CANNONS_CALIBER", false);
	SetCurrentNode("UPGRADE_SCROLL");
}

void ClickSailsUpgrade()
{
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_HULL", "TABS", "TabDeSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_SAILS", "TABS", "TabSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_CANNONS", "TABS", "TabDeSelected");
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_HULL_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_SAILS_CAPTION", 8,0,argb(255,255,255,255));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_CANNONS_CAPTION", 8,0,argb(255,196,196,196));
	FillUpgradeScroll("Sails");
	FillUpgradeInfo("Sails");
	iUpgradeMode = SAILS;
	SetNodeUsing("CANNONS_CALIBER", false);
	SetCurrentNode("UPGRADE_SCROLL");
}

void ClickCannonsUpgrade()
{
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_HULL", "TABS", "TabDeSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_SAILS", "TABS", "TabDeSelected");
	SetNewGroupPicture("UPGRADE_WINDOW_TAB_CANNONS", "TABS", "TabSelected");
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_HULL_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_SAILS_CAPTION", 8,0,argb(255,196,196,196));
	SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"UPGRADE_WINDOW_CANNONS_CAPTION", 8,0,argb(255,255,255,255));
	FillUpgradeScroll("Cannons");
	FillUpgradeInfo("Cannons");
	iUpgradeMode = CANNONS;
	SetNodeUsing("CANNONS_CALIBER", true);
	SetCurrentNode("UPGRADE_SCROLL");
}

void FillUpgradeScroll(string smode)
{
	
	string faceName;
	string attributeName;
	
 	DeleteAttribute(&GameInterface, "UPGRADE_SCROLL");
	
	nCurScrollNum = -1;

	GameInterface.UPGRADE_SCROLL.current = 0;

	
	int nOffSize = 3;
		
	GameInterface.UPGRADE_SCROLL.NotUsed = 1;
	
	GameInterface.UPGRADE_SCROLL.ImagesGroup.t0 = "EMPTYFACE";
	
	FillUpgradesList("UPGRADE_SCROLL.ImagesGroup", smode, iCannonMaterial);
	
	GameInterface.UPGRADE_SCROLL.BadTex1 = 0;
	GameInterface.UPGRADE_SCROLL.BadPic1 = "emptyface";

	
	int m = 0;
	int iCannonsTypeQuantity = 0;
	int iCannonsStep = 0;

	int iMax;
	if(smode == "cannons")
	{
		iMax = CANNON_TYPES_QUANTITY + 1;
		SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"CANNONS_CALIBER", 2, iCannonMaterial, 1);
	}
	else
	{
		iMax = 4;
	}
	
	int k;
	for(int i = 1; i < iMax; i++)
	{
		if(smode == "cannons")
		{
			k = i - 1;
			if(sti(Cannon[k].caliber) > sti(RealShips[sti(refCharacter.ship.type)].MaxCaliber))
			{
				continue;
			}
			if(k == sti(refCharacter.ship.cannons.type))
			{
				iCannonsStep = iCannonsTypeQuantity;
			}
			iCannonsTypeQuantity = iCannonsTypeQuantity + 1;
		}
		attributeName = "pic" + (m + 1);
		GameInterface.UPGRADE_SCROLL.(attributeName).text = smode + i;
		if(smode == "cannons")
		{
			GameInterface.UPGRADE_SCROLL.(attributeName).img1 = smode + i;
			GameInterface.UPGRADE_SCROLL.(attributeName).tex1 = FindFaceGroupNum("UPGRADE_SCROLL.ImagesGroup",smode + "_UPGRADE_"+iCannonMaterial);
		}
		else
		{
			GameInterface.UPGRADE_SCROLL.(attributeName).img1 = smode;
			GameInterface.UPGRADE_SCROLL.(attributeName).tex1 = FindFaceGroupNum("UPGRADE_SCROLL.ImagesGroup",smode + "_UPGRADE_"+i);
		}
		
		m++;
	}

	switch(smode)
	{
		case "hull":
			GameInterface.UPGRADE_SCROLL.current = sti(refCharacter.ship.upgrades.hull)-1;
		break;
		case "sails":
			GameInterface.UPGRADE_SCROLL.current = sti(refCharacter.ship.upgrades.sails)-1;
		break;
		case "cannons":
			GameInterface.UPGRADE_SCROLL.current = iCannonsStep;
		break;
	}
	
	GameInterface.UPGRADE_SCROLL.ListSize = m;

	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"UPGRADE_SCROLL",-1);
	
}

bool CheckForUpgrade()
{
	string smode;
	switch(iUpgradeMode)
	{
		case HULL:
			smode = "hull";
		break;
		case SAILS:
			smode = "sails";
		break;
		case CANNONS:
			smode = "cannons";
		break;
	}

	int iCurrUpgradeStep;
	string sCharCannons, sScrollCannons;

	if(smode == "cannons")
	{
		iCurrUpgradeStep = sti(refCharacter.ship.cannons.type);
		sCharCannons = cannon[iCurrUpgradeStep].picture;
		string attributeName = "pic" + (nCurScrollNum + 1);
		sScrollCannons = GameInterface.UPGRADE_SCROLL.(attributeName).img1;
	}
	else
	{
		iCurrUpgradeStep = sti(refCharacter.ship.upgrades.(smode)) - 1;
		if(iCurrUpgradeStep == nCurScrollNum)
		{
			return false;
		}
	}
	if(smode == "cannons" && iCannonMaterial == sti(refCharacter.ship.upgrades.cannons) && sCharCannons == sScrollCannons)
	{
		return false;
	}
	if(iCost > sti(pchar.money) && iCost > 0)
	{
		return false;
	}
	return true;
}

void CannonMaterialChange()
{
	string sNode = GetEventData();
	int iButtonNumber = GetEventData();
	int iCondition = GetEventData();
	
	iCannonMaterial = iButtonNumber;

	FillUpgradeScroll("Cannons");
	FillUpgradeInfo("Cannons");
}

void ClickRepairWindow()
{
	ShowRepairWindow();
	iFullPrice = 0;

	int iShip = sti(refCharacter.ship.type);
	
	/////////////////////////////////////////////////////
	/// HULL
	/////////////////////////////////////////////////////
	int iRealHullHP = sti(Realships[iShip].hp);
	int iCurrentHullHP = sti(refCharacter.ship.hp);
	
	int iDifferenceHP = iRealHullHP - iCurrentHullHP;
	int iPrice = (20 - GetSummonSkillFromName(pchar, SKILL_COMMERCE)) * iDifferenceHP;

	while(iPrice > sti(pchar.money))
	{
		iDifferenceHP = iDifferenceHP - 10;
		iPrice = (20 - GetSummonSkillFromName(pchar, SKILL_COMMERCE)) * iDifferenceHP;
	}
	
	/////////////////////////////////////////////////////
	/// SAILS
	/////////////////////////////////////////////////////
	int iRealSailsHP = 100;
	int iCurrentSailsHP = sti(refCharacter.ship.sp);
	
	int iDifferenceSP = iRealSailsHP - (100 - iCurrentSailsHP);
	
	iPrice = (20 - GetSummonSkillFromName(pchar, SKILL_COMMERCE)) * iDifferenceSP/5;

	while(iPrice > sti(pchar.money))
	{
		iDifferenceSP = iDifferenceSP - 1;
		iPrice = (20 - GetSummonSkillFromName(pchar, SKILL_COMMERCE)) * iDifferenceSP/5;
	}
	
	/////////////////////////////////////////////////////
	/// CANNONS
	/////////////////////////////////////////////////////
	int iRealCannonsQ = sti(RealShips[iShip].CannonsQuantity);
	int iCurrentCannonsQ = GetIntactCannonQuantity(refCharacter);
	
	int iDifferenceCannons = iRealCannonsQ - iCurrentCannonsQ;
	
	int iCannonType = sti(refCharacter.ship.cannons.type);
	string sUpgrade = "cannons" + iCannonMaterial;
	iPrice = (sti(ShipUpgrades[FindShipUpgrade(sUpgrade)].cost) * iCurrentCannonsQ);
	iPrice = iCost + (sti(Cannon[iCannonType].cost) * iCurrentCannonsQ);

	while(iPrice > sti(pchar.money))
	{
		iDifferenceCannons = iDifferenceCannons - 1;
		iPrice = (sti(ShipUpgrades[FindShipUpgrade(sUpgrade)].cost) * iCurrentCannonsQ);
		iPrice = iCost + (sti(Cannon[iCannonType].cost) * iDifferenceCannons);
	}
	
	iDifferenceCannons = iRealCannonsQ - iDifferenceCannons;
	newRepairHullValuePercent = 0.0;
	newRepairSailValuePercent = 0.0;
}

//-------------------------------------------------------------------------------------
void ShowRepairWindow()
{
	XI_WindowDisable("MAIN_WINDOW", true);
	XI_WindowDisable("STORE_WINDOW", true);
	XI_WindowDisable("REPAIR_WINDOW", false);
	XI_WindowShow("REPAIR_WINDOW", true);
	
	string sText = XI_ConvertString("RepairShip");
	SetFormatedText("REPAIR_WINDOW_CAPTION" , sText);
	
	newRepairSailValue = 0;
	newRepairHullValue = 0;

	UpdateRepairWindow();

}

void HideRepairWindow()
{
	XI_WindowDisable("REPAIR_WINDOW", true);
	XI_WindowShow("REPAIR_WINDOW", false);
	XI_WindowDisable("MAIN_WINDOW", false);
	XI_WindowDisable("STORE_WINDOW", false);

	UpdateCharacterInfo();

	iHullRepairCost = 0;
	iSailsRepairCost = 0;
	iCannonsRepairCost = 0;
	iFullPrice = 0;
	newRepairHullValuePercent = 0;
	newRepairSailValuePercent = 0;

	if(sti(refCharacter.ship.hp) == sti(realships[sti(refCharacter.ship.type)].hp))
	{
		DeleteAttribute(refCharacter,"ship.blots");
	}

	if(sti(refCharacter.ship.sp) == sti(realships[sti(refCharacter.ship.type)].sp))
	{
		if(CheckAttribute(refCharacter, "ship.sails.color"))
		{
			refCharacter.ship.oldsails.color = refCharacter.ship.sails.color;
		}
		if(CheckAttribute(refCharacter, "ship.sails.gerald_name"))
		{
			refCharacter.ship.oldsails.gerald_name = refCharacter.ship.sails.gerald_name;
		}
		DeleteAttribute(refCharacter,"ship.sails");
		DeleteAttribute(refCharacter,"ship.masts");
		if(CheckAttribute(refCharacter, "ship.oldsails.color"))
		{
			refCharacter.ship.sails.color = refCharacter.ship.oldsails.color;
		}
		if(CheckAttribute(refCharacter, "ship.oldsails.gerald_name"))
		{
			refCharacter.ship.sails.gerald_name = refCharacter.ship.oldsails.gerald_name;
		}
	}
}

void ClickRepairOkButton()
{
	refCharacter.ship.hp = sti(refCharacter.ship.hp) + newRepairHullValue;
	refCharacter.ship.sp = sti(refCharacter.ship.sp) + newRepairSailValue;

	aref arDamages;

	string sBort;

	for (int i =0; i<4; i++)
	{
		switch (i)
		{
			case 0: sBort = "cannonf"; break;
			case 1: sBort = "cannonb"; break;
			case 2: sBort = "cannonl"; break;
			case 3: sBort = "cannonr"; break;
		}
		makearef(arDamages, refCharacter.Ship.Cannons.Borts.(sBort).damages);

		int iNumRealCannons = GetAttributesNum(arDamages);
	
		int iNumIntactCannons = 0;
		string attr;
		for (int k=0; k<iNumRealCannons; k++)
		{
			attr = "c"+k;
			if(newRepairCannonValue != 0 && arDamages.(attr) == 1.0)
			{
				arDamages.(attr) = 0.0;
				newRepairCannonValue = newRepairCannonValue - 1;
			}
		}
	}

	AddMoneyToCharacter(pchar, -iFullPrice);

	newRepairSailValue = 0;
	newRepairHullValue = 0;
	newRepairCannonValue = 0;
	iRepairCost = 0;
	DeleteAttribute(refCharacter, "ship.flow");

	HideRepairWindow();
}

void ClickRepairCancelButton()
{
	HideRepairWindow();

	newRepairSailValue = 0;
	newRepairHullValue = 0;
	newRepairCannonValue = 0;
	iRepairCost = 0;

}

string FindPosForShip(int iShip)
{
	int iResult = iStoreLine + SHIP_LUGGER;
	string attributeName = "ship"+ iResult;
	return attributeName;
}

int FindStringPosForShip(int iShip)
{
	aref result;
	int iShipsQ = GetAttributesNum(arShipList);

	string sShip;

	for(int i = 0; i < iShipsQ; i++)
	{
		result = GetAttributeN(arShipList, i);
		sShip = GetAttributeName(result);
		if(sti(arShipList.(sShip)) == iShip)
		{
			return i;
		}
	}
	return -1;
}

void SetHullSlider()
{
	int iShip = sti(refCharacter.ship.type);
	int iRealHullHP = sti(Realships[iShip].hp);
	int iCurrentHullHP = sti(refCharacter.ship.hp);

	UpdateRepairWindow();
}

void SetSailsSlider()
{
	int iShip = sti(refCharacter.ship.type);
	int iRealHullSP = sti(Realships[iShip].sp);
	int iCurrentHullSP = sti(refCharacter.ship.sp);

	UpdateRepairWindow();
}

void SetCannonsSlider()
{
	int iShip = sti(refCharacter.ship.type);
	int iRealCannons = sti(Realships[iShip].cannonsquantity);
	int iCurrentCannons = GetIntactCannonQuantity(refCharacter);

	UpdateRepairWindow();
}

void AddHull()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MaxHull();
	}
	else
	{
		int iShip = sti(refCharacter.ship.type);

		int iRealHullHP = sti(Realships[iShip].hp);
		int iCurrentHullHP = sti(refCharacter.ship.hp);

		int iCheckValue = newRepairHullValue  + iCurrentHullHP;
		
		if(iCheckValue < iRealHullHP)
		{
			newRepairHullValuePercent = newRepairHullValuePercent + 1;
			newRepairHullValue = newRepairHullValue + makefloat(iRealHullHP)/100.0;
		}

		iCheckValue = newRepairHullValue  + iCurrentHullHP;

		while(iCheckValue > iRealHullHP)
		{
			newRepairHullValue = newRepairHullValue - 1.0;
			iCheckValue = newRepairHullValue  + iCurrentHullHP;
		}

		iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));

		iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

		if(iFullPrice > sti(pchar.money))
		{	
			newRepairHullValue = newRepairHullValue - makefloat(iRealHullHP)/100.0;
			newRepairHullValuePercent = newRepairHullValuePercent - 1;

			iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));

			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
		}

		UpdateRepairWindow();
	}
}

void MinHull()
{
	newRepairHullValue = 0;
	newRepairHullValuePercent = 0;

	int iShip = sti(refCharacter.ship.type);

	int iRealHullHP = sti(Realships[iShip].hp);
	int iCurrentHullHP = sti(refCharacter.ship.hp);

	iHullRepairCost = 0;

	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
	UpdateRepairWindow();
}

void MaxHull()
{
	int iShip = sti(refCharacter.ship.type);

	int iRealHullHP = sti(Realships[iShip].hp);
	int iCurrentHullHP = sti(refCharacter.ship.hp);

	newRepairHullValue = iRealHullHP - iCurrentHullHP;
	newRepairHullValuePercent = makefloat(iRealHullHP - iCurrentHullHP) * 100.0 / makefloat(iRealHullHP);
	newRepairHullValuePercent = newRepairHullValuePercent + 0.5;

	iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));

	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

	if(sti(pchar.money) < iFullPrice)
	{
		bool isBreak = true;
		while(isBreak)
		{
			newRepairHullValuePercent = newRepairHullValuePercent - 1;

			newRepairHullValue = newRepairHullValue - makefloat(iRealHullHP)/100.0;

			
			iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
			if(sti(pchar.money) >= iFullPrice || iHullRepairCost == 0)
			{
				isBreak = false;
			}
		}
	}
	UpdateRepairWindow();
}

void RemoveHull()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MinHull();
	}
	else
	{
		int iShip = sti(refCharacter.ship.type);
		int iRealHullHP = sti(Realships[iShip].hp);
		int iCurrentHullHP = sti(refCharacter.ship.hp);

		if(newRepairHullValue > 0)
		{
			newRepairHullValuePercent = newRepairHullValuePercent - 1;
			newRepairHullValue = newRepairHullValue - makefloat(iRealHullHP)/100.0;
			
			iHullRepairCost = GetHullRepairCost(iShip, makeint(newRepairHullValuePercent));
			
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

			UpdateRepairWindow();
		}
	}
}


void MaxSails()
{
	int iShip = sti(refCharacter.ship.type);

	int iRealHullSP = sti(Realships[iShip].sp);
	int iCurrentHullSP = sti(refCharacter.ship.sp);

	newRepairSailValue = iRealHullSP - iCurrentHullSP;
	newRepairSailValuePercent = makefloat(iRealHullSP - iCurrentHullSP) * 100.0 / makefloat(iRealHullSP);
	newRepairSailValuePercent = newRepairSailValuePercent + 0.5;

	iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));

	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

	if(sti(pchar.money) < iFullPrice)
	{
		bool isBreak = true;
		while(isBreak)
		{
			newRepairSailValuePercent = newRepairSailValuePercent - 1;

			newRepairSailValue = newRepairSailValue - makefloat(iRealHullSP)/100.0;
			
			iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
			if(sti(pchar.money) >= iFullPrice || iSailsRepairCost == 0)
			{
				isBreak = false;
			}
		}
	}
	UpdateRepairWindow();
}

void AddSails()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MaxSails();
	}
	else
	{
		int iShip = sti(refCharacter.ship.type);

		int iCurrentSailHP = sti(refCharacter.ship.sp);
		int iRealSailHP = sti(RealShips[iShip].sp);

		int iCheckValue = newRepairSailValue + iCurrentSailHP;

		if(iCheckValue < sti(Realships[iShip].sp))
		{
			newRepairSailValuePercent = newRepairSailValuePercent + 1;
			newRepairSailValue = newRepairSailValue + makefloat(iRealSailHP)/100.0;
		}

		iCheckValue = newRepairSailValue + iCurrentSailHP;

		while(iCheckValue > iRealSailHP)
		{
			newRepairSailValue = newRepairSailValue - 1.0;
			iCheckValue = newRepairSailValue + iCurrentSailHP;
		}
			
		iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));

		iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

		if(iFullPrice > sti(pchar.money))
		{
			newRepairSailValue = newRepairSailValue - makefloat(iRealSailHP)/100.0;
			newRepairSailValuePercent = newRepairSailValuePercent - 1;
			iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));

			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
		}
		UpdateRepairWindow();
	}
}

void RemoveSails()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MinSails();
	}
	int iShip = sti(refCharacter.ship.type);
	int iCurrentSailHP = sti(refCharacter.ship.sp);
	int iRealSailHP = sti(RealShips[iShip].sp);

	if(newRepairSailValue != 0)
	{
		newRepairSailValuePercent = newRepairSailValuePercent - 1;

		newRepairSailValue = newRepairSailValue - makefloat(iRealSailHP)/100.0;

			
		iSailsRepairCost = GetSailRepairCost(iShip, makeint(newRepairSailValuePercent));
		iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
		UpdateRepairWindow();
	}
}

void MinSails()
{
	newRepairSailValue = 0;
	newRepairSailValuePercent = 0;

	int iShip = sti(refCharacter.ship.type);

	iSailsRepairCost = 0;

	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
	UpdateRepairWindow();
}

void AddCannons()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MaxCannons();
	}
	else
	{
		int iShip = sti(refCharacter.ship.type);
		int iMaxCannons = GetIntactCannonQuantity(refCharacter);
		int iCheckValue = newRepairCannonValue + iMaxCannons;

		if(iCheckValue < sti(RealShips[iShip].cannonsquantity))
		{
			newRepairCannonValue = newRepairCannonValue + 1;

			iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);
			
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
			
			if(iFullPrice > sti(pchar.money))
			{
				newRepairCannonValue = newRepairCannonValue - 1;
				iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);
			
				iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

			}
		}
		UpdateRepairWindow();
	}
}

void MaxCannons()
{
	int iShip = sti(refCharacter.ship.type);

	int iRealCannons = sti(Realships[iShip].cannonsquantity);
	int iCurrentCannons = GetIntactCannonQuantity(refCharacter);

	newRepairCannonValue = iRealCannons - iCurrentCannons;

	iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);

	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

	if(sti(pchar.money) < iFullPrice)
	{
		bool isBreak = true;
		while(isBreak)
		{
			newRepairCannonValue = newRepairCannonValue - 1;

			iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;

			if(sti(pchar.money) >= iFullPrice || iCannonsRepairCost == 0)
			{
				isBreak = false;
			}
		}
	}
	UpdateRepairWindow();
}

void RemoveCannons()
{
	if(XI_IsKeyPressed("shift") == true) // key_name = {"shift","control","alt"}
	{
		MinCannons();
	}
	else
	{
		if(newRepairCannonValue != 0)
		{
			newRepairCannonValue = newRepairCannonValue - 1;
			iCannonsRepairCost = GetCannonsRepairCost(newRepairCannonValue);
			iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
			UpdateRepairWindow();
		}
	}
}

void MinCannons()
{
	newRepairCannonValue = 0;
	iCannonsRepairCost = 0;
	iFullPrice = iHullRepairCost + iSailsRepairCost + iCannonsRepairCost;
	UpdateRepairWindow();
}


void ClickBuyTab()
{
	XI_WindowShow("STORE_WINDOW", true);
	XI_WindowDisable("STORE_WINDOW", false);

	XI_WindowShow("UPGRADE_WINDOW", false);
	XI_WindowDisable("UPGRADE_WINDOW", true);

	XI_WindowShow("REPAIR_WINDOW", false);
	XI_WindowDisable("REPAIR_WINDOW", true);

	SquadronSize = sti(pchar.skill.Temp.Tactic) / 2;
	if(SquadronSize < 1)
	{
		SquadronSize = 1;
	}
	if( SquadronSize > 5)
	{
		SquadronSize = 5;
	}
	
	string sText;

	sText = XI_ConvertString("MaxSquadronSize") + GetTextOnShipsQuantity(SquadronSize);
	sText = sText + "\n" + XI_ConvertString("SquadronSizeInfo");
	SetFormatedText("SQUADRON_INFO", sText);
	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"SQUADRON_INFO", 5 );

	SetFormatedText("SHIP_WINDOW_INFO_TEXT", "");
	SetFormatedText("SHIP_SELL_INFO_TEXT", "");

	sText = " "+ XI_ConvertString("ShipTypeShort");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("ShipClass");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Hull");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Sails");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Cannons");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " " + XI_ConvertString("Caliber");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " " + XI_ConvertString("Max.Caliber");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Speed");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Maneuv.");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Capacity");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);
	sText = " " + XI_Convertstring("Crew");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 0,	&sText);

	sText = " "+ XI_ConvertString("ShipTypeShort");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("ShipClass");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Hull");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Sails");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Cannons");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " " + XI_ConvertString("Caliber");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " " + XI_ConvertString("Max.Caliber");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Speed");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Maneuv.");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " "+ XI_ConvertString("Capacity");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);
	sText = " " + XI_Convertstring("Crew");
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 0,	&sText);

	sText = XI_ConvertString("FreeCrewLeftInShipyard") + FindRussianPeoplesString(sti(refShipMaster.shipyard.crew.quantity), "Acc");
	SetFormatedText("CREW_STORE_QUANTITY", sText);
}

void SetStoreShipDescription()
{
	bool isEnableBuyShipVariable = IsEnableBuyShip();
	SetSelectable("BUYSHIP_BUTTON",  isEnableBuyShipVariable);

	SetFormatedText("SHIP_SELL_INFO", "");
	string sText;

	string sCannonPict = "";
	string sCannonCaliber = "";
	if(sti(RealShips[iShipStoreListIndex].MaxCaliber) == 8)
	{
		sCannonPict = Cannon[CANNON_TYPE_CANNON_LBS8].picture;
		sCannonCaliber = Cannon[CANNON_TYPE_CANNON_LBS8].name;
	}
	if(sti(RealShips[iShipStoreListIndex].MaxCaliber) == 12)
	{
		sCannonPict = Cannon[CANNON_TYPE_CANNON_LBS8].picture;
		sCannonCaliber = Cannon[CANNON_TYPE_CANNON_LBS8].name;
	}
	if(sti(RealShips[iShipStoreListIndex].MaxCaliber) == 16)
	{
		sCannonPict = Cannon[CANNON_TYPE_CANNON_LBS12].picture;
		sCannonCaliber = Cannon[CANNON_TYPE_CANNON_LBS12].name;
	}
	if(sti(RealShips[iShipStoreListIndex].MaxCaliber) >= 24)
	{
		sCannonPict = Cannon[CANNON_TYPE_CANNON_LBS16].picture;
		sCannonCaliber = Cannon[CANNON_TYPE_CANNON_LBS16].name;
	}

	sText = XI_ConvertString(ShipsTypes[sti(Realships[iShipStoreListIndex].basetype)].name);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0,	&sText);

	sText = Realships[iShipStoreListIndex].class;
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = sti(Realships[iShipStoreListIndex].HP) + " / " + sti(Realships[iShipStoreListIndex].HP);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = sti(Realships[iShipStoreListIndex].SP) + " / " + sti(Realships[iShipStoreListIndex].SP);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = sti(Realships[iShipStoreListIndex].CannonsQuantity) + " / " + sti(Realships[iShipStoreListIndex].CannonsQuantity);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);
	
	sText = XI_ConvertString(sCannonCaliber);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = XI_ConvertString("caliber" + RealShips[iShipStoreListIndex].MaxCaliber);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = fts(stf(Realships[iShipStoreListIndex].SpeedRate), 3);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);
	sText = fts(stf(Realships[iShipStoreListIndex].TurnRate), 3);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);


	sText = sti(Realships[iShipStoreListIndex].Capacity);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	sText = sti(Realships[iShipStoreListIndex].maxcrew);
	SendMessage(&GameInterface,"lsle",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 0, &sText);

	SetNewPicture("SHIP_SELL_PICTURE", "interfaces\ships\" + ShipsTypes[sti(RealShips[iShipStoreListIndex].basetype)].name + ".tga");

	sText = XI_ConvertString("BuyCost") + "\n" + FindRussianMoneyString(GetBuyPrice(iShipStoreListIndex));
	SetFormatedText("SHIP_BUY_PRICE", stext);

	SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO", 1, 0);
	SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_SELL_INFO_TEXT", 1, 0);
	SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO", 1, 0);
	SendMessage( &GameInterface,"lsll",MSG_INTERFACE_MSG_TO_NODE,"SHIP_WINDOW_INFO_TEXT", 1, 0);

	sText = "HULL_UPGRADE_1";
	SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"STORE_UPGRADE_HULL", 6, sText, "hull");
	
	sText = "SAILS_UPGRADE_1";
	SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"STORE_UPGRADE_SAILS", 6, sText, "sails");
	
	sText = "CANNONS_UPGRADE_1";
	SendMessage(&GameInterface,"lslss",MSG_INTERFACE_MSG_TO_NODE,"STORE_UPGRADE_CANNONS", 6, sText, sCannonPict);

	sText = ShipsTypes[sti(Realships[iShipStoreListIndex].basetype)].name + "_descr";
	SetFormatedText("INFO_WINDOW_TEXT", XI_ConvertString(sText));

	SetFormatedText("SHIP_HELP_TEXT", "");
	SetFormatedText("STORE_HELP_TEXT", "");


	if(isEnableBuyShipVariable == false && sti(refCharacter.ship.type) != SHIP_NOTUSED)
	{
		SetFormatedtext("STORE_HELP_TEXT", XI_ConvertString("YouNeedToSellShipFirst"));
	}
	if(isEnableBuyShipVariable == false && sti(pchar.money) < GetFakeBuyPrice(iShipStoreListIndex))
	{
		SetFormatedtext("STORE_HELP_TEXT", XI_ConvertString("YouNeedMoreMoneyForBuyShip"));
	}

	int iOurTactic = GetSummonSkillFromName(pchar, SKILL_TACTIC);
	int iMaxSquadronSize = GetCompanionQuantity(pchar);
	int iPlayerShip = sti(pchar.ship.type);
	int iOfficers = GetNotQuestFreePassengersQuantity(pchar);
	if(iPlayerShip != SHIP_NOTUSED)
	{
		iPlayerShip = sti(Realships[iPlayerShip].basetype);
		if(ShipsTypes[iPlayerShip].name == "WarTartane")
		{
			iMaxSquadronSize = iMaxSquadronSize - 1;
			iOfficers = iOfficers + 1;
		}
	}

	if(isEnableBuyShipVariable == false && iOfficers < 1)
	{
		SetFormatedtext("STORE_HELP_TEXT", XI_ConvertString("YouHaveNoFreeCaptainForAssignToShip"));
	}

	
	iOurTactic = iOurTactic / 2;

	if(isEnableBuyShipVariable == false && iOurTactic <= iMaxSquadronSize)
	{
		SetFormatedtext("STORE_HELP_TEXT", XI_ConvertString("TacticSkillIsNotEnough"));
	}

	string attributeName = "ship" + (iStoreLine + 2);
	if(CheckAttribute(arShipList, attributeName + ".notforsale") || CheckAttribute(arShipList, attributeName + ".buyed"))
	{
		if(sti(arShipList.(attributeName).notforsale) == 1 || sti(arShipList.(attributeName).buyed) == 1)
		{
			SetFormatedText("STORE_HELP_TEXT", XI_ConvertString("ShipSolded"));
			SendMessage(&GameInterface,"lslll",MSG_INTERFACE_MSG_TO_NODE,"STORE_HELP_TEXT", 8,0,argb(255,192,192,192));
		}
	}


	SendMessage( &GameInterface,"lsl",MSG_INTERFACE_MSG_TO_NODE,"STORE_HELP_TEXT", 5 );

}

void ShowShipTooltip()
{
	string sNode = GetCurrentNode();
	switch(sNode)
	{
		case "SHIP_SELL_PICTURE":
			LaunchShipToolTip(iShipStoreListIndex);
		break;

		case "SHIPS_SCROLL":
			LaunchShipToolTip(sti(characters[GetCharacterIDFromScroll()].ship.type));
		break;

		case "UPGRADE_HULL":
			LaunchUpgradesToolTip();
		break;

		case "UPGRADE_SAILS":
			LaunchUpgradesToolTip();
		break;

		case "UPGRADE_CANNONS":
			LaunchUpgradesToolTip();
		break;
	}
}

void LaunchShipToolTip(int iRShipType)
{
	g_bToolTipStarted = true;
	//int iRShipType = sti(chref.ship.type);
	int iBShipType = sti(RealShips[iRShipType].basetype);
	string sHeader = XI_ConvertString(ShipsTypes[iBShipType].Name);
	string sGroupName = "SHIPS_"+ShipsTypes[iBShipType].Name;
	string sShipDescr = XI_ConvertString(ShipsTypes[iBShipType].Name+"_descr");
	string sShipParamString = XI_ConvertString("ShipClass") + ": " + ShipsTypes[iBShipType].class + "\n" +
		XI_ConvertString("Hull") + ": " + sti(RealShips[iRShipType].hp) + "\n" +
		XI_ConvertString("Cannons") + ": " + RealShips[iRShipType].CannonsQuantity + "\n" +
		XI_ConvertString("Speed") + ": " + FloatToString(stf(RealShips[iRShipType].speedrate),2) + "\n" +
		XI_ConvertString("Maneuver") + ": " + FloatToString(stf(RealShips[iRShipType].turnrate),2) + "\n" +
		XI_ConvertString("Capacity") + ": " + RealShips[iRShipType].Capacity + "\n" +
		XI_ConvertString("Max.Crew") + ": " + RealShips[iRShipType].MaxCrew;

	CreateTooltip("#"+sHeader, sShipDescr,argb(255,255,255,255), sShipParamString,argb(255,255,255,255), "",0, "",0, "", sGroupName,"ship", 64,64);
}

void EndTooltip()
{
	if(g_bToolTipStarted == true)
	{
		CloseTooltip();
		g_bToolTipStarted = false;
	}
}

void LaunchUpgradesToolTip()
{
	g_bToolTipStarted = true;

	string sHeader = "";
	string sText1 = "";
	string sText2 = "";
	string sText3 = "";
	string sPicture = "";
	string sGroupPicture = "";
	string sGroup = "";
	
	string sNode = GetCurrentNode();

	switch(sNode)
	{
		case "UPGRADE_HULL":
			sHeader = XI_ConvertString("HullUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoHull" + refCharacter.ship.upgrades.hull);
			
			sGroup = "HULL_UPGRADE_" + refCharacter.ship.upgrades.hull;
			sGroupPicture = "hull";
		break;
		case "UPGRADE_SAILS":
			sHeader = XI_ConvertString("SailsUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoSails" + refCharacter.ship.upgrades.sails);
			
			sGroup = "SAILS_UPGRADE_" + refCharacter.ship.upgrades.sails;
			sGroupPicture = "sails";
		break;
		case "UPGRADE_CANNONS":
			sHeader = XI_ConvertString("CannonsUpgrade");
			sText1 = XI_ConvertString("UpgradeShipInfoCannons" + refCharacter.ship.upgrades.cannons);
			
			int iOurCannonType = sti(refCharacter.ship.cannons.type);
			sGroupPicture = Cannon[iOurCannonType].picture;
			sGroup = "CANNONS_UPGRADE_" + refCharacter.ship.upgrades.cannons;

			int iCannonType =  Cannon[sti(refCharacter.ship.cannons.type)].type;
			if(iCannonType == CANNON_NAME_CULVERINE)
			{
				sText2 = XI_ConvertString("cannon type") + ": " + XI_ConvertString("Culverine");
			}
			if(iCannonType == CANNON_NAME_CANNON)
			{
				sText2 = XI_ConvertString("cannon type") + ": " + XI_ConvertString("Cannon");
			}

			sText2 = sText2 + "\n" + XI_ConvertString("Caliber_info");
			sText2 = sText2 + ": " + XI_ConvertString(Cannon[sti(refCharacter.ship.cannons.type)].name);
		break;
	}

	CreateTooltip("#" + sHeader, sText1, argb(255,255,255,255), sText2, argb(255,255,255,255), sText3, argb(255,192,255,192), "", argb(255,255,255,255), sPicture, sGroup, sGroupPicture, 64, 64);
}

void FillPassengersScroll(string sMode)
{
	nCurOScrollNum = -1;

	DeleteAttribute(&GameInterface, "OFFICERS_SCROLL");
	
	GameInterface.OFFICERS_SCROLL.ImagesGroup.t0 = "EMPTYFACE";

	GameInterface.OFFICERS_SCROLL.BadTex1 = 0;
	GameInterface.OFFICERS_SCROLL.BadPic1 = "emptyface";

	FillFaceList("OFFICERS_SCROLL.ImagesGroup", pchar, 1);
	FillFaceList("OFFICERS_SCROLL.ImagesGroup", pchar, 4);

	string attributeName;
	int cn = -1;

	string tex;

	int m = 0;
	int iPassengers = GetPassengersQuantity(pchar);


	int iPCharShip = sti(pchar.ship.type);
	bool isFillMainCharacterToList = false;
	if(iPCharShip != SHIP_NOTUSED)
	{
		iPCharShip = sti(RealShips[iPCharShip].basetype);
		if(ShipsTypes[iPCharShip].name == "WarTartane")
		{
			isFillMainCharacterToList = true;
		}
	}
	/*else
	{
		isFillMainCharacterToList = true;
	}*/
	if(refCharacter.id != pchar.id)
	{
		isFillMainCharacterToList = true;
	}
	if(isFillMainCharacterToList == true)
	{
		attributeName = "pic" + (m+1);
		GameInterface.OFFICERS_SCROLL.(attributeName).index = nMainCharacterIndex;
		GameInterface.OFFICERS_SCROLL.(attributeName).character = pchar.id;
		GameInterface.OFFICERS_SCROLL.(attributeName).str1 = pchar.name;
		GameInterface.OFFICERS_SCROLL.(attributeName).str2 = pchar.lastname;
		GameInterface.OFFICERS_SCROLL.(attributeName).img1 = GetFacePicName(pchar);
		tex = FindFaceGroupNum("OFFICERS_SCROLL.ImagesGroup","FACE128_"+pchar.FaceID);
		if (tex == "-1") 
		{
			tex= "0";
		}
		GameInterface.OFFICERS_SCROLL.(attributeName).tex1 = tex;

		m++;	
	}

	if(refCharacter.id != pchar.id || iConfirmMode == MODE_BUY)
	{
		for(int i = 0; i < iPassengers; i++)
		{
			cn = GetPassenger(pchar,i);
			if( cn >= 0 && cn != nMainCharacterIndex) 
			{
				if(sti(characters[cn].prisoned) != 1)
				{
					if(!CheckAttribute(&characters[cn], "isfree"))
					{
						if(!CheckAttribute(&characters[cn], "isquest"))
						{
							attributeName = "pic" + (m+1);

							GameInterface.OFFICERS_SCROLL.(attributeName).index = cn;
							GameInterface.OFFICERS_SCROLL.(attributeName).character = characters[cn].id;
							GameInterface.OFFICERS_SCROLL.(attributeName).str1 = characters[cn].name;
							GameInterface.OFFICERS_SCROLL.(attributeName).str2 = characters[cn].lastname;
							GameInterface.OFFICERS_SCROLL.(attributeName).img1 = GetFacePicName(GetCharacter(cn));
							tex = FindFaceGroupNum("OFFICERS_SCROLL.ImagesGroup","FACE128_"+Characters[cn].FaceID);
							if (tex == "-1") 
							{
								tex= "0";
							}
							GameInterface.OFFICERS_SCROLL.(attributeName).tex1 = tex;

							m++;	
						}
					}
				}
			}
		}
	}

	if(sMode == "companions")
	{
		int iCompanions = GetCompanionQuantity(pchar);
		for(int k = 0; k < iCompanions; k++)
		{
			cn = GetCompanionIndex(pchar, k)
			if( cn >= 0 && cn != nMainCharacterIndex) 
			{
				if(characters[cn].id != refCharacter.id)
				{
					if(GetShipRemovable(&characters[cn]) == true || characters[cn].id == pchar.id)
					{
						if(!CheckAttribute(&characters[cn], "isquest"))
						{
							attributeName = "pic" + (m+1);

							GameInterface.OFFICERS_SCROLL.(attributeName).index = cn;
							GameInterface.OFFICERS_SCROLL.(attributeName).character = characters[cn].id;
							GameInterface.OFFICERS_SCROLL.(attributeName).str1 = characters[cn].name;
							GameInterface.OFFICERS_SCROLL.(attributeName).str2 = characters[cn].lastname;
							GameInterface.OFFICERS_SCROLL.(attributeName).img1 = GetFacePicName(GetCharacter(cn));
							tex = FindFaceGroupNum("OFFICERS_SCROLL.ImagesGroup","FACE128_"+Characters[cn].FaceID);
							if (tex == "-1") 
							{
								tex= "0";
							}
							GameInterface.OFFICERS_SCROLL.(attributeName).tex1 = tex;

							m++;	
						}
					}
				}
			}
		}
	}

	GameInterface.OFFICERS_SCROLL.ListSize = m;
	GameInterface.OFFICERS_SCROLL.NotUsed = 5;	

	SendMessage(&GameInterface,"lsl",MSG_INTERFACE_SCROLL_CHANGE,"OFFICERS_SCROLL",-1);
}

void FillCrewToShip(aref chr)
{
	int shipType = sti(chr.ship.type);
		
	chr.ship.crew.BoardingCrew = refShipMaster.shipyard.crew.BoardingCrew;
	if(sti(RealShips[shipType].BoardingCrew) < sti(chr.ship.crew.BoardingCrew))
	{
		chr.ship.crew.BoardingCrew = RealShips[shipType].BoardingCrew;
	}
	refShipMaster.shipyard.crew.BoardingCrew = sti(refShipMaster.shipyard.crew.BoardingCrew) - sti(chr.ship.crew.BoardingCrew);

	chr.ship.crew.SailorCrew = refShipMaster.shipyard.crew.SailorCrew;
	if(sti(RealShips[shipType].SailorCrew) < sti(chr.ship.crew.SailorCrew))
	{
		chr.ship.crew.SailorCrew = RealShips[shipType].SailorCrew;
	}
	refShipMaster.shipyard.crew.SailorCrew = sti(refShipMaster.shipyard.crew.SailorCrew) - sti(chr.ship.crew.SailorCrew);

	chr.ship.crew.GunnerCrew = refShipMaster.shipyard.crew.GunnerCrew;
	if(sti(RealShips[shipType].GunnerCrew) < sti(chr.ship.crew.GunnerCrew))
	{
		chr.ship.crew.GunnerCrew = RealShips[shipType].GunnerCrew;
	}
	refShipMaster.shipyard.crew.GunnerCrew = sti(refShipMaster.shipyard.crew.GunnerCrew) - sti(chr.ship.crew.GunnerCrew);

	chr.ship.crew.CannonerCrew = refShipMaster.shipyard.crew.CannonerCrew;
	if(sti(RealShips[shipType].CannonerCrew) < sti(chr.ship.crew.CannonerCrew))
	{
		chr.ship.crew.CannonerCrew = RealShips[shipType].CannonerCrew;
	}
	refShipMaster.shipyard.crew.CannonerCrew = sti(refShipMaster.shipyard.crew.CannonerCrew) - sti(chr.ship.crew.CannonerCrew);
	
	chr.ship.crew.quantity = sti(chr.ship.crew.BoardingCrew) + sti(chr.ship.crew.SailorCrew) + sti(chr.ship.crew.GunnerCrew) + sti(chr.ship.crew.CannonerCrew);
	refShipMaster.shipyard.crew.quantity = sti(refShipMaster.shipyard.crew.BoardingCrew) + sti(refShipMaster.shipyard.crew.SailorCrew) + sti(refShipMaster.shipyard.crew.GunnerCrew) + sti(refShipMaster.shipyard.crew.CannonerCrew);
}