

int LocationInitQuestLocations(int n)
{
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//  
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Cabine";
	locations[n].id.label = "cabine";
	locations[n].filespath.models = "locations\inside\Cabin01\";
	locations[n].image = "loading\Cabin.tga";
	//Sound
	locations[n].type = "sailing_cabine";
	Locations[n].camshuttle = 1;
	//Models
	//Always
	locations[n].models.always.tavern = "Cabin01";
	locations[n].models.always.locators = "Cabin01_locators";

	locations[n].models.always.window = "cabin01_fonar";
    Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 65532;
	
	//Day
	locations[n].models.day.charactersPatch = "Cabin01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Cabin01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Antigua";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Sea";
	//locations[n].locators_radius.reload.sea_2_back = 2.0;
	
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   2
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Cabine2";
	locations[n].id.label = "cabine";
	locations[n].filespath.models = "locations\inside\Cabin02\";
	locations[n].image = "loading\Cabin.tga";
	//Sound
	locations[n].type = "sailing_cabine";
	Locations[n].camshuttle = 1;
	//Models
	//Always
	locations[n].models.always.tavern = "Cabin02";
	locations[n].models.always.locators = "Cabin02_locators";

	locations[n].models.always.window = "cabin02_fonar";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 65532;
	
	//Day
	locations[n].models.day.charactersPatch = "Cabin02_patch";

	//Night
	locations[n].models.night.charactersPatch = "Cabin02_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	
	locations[n].reload.l1.name = "reload1";
	locations[n].reload.l1.go = "Antigua";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Sea";
	//locations[n].locators_radius.reload.sea_2_back = 2.0;
	
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//  
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Duel_field";
	locations[n].id.label = "Duel Field";
	locations[n].filespath.models = "locations\decks\duelfield\";
	locations[n].image = "loading\DuelField.tga";
	//Sound
	locations[n].type = "land";
	//Models
	//Always
	locations[n].models.always.tavern = "duelfield";
	locations[n].models.always.locators = "duelfield_locators";
	locations[n].models.always.grassPatch = "duelfield_grass";
	
	locations[n].models.always.plan = "duelfield_plan";
	locations[n].models.always.plan.level = 9;

	//Day
	locations[n].models.day.charactersPatch = "duelfield_patch";
	locations[n].models.day.fonar = "duelfield_fd";

	//Night
	locations[n].models.night.charactersPatch = "duelfield_patch";
	locations[n].models.night.fonar = "duelfield_fn";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	locations[n].reload.l1.name = "reload1";
	locations[n].reload.l1.go = "Tortuga_tavern";
	locations[n].reload.l1.emerge = "reload1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Town";

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   ( )
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "farm_field";
	locations[n].id.label = "Farm Field";
	locations[n].filespath.models = "locations\decks\farmfield\";
	locations[n].image = "loading\Farmfield.tga";
	//Sound
	locations[n].type = "land";
	//Models
	//Always
	locations[n].models.always.tavern = "farmfield";
	locations[n].models.always.locators = "farmfield_locators";
	locations[n].models.always.grassPatch = "farmfield_grass";

	locations[n].models.always.plan = "farmfield_plan";
	locations[n].models.always.plan.level = 9;

	//Day
	locations[n].models.day.charactersPatch = "farmfield_patch";
	locations[n].models.day.fonar = "farmfield_fd";

	//Night
	locations[n].models.night.charactersPatch = "farmfield_patch";
	locations[n].models.night.fonar = "farmfield_fn";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	locations[n].reload.l1.name = "reload1";
	locations[n].reload.l1.go = "Tortuga_tavern";
	locations[n].reload.l1.emerge = "reload1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Town";

	locations[n].reload.l2.name = "reload2";
	locations[n].reload.l2.go = "Cob_house";
	locations[n].reload.l2.emerge = "reload1";
	locations[n].reload.l2.autoreload = "0";
	locations[n].reload.l2.label = "House";

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//COB_HOUSE -      ( )
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Cob_house";
	locations[n].id.label = "House";
	locations[n].image = "loading\Cobhurch01.tga";

	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Cobhouse";

	locations[n].models.always.locators = "cobhouse_locators";
	locations[n].models.always.tavern = "cobhouse";
	locations[n].models.always.window = "cobhouse_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	
	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "cobhouse_patch";

	//Night
	locations[n].models.night.charactersPatch = "cobhouse_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1";
	locations[n].reload.l1.go = "farm_field";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "farm_field";
	n = n + 1;


	//////////////////////////////////////////////////////////////////////////////////////////
	//Treasure cave
	//////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Grotto";
	locations[n].id.label = "Grotto";
	locations[n].filespath.models = "locations\Grotto\";
	//locations[n].image = "loading\Tavern_01.tga";
	//Sound
	locations[n].type = "cave";
	Locations[n].QuestlockWeather = "Seventeen Hour";
	//Models
	//Always

	Locations[n].models.always.town = "Grotto";
	Locations[n].models.always.seabed = "Grotto_sb";
	Locations[n].models.always.grassPatch = "Grotto_grass";
	Locations[n].models.always.locators = "Grotto_locators";
		
	Locations[n].models.always.l2 = "Gold";
	Locations[n].models.always.l2.tech = "EnvironmentShader";
	Locations[n].models.always.l2.reflection = 1;
		
	Locations[n].models.always.Waterfall1 = "water";
	Locations[n].models.always.Waterfall1.uvslide.v0 = 0.0;
	Locations[n].models.always.Waterfall1.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall1.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall1.level = 50;

	Locations[n].models.always.Waterfall2 = "cfall";
	Locations[n].models.always.Waterfall2.uvslide.v0 = 0.3;
	Locations[n].models.always.Waterfall2.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall2.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall2.level = 50;
	
	//Day
	locations[n].models.day.charactersPatch = "Grotto_patch_day";
	//Night
	locations[n].models.night.charactersPatch = "Grotto_patch_day";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Dominica";
	locations[n].reload.l1.emerge = "reload1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Sea";
	locations[n].locators_radius.reload.reload1_back = 3.0;
	//locations[n].locators_radius.goto.goto4 = 5.0;
	n = n + 1;


	//////////////////////////////////////////////////////////////////////////////////////////
	//House_behind_gates
	//////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "House_behind_gates";
	locations[n].id.label = "Jungle";
	locations[n].filespath.models = "locations\decks\FarmField\";
	//locations[n].image = "loading\Tavern_01.tga";
	//Sound
	locations[n].type = "land";
	//Models
	//Always

	Locations[n].models.always.town = "FarmField";
	Locations[n].models.always.grassPatch = "FarmField_grass";
	Locations[n].models.always.locators = "FarmField_locators";

	locations[n].models.always.plan = "FarmField_plan";
	locations[n].models.always.plan.level = 9;
	
	//Day
	locations[n].models.day.charactersPatch = "FarmField_patch";
	locations[n].models.day.fonar = "FarmField_fd";
	//Night
	locations[n].models.night.charactersPatch = "FarmField_patch";
	locations[n].models.night.fonar = "FarmField_fn";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////
	//House_behind_gates_inside
	//////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "House_behind_gates_inside";
	locations[n].id.label = "House";
	locations[n].filespath.models = "locations\inside\cobhouse\";
	//locations[n].image = "loading\Tavern_01.tga";
	//Sound
	locations[n].type = "House";
	//Models
	//Always

	Locations[n].models.always.town = "cobhouse";
	locations[n].models.always.window = "cobhouse_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	Locations[n].models.always.locators = "cobhouse_locators";
	locations[n].models.always.back = "..\backgroundInsidesOutCity";

	//Day
	locations[n].models.day.charactersPatch = "cobhouse_patch";
	//Night
	locations[n].models.night.charactersPatch = "cobhouse_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Room_in_House_behind_gates_inside
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "Room_in_House_behind_gates_inside";
	locations[n].id.label = "Room";
	locations[n].filespath.models = "locations\inside\Brothel_room\";
	locations[n].image = "loading\Brothel_512.tga";

	//Town sack
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	//Models
	//Always
	locations[n].models.always.locators = "Brothel_room_locators";
	locations[n].models.always.store = "Brothel_room";
	locations[n].models.always.window = "Brothel_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	
	locations[n].models.always.back = "..\backgroundInsidesOutCity";

	//Day
	locations[n].models.day.charactersPatch = "Brothel_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Brothel_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "House_behind_gates_inside";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "House";
	Locations[n].reload.l1.disable = 1;
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;


	return n;
}
