
void InitColonies()
{
	int n, i;

	for (i=0; i<MAX_COLONIES; i++)
	{
		DeleteAttribute(&Colonies[i], "");

		Colonies[i].id = "";
		Colonies[i].reload_enable = true;
		Colonies[i].visible = true;
		
		Colonies[i].commander = "-1";
		Colonies[i].money = 0;
		Colonies[i].capturetime = "";
		Colonies[i].capture_day = "";
		Colonies[i].capture_month = "";
		Colonies[i].capture_year = "";
		Colonies[i].timerInfo = "0";
		Colonies[i].captureInfo = "0";
		Colonies[i].captureSuccesInfo = "0";
		Colonies[i].resquetime = "";
		Colonies[i].days_for_resque = "-1";
		Colonies[i].capture_flag = "0";
		Colonies[i].agressor = "-1";
		Colonies[i].loyality = "1";
		Colonies[i].visited = "0";
		Colonies[i].disease = "0";
		Colonies[i].disease.time = "0";
		Colonies[i].island = "0";
		Colonies[i].num = "1";
		colonies[i].population = 0;
		colonies[i].colonists = 0;
		colonies[i].tax_rate = (1 + iGameArcade);
		colonies[i].morale = 50;
		colonies[i].crew.sailors = 50;
		colonies[i].crew.soldiers = 50;
		colonies[i].crew.musketeers = 20;
		colonies[i].crew.cannoners = 50;
		colonies[i].isBuild = 0;
		colonies[i].crew.experience = 1;
		colonies[i].info.day = worldMap.date.day;
		colonies[i].info.month = worldMap.date.month;
		colonies[i].info.year = worldMap.date.year;

		colonies[i].ismaincolony = 0;

		///////////////////////////////////////////////////////////////////// 
		/// Upgrades
		///////////////////////////////////////////////////////////////////// 
		colonies[i].colonylevel = rand(iColonyState - 1) + 1;

		//1 
		colonies[i].fort = 0;
		colonies[i].shipyard = 1;
		colonies[i].wheatfield = 0;
		colonies[i].fishingpier = 0;
		colonies[i].mill = 0;

		//2 
		//   
		// 2
		// 2
		colonies[i].huts = 0; 
		colonies[i].storehouse = 0;

		//3 
		//   
		// 3
		// 3
		colonies[i].church = 1;
		//colonies[i].prison = 0;
		
		//4 
		//   
		// 4
		// 4
		colonies[i].academy = 0; 

		colonies[i].expedition = 0;
		colonies[i].goldmines = rand(1)-1;// 0 -  ,  -1   
		colonies[i].silvermines = rand(1)-1;// 0 -  ,  -1   
	}
	SetContrabandRules();
	SetTradeRules();
		
	///////////////////////////////////////////////////////////////////// 
	/// Bridgetown
	///////////////////////////////////////////////////////////////////// 
		n = 0;
		Colonies[n].id = "Bridgetown";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = ENGLAND;
		Colonies[n].nation = ENGLAND;
		Colonies[n].island = "Barbados";
		colonies[n].num = 1;
		colonies[n].ismaincolony = 1;
		colonies[n].map.x = 1812;
		colonies[n].map.y = 1655;
		
	///////////////////////////////////////////////////////////////////// 
	/// San Juan
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "SanJuan";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = SPAIN;
		Colonies[n].nation = SPAIN;
		Colonies[n].island = "PuertoRico";
		colonies[n].num = 1;
		colonies[n].map.x = 933;
		colonies[n].map.y = 312;
		
	///////////////////////////////////////////////////////////////////// 
	/// Santiago Vega
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "SantiagoVega";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = SPAIN;
		Colonies[n].nation = SPAIN;
		Colonies[n].island = "Jamaica";
		colonies[n].num = 1;
		colonies[n].ismaincolony = 1;
		colonies[n].map.x = 206;
		colonies[n].map.y = 440;
		
	///////////////////////////////////////////////////////////////////// 
	/// Curacao
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Curacao";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = HOLLAND;
		Colonies[n].nation = HOLLAND;
		Colonies[n].island = "Curacao";
		colonies[n].num = 1;
		colonies[n].map.x = 625;
		colonies[n].map.y = 1895;

	///////////////////////////////////////////////////////////////////// 
	/// Tortuga
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Tortuga";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = FRANCE;
		Colonies[n].nation = FRANCE;
		Colonies[n].island = "Tortuga";
		colonies[n].num = 1;
		colonies[n].map.x = 450;
		colonies[n].map.y = 195;
		
	///////////////////////////////////////////////////////////////////// 
	/// St. Martin
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "StMartin";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = HOLLAND;
		Colonies[n].nation = HOLLAND;
		Colonies[n].island = "StMartin";
		colonies[n].num = 1;
		colonies[n].ismaincolony = 1;
		colonies[n].map.x = 1320;
		colonies[n].map.y = 371;

	///////////////////////////////////////////////////////////////////// 
	/// St. Kitts
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "StKitts";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = ENGLAND;
		Colonies[n].nation = ENGLAND;
		Colonies[n].island = "StKitts";
		colonies[n].num = 1;
		colonies[n].map.x = 1315;
		colonies[n].map.y = 648;

	///////////////////////////////////////////////////////////////////// 
	/// Nevis
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Nevis";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = ENGLAND;
		Colonies[n].nation = ENGLAND;
		Colonies[n].island = "Nevis";
		colonies[n].num = 1;
		colonies[n].map.x = 1381;
		colonies[n].map.y = 770;

	///////////////////////////////////////////////////////////////////// 
	/// StEustatius
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "StEustatius";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = HOLLAND;
		Colonies[n].nation = HOLLAND;
		Colonies[n].island = "StEustatius";
		colonies[n].num = 1;
		colonies[n].map.x = 1370;
		colonies[n].map.y = 505;

	///////////////////////////////////////////////////////////////////// 
	/// Antigua
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Antigua";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = ENGLAND;
		Colonies[n].nation = ENGLAND;
		Colonies[n].island = "Antigua";
		colonies[n].num = 1;
		colonies[n].map.x = 1495;
		colonies[n].map.y = 635;

	///////////////////////////////////////////////////////////////////// 
	/// Montserrat
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Montserrat";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = ENGLAND;
		Colonies[n].nation = ENGLAND;
		Colonies[n].island = "Montserrat";
		colonies[n].num = 1;
		colonies[n].map.x = 1450;
		colonies[n].map.y = 895;

	///////////////////////////////////////////////////////////////////// 
	/// Guadeloupe
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Guadeloupe";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = FRANCE;
		Colonies[n].nation = FRANCE;
		Colonies[n].island = "Guadeloupe";
		colonies[n].num = 1;
		colonies[n].ismaincolony = 1;
		colonies[n].map.x = 1560;
		colonies[n].map.y = 1010;
		
		//Cerez: Destroy Guadeloupe Church for a visual effect (because the entrance locator is broken)
		colonies[n].church = 0;

	///////////////////////////////////////////////////////////////////// 
	/// Martinique
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Martinique";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = FRANCE;
		Colonies[n].nation = FRANCE;
		Colonies[n].island = "Martinique";
		colonies[n].num = 1;
		colonies[n].map.x = 1648;
		colonies[n].map.y = 1432;

	///////////////////////////////////////////////////////////////////// 
	/// La Vega
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "LaVega";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = SPAIN;
		Colonies[n].nation = SPAIN;
		Colonies[n].island = "Hispaniola";
		Colonies[n].num = "2";
		colonies[n].map.x = 535;
		colonies[n].map.y = 265;

	///////////////////////////////////////////////////////////////////// 
	/// Santo Domingo
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "SantoDomingo";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = SPAIN;
		Colonies[n].nation = SPAIN;
		Colonies[n].island = "Hispaniola";
		Colonies[n].num = "3";
		colonies[n].map.x = 568;
		colonies[n].map.y = 322;
		
	///////////////////////////////////////////////////////////////////// 
	/// Petit Goave
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "PetitGoave";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = FRANCE;
		Colonies[n].nation = FRANCE;
		Colonies[n].island = "Hispaniola";
		Colonies[n].num = "1";
		colonies[n].map.x = 450;
		colonies[n].map.y = 325;
		
	///////////////////////////////////////////////////////////////////// 
	/// Dominica
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Dominica";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = "none";
		Colonies[n].nation = "none";
		Colonies[n].island = "Dominica";
		Colonies[n].num = "1";
		colonies[n].map.x = 1595;
		colonies[n].map.y = 1250;
		colonies[n].colonylevel = 0;
		
	///////////////////////////////////////////////////////////////////// 
	/// Grenada
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "Grenada";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = "none";
		Colonies[n].nation = "none";
		Colonies[n].island = "Grenada";
		Colonies[n].num = "1";
		colonies[n].map.x = 1605;
		colonies[n].map.y = 1852;
		colonies[n].colonylevel = 0;

	///////////////////////////////////////////////////////////////////// 
	/// IslaMona
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "IslaMona";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = "none";
		Colonies[n].nation = "none";
		Colonies[n].island = "IslaMona";
		Colonies[n].num = "1";
		colonies[n].map.x = 720;
		colonies[n].map.y = 395;
		colonies[n].colonylevel = 0;
	
	///////////////////////////////////////////////////////////////////// 
	/// MarieGalante
	///////////////////////////////////////////////////////////////////// 
		n = n + 1;
		Colonies[n].id = "MarieGalante";
		Colonies[n].visible = true;
		Colonies[n].smuggling_nation = "none";
		Colonies[n].nation = "none";
		Colonies[n].island = "MarieGalante";
		Colonies[n].num = "1";
		colonies[n].map.x = 1625;
		colonies[n].map.y = 1125;
		colonies[n].colonylevel = 0;
		
	
	CreateColonyPopulation();
	SetTradeRulesForSeveralColoniesOneOneIsland();
} 


