
int LocationInitIslaMona(int n)
{
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_town";
	locations[n].id.label = "IslaMona";
	locations[n].worldmap = "IslaMona";
	
	locations[n].townsack = "IslaMona";
	locations[n].fastreload = "IslaMona";
	
	locations[n].filespath.models = "locations\Town_IslaMona\Town\";
	locations[n].image = "loading\Town_512.tga";
	locations[n].citizens = true;
	locations[n].soldiers = true;

	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	locations[n].models.always.L1 = "IslaMona";
	locations[n].models.always.locators = "IslaMona_locators";
	locations[n].models.always.grassPatch = "IslaMona_grass";
	Locations[n].models.always.seabed = "IslaMona_sb";
	
	locations[n].models.always.plan = "IslaMona_plan";
	locations[n].models.always.plan.level = 9;

	//River
	Locations[n].models.always.Waterfall1 = "Islamona_river1";
	Locations[n].models.always.Waterfall1.uvslide.v0 = 0.2;
        Locations[n].models.always.Waterfall1.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall1.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall1.level = 50;
	
	Locations[n].models.always.Waterfall2 = "Islamona_river2";
	Locations[n].models.always.Waterfall2.uvslide.v0 = -0.3;
        Locations[n].models.always.Waterfall2.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall2.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall2.level = 49;

	//Day
	locations[n].models.day.fonar = "IslaMona_fd";
	locations[n].models.day.charactersPatch = "IslaMona_patch";
	//locations[n].models.day.rinok = "IslaMona_rinok";
	//Night
	locations[n].models.night.fonar = "IslaMona_fn";
	locations[n].models.night.charactersPatch = "IslaMona_patch";
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map

	locations[n].reload.l0.name = "reload1";
	locations[n].reload.l0.go = "IslaMona";
	locations[n].reload.l0.emerge = "reload_1";
	locations[n].reload.l0.autoreload = "0";
	locations[n].reload.l0.label = "";
	locations[n].locators_radius.reload.reload1_back = 0.2;

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	locations[n].locators_radius.reload.reload1_back = 1.3;

	locations[n].reload.l3.name = "reload3_back";
	locations[n].reload.l3.go = "IslaMona_townhall";
	locations[n].reload.l3.emerge = "reload1";
	locations[n].reload.l3.autoreload = "0";
	locations[n].reload.l3.label = "Residence";

	locations[n].reload.l4.name = "reload4_back";
	locations[n].reload.l4.go = "IslaMona_tavern";
	locations[n].reload.l4.emerge = "reload1";
	locations[n].reload.l4.autoreload = "0";
	locations[n].reload.l4.label = "Tavern";

	locations[n].reload.l5.name = "reload5_back";
	locations[n].reload.l5.go = "IslaMona_shipyard";
	locations[n].reload.l5.emerge = "reload1";
	locations[n].reload.l5.autoreload = "0";
	locations[n].reload.l5.label = "Shipyard";
	Locations[n].reload.l5.close_for_night = 1;

	locations[n].reload.l6.name = "reload6_back";
	locations[n].reload.l6.go = "IslaMona_store";
	locations[n].reload.l6.emerge = "reload1";
	locations[n].reload.l6.autoreload = "0";
	locations[n].reload.l6.label = "Store";
	Locations[n].reload.l6.close_for_night = 1;

	n = n + 1;

    
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_tavern";
	locations[n].id.label = "IslaMona tavern";
	locations[n].filespath.models = "locations\inside\tavern04\";
	locations[n].image = "loading\Tavern_512.tga";
	locations[n].habitues = 1;
	//Town sack
	locations[n].townsack = "IslaMona";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "tavern";
	locations[n].fastreload = "IslaMona";
	//Models
	//Always
	locations[n].models.always.tavern = "tavern04";
	locations[n].models.always.locators = "tavern04_locators";
	locations[n].models.always.window = "tavern04_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "tavern04_patch";

	//Night
	locations[n].models.night.charactersPatch = "tavern04_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona_town";
	locations[n].reload.l1.emerge = "reload4";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_tavern_upstairs";
	locations[n].id.label = "IslaMona Tavern upstairs";
	locations[n].image = "loading\Tavern_512.tga";

	//Town sack
	locations[n].townsack = "IslaMona";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "IslaMona";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Tavern_room";
	locations[n].models.always.locators = "Tavern_room_locators";
	locations[n].models.always.tavern = "Tavern_room";
	locations[n].models.always.window = "tavern_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona_tavern";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	locations[n].locators_radius.reload.reload1 = 0.8;
	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_store";
	locations[n].id.label = "IslaMona store";
	locations[n].filespath.models = "locations\inside\Store02\";
	locations[n].image = "loading\Shop_512.tga";

	//Town sack
	locations[n].townsack = "IslaMona";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shop";
	locations[n].fastreload = "IslaMona";
	//Models
	//Always
	locations[n].models.always.locators = "Store02_locators";
	locations[n].models.always.store = "Store02";
	locations[n].models.always.window = "store02_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Store02_patch";

	//Night
	locations[n].models.night.charactersPatch = "Store02_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona_town";
	locations[n].reload.l1.emerge = "reload6";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;


 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_Shipyard";
	locations[n].id.label = "IslaMona shipyard";
	locations[n].filespath.models = "locations\inside\ShipyardPirates\";
	locations[n].image = "loading\Shipyard_512.tga";

	//Town sack
	locations[n].townsack = "IslaMona";
	//Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shipyard";
	locations[n].fastreload = "IslaMona";
	//Models
	
	//Always
	locations[n].models.always.locators = "ShipyardPirates_locators";
	locations[n].models.always.shipyard = "ShipyardPirates";
	locations[n].models.always.rock = "ShipyardPirates_rock";

	locations[n].models.always.window = "ShipyardPirates_fn";
	Locations[n].models.always.window.tech = "LocationWindows";
	Locations[n].models.always.window.level = 65532;
	//Day
	locations[n].models.day.charactersPatch = "ShipyardPirates_patch";
	
	//Night
	locations[n].models.night.charactersPatch = "ShipyardPirates_patch";
	

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona_town";
	locations[n].reload.l1.emerge = "reload5";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "IslaMona_townhall";
	locations[n].id.label = "IslaMona Townhall";
	locations[n].filespath.models = "locations\inside\Residence05";
	locations[n].image = "loading\Pirat_512.tga";

	//Town sack
	locations[n].townsack = "IslaMona";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "residence";
	locations[n].fastreload = "IslaMona";
	//Models

	//Always
	locations[n].models.always.locators = "residence05_locators";
	locations[n].models.always.l1 = "residence05";
	locations[n].models.always.window = "residence05_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	
	locations[n].models.always.back = "..\inside_back";
	
	//Day
	locations[n].models.day.charactersPatch = "residence05_patch";

	//Night
	locations[n].models.night.charactersPatch = "residence05_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "IslaMona_town";
	locations[n].reload.l1.emerge = "reload3";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "IslaMona";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;


	return n;
}
