
int LocationInitPetitGoave(int n)
{
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_town";
	locations[n].id.label = "PetitGoave town";
	locations[n].worldmap = "PetitGoave";
	
	locations[n].townsack = "PetitGoave";
	locations[n].fastreload = "PetitGoave";
	
	locations[n].filespath.models = "locations\Town_PetitGoave\Town\";
	locations[n].image = "loading\Town_512.tga";
	locations[n].citizens = true;
	locations[n].soldiers = true;

	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	locations[n].models.always.town = "PetitGoave";
	locations[n].models.always.L1 = "PetitGoave_signsA";
	Locations[n].models.always.seabed = "PetitGoave_sb";
	locations[n].models.always.locators = "PetitGoave_locators";
	locations[n].models.always.grassPatch = "PetitGoave_grass";
	
	locations[n].models.always.plan = "plan1";
	locations[n].models.always.plan.level = 9;
		//Fontain
	Locations[n].models.always.Waterfall1 = "fontain1";
	Locations[n].models.always.Waterfall1.uvslide.v0 = 0.5;
    Locations[n].models.always.Waterfall1.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall1.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall1.level = 50;
	
	Locations[n].models.always.Waterfall2 = "fontain2";
	Locations[n].models.always.Waterfall2.uvslide.v0 = 0.2;
    Locations[n].models.always.Waterfall2.uvslide.v1 = 0.0;
	Locations[n].models.always.Waterfall2.tech = "LocationWaterFall";
	Locations[n].models.always.Waterfall2.level = 49;


	//Day
	locations[n].models.day.fonar = "PetitGoave_fd";
	locations[n].models.day.charactersPatch = "PetitGoave_patch_day";
	locations[n].models.day.rinok = "PetitGoave_rinok";
	//Night
	locations[n].models.night.fonar = "PetitGoave_fn";
	locations[n].models.night.charactersPatch = "PetitGoave_patch_night";
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "Hispaniola";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	locations[n].locators_radius.reload.reload1_back = 1.8;

	locations[n].reload.l3.name = "reload3_back";
	locations[n].reload.l3.go = "PetitGoave_townhall";
	locations[n].reload.l3.emerge = "reload1";
	locations[n].reload.l3.autoreload = "0";
	locations[n].reload.l3.label = "Residence";
	Locations[n].reload.l3.close_for_night = 1;

	locations[n].reload.l4.name = "reload4_back";
	locations[n].reload.l4.go = "PetitGoave_tavern";
	locations[n].reload.l4.emerge = "reload1";
	locations[n].reload.l4.autoreload = "0";
	locations[n].reload.l4.label = "Tavern";

	locations[n].reload.l5.name = "reload5_back";
	locations[n].reload.l5.go = "PetitGoave_shipyard";
	locations[n].reload.l5.emerge = "reload1";
	locations[n].reload.l5.autoreload = "0";
	locations[n].reload.l5.label = "Shipyard";
	Locations[n].reload.l5.close_for_night = 1;

	locations[n].reload.l6.name = "reload6_back";
	locations[n].reload.l6.go = "PetitGoave_store";
	locations[n].reload.l6.emerge = "reload1";
	locations[n].reload.l6.autoreload = "0";
	locations[n].reload.l6.label = "Store";
	Locations[n].reload.l6.close_for_night = 1;

	locations[n].reload.l7.name = "reload7_back";
	locations[n].reload.l7.go = "PetitGoave_church";
	locations[n].reload.l7.emerge = "reload1";
	locations[n].reload.l7.autoreload = "0";
	locations[n].reload.l7.label = "Church";
	Locations[n].reload.l7.close_for_night = 1;
	//Locations[n].reload.l7.disable = 1;

	locations[n].reload.l8.name = "reload8_back";
	locations[n].reload.l8.go = "PetitGoave_bank";
	locations[n].reload.l8.emerge = "reload1";
	locations[n].reload.l8.autoreload = "0";
	locations[n].reload.l8.label = "Bank";
	//locations[n].reload.l8.disable = 1;
	Locations[n].reload.l8.close_for_night = 1;
	
	n = n + 1;

    
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_tavern";
	locations[n].id.label = "PetitGoave tavern";
	locations[n].filespath.models = "locations\inside\tavern01\";
	locations[n].image = "loading\Tavern_512.tga";
	locations[n].habitues = 1;
	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "tavern";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].models.always.tavern = "tavern01";
	locations[n].models.always.locators = "tavern01_locators";
	locations[n].models.always.window = "tavern01_windows";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "tavern01_patch";

	//Night
	locations[n].models.night.charactersPatch = "tavern01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//locations[n].models.back = "back\redlt_";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload4";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_tavern_upstairs";
	locations[n].id.label = "PetitGoave Tavern upstairs";
	locations[n].image = "loading\Tavern_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Tavern_room";
	locations[n].models.always.locators = "Tavern_room_locators";
	locations[n].models.always.tavern = "Tavern_room";
	locations[n].models.always.window = "tavern_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//locations[n].models.back = "back\redlf2_";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_tavern";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Tavern";
	locations[n].locators_radius.reload.reload1 = 0.8;
	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_store";
	locations[n].id.label = "PetitGoave store";
	locations[n].filespath.models = "locations\inside\Store03\";
	locations[n].image = "loading\Shop_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shop";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].models.always.locators = "Store03_locators";
	locations[n].models.always.store = "Store03";
	locations[n].models.always.window = "store03_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Store03_patch";

	//Night
	locations[n].models.night.charactersPatch = "Store03_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//locations[n].models.back = "back\redms_";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload6";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	locations[n].locators_radius.camdetector.camera1 = 5;
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_Bank";
	locations[n].id.label = "PetitGoave Bank";
	locations[n].filespath.models = "locations\inside\Bank01\";
	locations[n].image = "loading\Bank_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].models.always.locators = "Bank01_locators";
	locations[n].models.always.store = "Bank01";
	locations[n].models.always.window = "bank01_windows";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Bank01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Bank01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//locations[n].models.back = "back\redss_";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload8";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_Shipyard";
	locations[n].id.label = "PetitGoave shipyard";
	locations[n].filespath.models = "locations\inside\Shipyard01\";
	locations[n].image = "loading\Shipyard_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shipyard";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].models.always.locators = "Shipyard01_locators";
	locations[n].models.always.shipyard = "Shipyard01";
	//Day
	locations[n].models.day.charactersPatch = "Shipyard01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Shipyard01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload5";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_townhall";
	locations[n].id.label = "PetitGoave Townhall";
	locations[n].filespath.models = "locations\inside\Residence04";
	locations[n].image = "loading\Rezidence_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "residence";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].models.always.locators = "Residence04_locators";
	locations[n].models.always.l1 = "Residence04";
	locations[n].models.always.window = "residence04_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;
	
	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Residence04_patch";

	//Night
	locations[n].models.night.charactersPatch = "Residence04_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//locations[n].models.back = "back\redrsb_";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload3";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "PetitGoave_church";
	locations[n].id.label = "PetitGoave Church";
	locations[n].image = "loading\Church_512.tga";

	//Town sack
	locations[n].townsack = "PetitGoave";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "church";
	locations[n].fastreload = "PetitGoave";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Church01";

	locations[n].models.always.locators = "Church01_locators";
	locations[n].models.always.tavern = "Church01";
	locations[n].models.always.window = "church01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Church01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Church01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "PetitGoave_town";
	locations[n].reload.l1.emerge = "reload7";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "PetitGoave";
	LAi_LocationFightDisable(&locations[n], true);
	
	n = n + 1;

	return n;
}
