
int LocationInitStEustatius(int n)
{
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_town";
	locations[n].id.label = "StEustatius";
	locations[n].worldmap = "StEustatius";
	
	locations[n].townsack = "StEustatius";
	locations[n].fastreload = "StEustatius";
	
	locations[n].filespath.models = "locations\Town_StEustatius\Town\";
	locations[n].image = "loading\Town_512.tga";
	locations[n].citizens = true;
	locations[n].soldiers = true;

	//Sound
	locations[n].type = "town";
	LAi_LocationFantomsGen(&locations[n], true);
	//Models
	//Always
	locations[n].models.always.town = "StEustatius";
	locations[n].models.always.L1 = "StEustatius_signsA";
	Locations[n].models.always.seabed = "StEustatius_sb";
	locations[n].models.always.locators = "StEustatius_locators";
	locations[n].models.always.grassPatch = "StEustatius_grass";
	
	locations[n].models.always.plan = "plan1";
	locations[n].models.always.plan.level = 9;

	//Day
	locations[n].models.day.fonar = "StEustatius_fd";
	locations[n].models.day.charactersPatch = "StEustatius_patch_day";
	locations[n].models.day.rinok = "StEustatius_rinok";
	//Night
	locations[n].models.night.fonar = "StEustatius_fn";
	locations[n].models.night.charactersPatch = "StEustatius_patch_night";
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "true";
	//Reload map

	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius";
	locations[n].reload.l1.emerge = "reload_1";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	locations[n].locators_radius.reload.reload1_back = 1.8;

	locations[n].reload.l2.name = "reload2_back";
	locations[n].reload.l2.go = "StEustatius";
	locations[n].reload.l2.emerge = "reload_1";
	locations[n].reload.l2.autoreload = "0";
	locations[n].reload.l2.label = "StEustatius";
	locations[n].locators_radius.reload.reload2_back = 1.8;

	locations[n].reload.l3.name = "reload3_back";
	locations[n].reload.l3.go = "StEustatius_townhall";
	locations[n].reload.l3.emerge = "reload1";
	locations[n].reload.l3.autoreload = "0";
	locations[n].reload.l3.label = "Residence";
	Locations[n].reload.l3.close_for_night = 1;

	locations[n].reload.l4.name = "reload4_back";
	locations[n].reload.l4.go = "StEustatius_tavern";
	locations[n].reload.l4.emerge = "reload1";
	locations[n].reload.l4.autoreload = "0";
	locations[n].reload.l4.label = "Tavern";

	locations[n].reload.l5.name = "reload5_back";
	locations[n].reload.l5.go = "StEustatius_shipyard";
	locations[n].reload.l5.emerge = "reload1";
	locations[n].reload.l5.autoreload = "0";
	locations[n].reload.l5.label = "Shipyard";
	Locations[n].reload.l5.close_for_night = 1;

	locations[n].reload.l6.name = "reload6_back";
	locations[n].reload.l6.go = "StEustatius_store";
	locations[n].reload.l6.emerge = "reload1";
	locations[n].reload.l6.autoreload = "0";
	locations[n].reload.l6.label = "Store";
	Locations[n].reload.l6.close_for_night = 1;

	locations[n].reload.l7.name = "reload7_back";
	locations[n].reload.l7.go = "StEustatius_church";
	locations[n].reload.l7.emerge = "reload1";
	locations[n].reload.l7.autoreload = "0";
	locations[n].reload.l7.label = "Church";
	Locations[n].reload.l7.close_for_night = 1;
	//Locations[n].reload.l7.disable = 1;

	locations[n].reload.l8.name = "reload8_back";
	locations[n].reload.l8.go = "StEustatius_bank";
	locations[n].reload.l8.emerge = "reload1";
	locations[n].reload.l8.autoreload = "0";
	locations[n].reload.l8.label = "Bank";
	//locations[n].reload.l8.disable = 1;
	Locations[n].reload.l8.close_for_night = 1;
	
	n = n + 1;


	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_tavern";
	locations[n].id.label = "StEustatius tavern";
	locations[n].filespath.models = "locations\inside\tavern02\";
	locations[n].image = "loading\Tavern_512.tga";
	locations[n].habitues = 1;
	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "tavern";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].models.always.tavern = "tavern02";
	locations[n].models.always.locators = "tavern02_locators";
	locations[n].models.always.window = "tavern02_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "tavern02_patch";

	//Night
	locations[n].models.night.charactersPatch = "tavern02_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload4";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	//   
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_tavern_upstairs";
	locations[n].id.label = "StEustatius Tavern upstairs";
	locations[n].image = "loading\Tavern_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Tavern_room";
	locations[n].models.always.locators = "Tavern_room_locators";
	locations[n].models.always.tavern = "Tavern_room";
	locations[n].models.always.window = "tavern_room_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Tavern_room_patch";

	//Night
	locations[n].models.night.charactersPatch = "Tavern_room_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_tavern";
	locations[n].reload.l1.emerge = "reload2";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "Tavern";
	locations[n].locators_radius.reload.reload1 = 0.8;
	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_store";
	locations[n].id.label = "StEustatius store";
	locations[n].filespath.models = "locations\inside\Store04\";
	locations[n].image = "loading\Shop_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shop";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].models.always.locators = "Store04_locators";
	locations[n].models.always.store = "Store04";
	locations[n].models.always.window = "store04_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Store04_patch";

	//Night
	locations[n].models.night.charactersPatch = "Store04_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload6";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_bank";
	locations[n].id.label = "StEustatius Bank";
	locations[n].filespath.models = "locations\inside\Bank01\";
	locations[n].image = "loading\Bank_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "house";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].models.always.locators = "Bank01_locators";
	locations[n].models.always.store = "Bank01";
	locations[n].models.always.window = "bank01_windows";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";

	//Day
	locations[n].models.day.charactersPatch = "Bank01_patch";
	
	//Night
	locations[n].models.night.charactersPatch = "Bank01_patch";
	
	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload8";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_Shipyard";
	locations[n].id.label = "StEustatius shipyard";
	locations[n].filespath.models = "locations\inside\Shipyard01\";
	locations[n].image = "loading\Shipyard_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "shipyard";
	locations[n].fastreload = "StEustatius";
	//Models
	
	//Always
	locations[n].models.always.locators = "Shipyard01_locators";
	locations[n].models.always.shipyard = "Shipyard01";
	//Day
	locations[n].models.day.charactersPatch = "Shipyard01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Shipyard01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload5";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

 	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_townhall";
	locations[n].id.label = "StEustatius Townhall";
	locations[n].filespath.models = "locations\inside\Residence02";
	locations[n].image = "loading\Rezidence_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "residence";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].models.always.locators = "Residence02_locators";
	locations[n].models.always.l1 = "Residence02";
	locations[n].models.always.window = "residence02_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	
	//Day
	locations[n].models.day.charactersPatch = "Residence02_patch";
	
	//Night
	locations[n].models.night.charactersPatch = "Residence02_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";
	
	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload3";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);

	n = n + 1;

	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	// 
	//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	locations[n].id = "StEustatius_church";
	locations[n].id.label = "StEustatius Church";
	locations[n].image = "loading\Church_512.tga";

	//Town sack
	locations[n].townsack = "StEustatius";
	Locations[n].lockWeather = "Inside";

	//Sound
	locations[n].type = "church";
	locations[n].fastreload = "StEustatius";
	//Models
	//Always
	locations[n].filespath.models = "locations\inside\Church01";

	locations[n].models.always.locators = "Church01_locators";
	locations[n].models.always.tavern = "Church01";
	locations[n].models.always.window = "church01_window";
	locations[n].models.always.window.tech = "LocationWindows";
	locations[n].models.always.window.level = 50;

	locations[n].models.always.back = "..\inside_back";
	//Day
	locations[n].models.day.charactersPatch = "Church01_patch";

	//Night
	locations[n].models.night.charactersPatch = "Church01_patch";

	//Environment
	locations[n].environment.weather = "true";
	locations[n].environment.sea = "false";

	//Reload map
	locations[n].reload.l1.name = "reload1_back";
	locations[n].reload.l1.go = "StEustatius_town";
	locations[n].reload.l1.emerge = "reload7";
	locations[n].reload.l1.autoreload = "0";
	locations[n].reload.l1.label = "StEustatius";
	LAi_LocationFightDisable(&locations[n], true);
	
	n = n + 1;

	return n;
}
