
void TavernWaitDate(string date)
{
	//Cerez: Disabled time suddenly passing when not staying in tavern
	/*
	int iTime, iAddTime;
	iTime = sti(environment.time);
	if (date == "wait_day")
	{
		if (iTime >= 21) iAddTime = 24 - iTime + 7;
		if (iTime < 7) iAddTime = 7 - iTime;
		StoreDayUpdate();
	}
	else
	{
		if (iTime < 24) iAddtime = 24 - iTime;
	}
	LAi_Fade("", "");
	WaitDate("",0,0,0,iAddtime,5);
	RecalculateJumpTable();
	
	if(sti(environment.date.day) != 7)
	{
		DoQuestCheckDelay("tavern_cituations", 2.0);
	}
	objLandInterface.textinfo.datatext.text = XI_convertString("Date:")+GetDataDay()+" "+XI_ConvertString("target_month_" + GetDataMonth())+" "+GetDataYear();

	bStorm = 0;
	string sCurrentTime = GetDayTime();
	if(sCurrentTime == DAY_TIME_NIGHT || sCurrentTime == DAY_TIME_EVENING)
	{
		SetNextWeather("TwentyTwo Hour");
	}
	if(sCurrentTime == DAY_TIME_MORNING || sCurrentTime == DAY_TIME_DAY)
	{
		SetNextWeather("Seven Hour");
	}
	*/
}

//Cerez: Adjusted to wake at sunrise (7) or when the night falls (20)
void TavernWaitDate2(string date)
{
	int iTime, iAddTime;
	iTime = sti(environment.time);
	if (date == "wait_day")
	{
		if (iTime >= 20) iAddTime = 24 - iTime + 7;
		if (iTime < 6) iAddTime = 7 - iTime;
		StoreDayUpdate();
	}
	else
	{
		if (iTime >= 6 && iTime < 20) iAddTime = 24 - iTime - 4;
	}
	WaitDate("",0,0,0,iAddtime,1);
	RecalculateJumpTable();

	if(sti(environment.date.day) != 7)
	{
		DoQuestCheckDelay("tavern_room_cituations", 2.0);
	}
	objLandInterface.textinfo.datatext.text = XI_convertString("Date:")+GetDataDay()+" "+XI_ConvertString("target_month_" + GetDataMonth())+" "+GetDataYear();

	bStorm = 0;
	string sCurrentTime = GetDayTime();
	if(sCurrentTime == DAY_TIME_NIGHT || sCurrentTime == DAY_TIME_EVENING)
	{
		SetNextWeather("TwentyOne Hour");
	}
	if(sCurrentTime == DAY_TIME_MORNING || sCurrentTime == DAY_TIME_DAY)
	{
		SetNextWeather("Seven Hour");
	}
}

void CheckForTavernRoomSituations()
{
	string sNation;

	object HuntedNations[MAX_NATIONS];
	
	int iCounter = 0;

	for(int i = 0; i < MAX_NATIONS; i++)
	{
		sNation = GetNationNameByType(i);
		if(CheckAttribute(pchar, "bounty."+sNation+".money"))
		{
			if(sti(pchar.bounty.(sNation).money) > 0)
			{
				HuntedNations[iCounter].nation = GetNationTypeByName(Nations[i].name);
				iCounter = iCounter + 1;
			}
		}
	}

	if(iCounter > 0)
	{
		iCounter = rand(iCounter - 1);
		int iNation = sti(HuntedNations[iCounter].nation);
		GenerateLandHanters(pchar, iNation);
	}
}

void CheckForTavernSituations()
{
	//  
	//0 -   
	//1 -   
	//2 -   
	//3 -  
	//4 -  
	//5 -   (       ...)
	
	int iRand = rand(5);

	/*    ,           ..    .
	if(iRand == 3)
	{
		GenerateDrinkFight();
	}
	

	if(iRand == 5)
	{
		GenerateTavernPatrol();
	}
	*/
}

void GenerateTavernPatrol()
{
	string sLocation = pchar.location;
	sLocation = Locations[FindLocation(sLocation)].fastreload;
	int iColony = FindColony(sLocation);

	ref chr;

	int iNation = sti(colonies[iColony].nation);
	int iChar;

	string slai_group, slai_group2;
	
	for (int i = 0; i < 3; i++)
	{
		iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "soldier", MAN, 0, WARRIOR);

		chr = &characters[iChar];
		LAi_NPC_Equip(chr, chr.rank, true, false);

		slai_group = GetNationNameByType(iNation)  + "_citizens";
		slai_group2 = GetNationNameByType(iNation)  + "_soldiers";
		LAi_group_MoveCharacter(chr, slai_group2);
		LAi_group_SetRelation(slai_group, slai_group2, LAI_GROUP_FRIEND);
		
		chr.dialog.filename = "Patrol_dialog.c";
		chr.dialog.currentnode = "first time";
		
		LAi_RemoveLoginTime(chr);

		PlaceCharacter(chr, "quest_locators", "random");
		LAi_SetPatrolType(chr);
	}
}

void GenerateDrinkFight()
{
	string sLocation = pchar.location;
	sLocation = Locations[FindLocation(sLocation)].fastreload;
	int iColony = FindColony(sLocation);

	int iNation = sti(colonies[iColony].nation);
	int iChar = GenerateCharacter(iNation, WITHOUT_SHIP, "citizen", MAN, 0, WARRIOR);
	
	ref chr = &characters[iChar];
	chr.id = "Drink_man";

	LAi_RemoveLoginTime(chr);

	chr.dialog.filename = "Citizen_dialog.c";
	chr.dialog.currentnode = "drink_man";
	PlaceCharacter(chr, "quest_locators", "random");
	LAi_SetActorType(chr);
	LAi_ActorDialog(chr, pchar, "", 5.0, 1.0);

}

void DrinkManLeave()
{
	ref chr = &characters[GetCharacterIndex("Drink_man")];

	LAi_ActorRunToLocation(chr, "reload", "reload1", "none", "goto", "goto1", "", 3.0);
}

void DrinkManDuel()
{
	
	ref chr = &characters[GetCharacterIndex("Drink_man")];

	LAi_ActorRunToLocation(chr, "reload", "reload1", "none", "goto", "goto1", "", 3.0);

	chr.characterlock = 1;
	//   1 .          ...  

	pchar.isduel = 1;

	LAi_NPC_Equip(chr, sti(chr.rank), true, false);

	string sQuest = "duel_timer" + rand(100000);
	string sQuest2 = "duel"+rand(1000000);

	float fHour = GetHour();
	int iDay = 0;
	if(fHour >= 23.0) 
	{
		iDay = 1;
		fHour = 1.0;
	}
	else
	{
		fHour = fHour + 1.0;
	}
	pchar.quest.(sQuest).win_condition.l1 = "Timer";
	pchar.quest.(sQuest).win_condition.l1.date.day = GetAddingDataDay(0, 0, iDay);
	pchar.quest.(sQuest).win_condition.l1.date.month = GetAddingDataMonth(0, 0, iDay);
	pchar.quest.(sQuest).win_condition.l1.date.year = GetAddingDataYear(0, 0, iDay);
	pchar.quest.(sQuest).win_condition.l1.date.hour = fHour;
	pchar.quest.(sQuest).win_condition = "Duel_Timer";
	pchar.quest.(sQuest).duel_quest = sQuest2;

	pchar.quest.(sQuest2).win_condition.l1 = "location";
	pchar.quest.(sQuest2).win_condition.l1.location = "Duel_field";
	pchar.quest.(sQuest2).win_condition = "Prepare_for_duel";
	pchar.quest.(sQuest2).character = chr.id;

	Locations[FindLocation("Duel_field")].fastreload = "";

	string sColony = pchar.location;
	sColony = Locations[FindLocation(sColony)].fastreload;
	Locations[FindLocation("Duel_field")].parentcolony = sColony;

}

void GenerateRobbery()
{
}
